local Carbonite, store = ...
local CreateFrame, hooksecurefunc, getreplacehook = CreateFrame, hooksecurefunc
if CoreToggleAddonFactory then
    CreateFrame, hooksecurefunc, getreplacehook, ToggleCarbonite = CoreToggleAddonFactory(..., {}, function(store)
        store[1][NxFrame] = true
        store[1][NXMiniMapBut] = true
        if NxMapDock then
            store[1][NxMapDock] = nil
        end
        if store.status then
            if Nx.Map.Maps[1].__MMO1 then
                Nx.Opt:NXCmdMMOwnChange(nil, true)
                Nx.Map.Maps[1].__MMO1 = nil
            end
             
        else
            if Nx.Map.Maps[1].MMO1 then
                Nx.Opt:NXCmdMMOwnChange(nil, false)
                Nx.Map.Maps[1].__MMO1 = true
            end            
            WatchFrame:Show()
        end
    end)
end
local L = Carbonite_Strings
local function _TRANS(s) return L[s] end
store.locals = {L, _TRANS, CreateFrame, hooksecurefunc, getreplacehook}
function NxUtilCopyTable(source, target)
    for k,v in next, source do
        if v~=nil then
            if type(v)=="table" then
                if target[k] == nil then target[k] = {} end
                NxUtilCopyTable(v, target[k])
            else
                target[k] = v
            end
        end
    end
end
function NXInit()
	Nx = {}
	local Nx = Nx
	Nx.WebSite = "carboniteaddon.com"
	NXTITLEFULL = NXTITLE
	Nx.VERMAJOR			= 5.041
	Nx.VERMINOR			= .000			
	Nx.BUILD				= 292
	Nx.VERSION			= Nx.VERMAJOR + Nx.VERMINOR / 1000
	Nx.VERSIONDATA			= .02				
	Nx.VERSIONCHAR			= .02				
	Nx.VERSIONCharData	= .4				
	Nx.VERSIONFAV			= .13				
	Nx.VERSIONGATHER		= .75				
	Nx.VERSIONGOPTS		= .102			
	Nx.VERSIONHUDOPTS		= .03				
	Nx.VERSIONINFO			= .24				
	Nx.VERSIONList			= .1				
	Nx.VERSIONQOPTS		= .12				
	Nx.VERSIONSOCIAL		= .2				
	Nx.VERSIONTaxiCap		= .5				
	Nx.VERSIONTRAVEL		= .5				
	Nx.VERSIONWare			= .15				
	Nx.VERSIONWin			= .31				
	Nx.VERSIONTOOLBAR		= .1				
	Nx.VERSIONCAP			= .75				
	Nx.VERSIONVENDORV		= .55				
	Nx.VERSIONTransferData = .1			
	Nx.TXTBLUE			= "|cffc0c0ff"
	Nx.Tick = 0
	NxData = {
		Version = 0,
	}
	
	Nx.Font = {}
	Nx.Skin = {}
	Nx.Window = {}
	Nx.Menu = {}
	Nx.MenuI = {}
	Nx.List = {}
	Nx.DropDown = {}
	Nx.Button = {}
	Nx.EditBox = {}
	Nx.Graph = {}
	Nx.Slider = {}
	Nx.TabBar = {}
	Nx.ToolBar = {}
	
	Nx.Timer = {}
	Nx.Timer.Win = {}
	
	Nx.Help = {}
	Nx.Help.Demo = {}
	Nx.Help.License = {}
	Nx.Help.Ad = {}
	Nx.Proc = {}
	Nx.Script = {}
	Nx.Help.Logo = "Interface\\AddOns\\Carbonite\\Gfx\\Carbonite"
	
	Nx.Opts = {}
	
	Nx.Com = {}
	Nx.Com.List = {}
	
	Nx.Fav = {}
	
	Nx.HUD = {}
	
	Nx.Info = {}
	
	Nx.Map = {}
	Nx.Map.Dock = {}
	Nx.Map.Guide = {}
	
	Nx.Travel = {}
	
	Nx.Quest = {}
	Nx.Quest.List = {}
	Nx.Quest.Watch = {}
	Nx.Quests = {}				
	
	Nx.Warehouse = {}
	
	Nx.Sec = {}
	Nx.I68 = {}
	
	Nx.Title = {}
	Nx.AuctionAssist = {}
	Nx.Combat = {}
	Nx.Social = {}
	Nx.Social.List = {}
	Nx.Social.PunksHUD = {}
	
	Nx.UEvents = {}
	Nx.UEvents.List = {}
	Nx.DebugOn = false
	Nx.NetSendPos = false
	Nx.NetPlyrSendTime = GetTime()
	Nx.GroupMembers = {}
	Nx.Item = {}
	Nx.NXMiniMapBut = {}
	Nx.InfoStats = {}
	
	local ver = GetBuildInfo()
	local v1, v2, v3 = strsplit (".", ver)
	v1 = tonumber (v1) or 0
	v2 = tonumber (v2) or 0
	v3 = tonumber (v3) or 0
	ver = v1 * 10000 + v2 * 100 + v3
	Nx.V30 = true
	if ver < 10000 or ver >= 40003 then		
		Nx.V403 = true
	end
	if ver > 10000 and ver < 50000 then		
		local s = "|cffff2020Carbonite requires WoW 5"
		DEFAULT_CHAT_FRAME:AddMessage (s)
		UIErrorsFrame:AddMessage (s)
		Nx.NXVerOld = true
	end
	
	Nx.TooltipLastDiffNumLines = 0
end
NXInit()
function Nx.slashCommand (txt)
	local UEvents = Nx.UEvents
	Nx.prt (txt)
	local cmd, a1, a2 = strsplit (" ", txt)
	cmd = strlower (cmd)
	a1 = a1 or ""
	a2 = a2 or ""
	if cmd == "" or cmd == "?" or cmd == "help" then
		Nx.prt ("Commands:")
		Nx.prt (" goto [zone] x y  (set map goto)")
		Nx.prt (" gotoadd [zone] x y  (add map goto)")
		Nx.prt (" menu  (open menu)")
		Nx.prt (" note [\"]name[\"] [zone] [x y]  (make map note)")
		Nx.prt (" options  (open options window)")
		Nx.prt (" resetwin  (reset window layouts)")
		Nx.prt (" rl  (reload UI)")
		Nx.prt (" track name  (track the player)")
		Nx.prt (" winpos name x y  (position a window)")
		Nx.prt (" winshow name [0/1]  (toggle or show a window)")
		Nx.prt (" winsize name w h  (size a window)")
	elseif cmd == "goto" then
		local map = Nx.Map:GetMap (1)
		local s = gsub (txt, "goto%s*", "")
		map:SetTargetAtStr (s)
	elseif cmd == "gotoadd" then
		local map = Nx.Map:GetMap (1)
		local s = gsub (txt, "gotoadd%s*", "")
		map:SetTargetAtStr (s, true)
	elseif cmd == "menu" then
		Nx.NXMiniMapBut:OpenMenu()
	elseif cmd == "note" then
		local s = gsub (txt, "note%s*", "")
		Nx.Fav:SetNoteAtStr (s)
	elseif cmd == "options" then
		Nx.Opts:Open()
	elseif cmd == "resetwin" then
		Nx.Window:ResetLayouts()
	elseif cmd == "rl" then
		ReloadUI()
	elseif cmd == "track" then
		if a1 then
			local map = Nx.Map:GetMap (1)
			map.TrackPlyrs[a1] = true
		end
	elseif cmd == "winpos" then
		Nx.Window:ConsolePos (gsub (txt, "winpos%s*", ""))
	elseif cmd == "winshow" then
		Nx.Window:ConsoleShow (gsub (txt, "winshow%s*", ""))
	elseif cmd == "winsize" then
		Nx.Window:ConsoleSize (gsub (txt, "winsize%s*", ""))
	
	elseif cmd == "gatherd" then
		NxData.NXDBGather = not NxData.NXDBGather
	elseif cmd == "herb" then
		UEvents:AddHerb (strtrim (a1 .. " " .. a2))
	elseif cmd == "dbmapmax" then
		NxData.NXDBMapMax = not NxData.NXDBMapMax
	elseif cmd == "mine" then
		UEvents:AddMine (strtrim (a1 .. " " .. a2))
	elseif cmd == "addopen" then
		UEvents:AddOpen (a1, a2)
	elseif cmd == "pro" then
		Nx.Timer:ProfilerDump()
	
	elseif cmd == "c" then
		Nx.Combat:Open()
	elseif cmd == "cap" then
		Nx.CaptureItems()
	elseif cmd == "crash" then
		assert()
	elseif cmd == "com" then
		Nx.Com.List:Open()
	elseif cmd == "comd" then
		NxData.DebugCom = not NxData.DebugCom
		ReloadUI()
	elseif cmd == "comt" then
		Nx.Com:Test (a1, a2)
	elseif cmd == "comver" then
		if NxData.NXVerDebug then			
			Nx.Com:GetUserVer()
		end
	elseif cmd == "d" then
		Nx.DebugOn = not Nx.DebugOn
	elseif cmd == "dock" then
		NxData.DebugDock = not NxData.DebugDock
	elseif cmd == "events" then
		UEvents.List:Open()
	elseif cmd == "g" then
		Nx.Graph:Create (20, 50, UIParent)
		local g2 = Nx.Graph:Create (200, 20, UIParent)
		g2.Frm:SetPoint ("CENTER", 0, 100)
	elseif cmd == "item" then
		local id = format (L"Hitem:%s", a1)
		GameTooltip:SetOwner (UIParent, "ANCHOR_LEFT", 0, 0)
		GameTooltip:SetHyperlink (id)
		local name, iLink, iRarity, lvl, minLvl, type, subType, stackCount, equipLoc, tx = GetItemInfo (id)
		Nx.prt ("Item: %s %s", name or L"nil", iLink or "")
	elseif cmd == "kill" then
		UEvents:AddKill (a1)
	elseif cmd == "loot" then
		Nx.LootOn = not Nx.LootOn
		Nx.prt ("Loot %s", Nx.LootOn and L"On" or L"Off")
	elseif cmd == "mapd" then
		NxData.DebugMap = not NxData.DebugMap
		ReloadUI()
	elseif cmd == "questclr" then
		Nx.Quest:ClearCaptured()
	elseif cmd == "unitc" then
		NxData.DebugUnit = true
		Nx:UnitDCapture()
	elseif cmd == "unitd" then
		NxData.DebugUnit = not NxData.DebugUnit
	elseif cmd == "vehpos" then
		Nx.Map:GetMap (1):VehicleDumpPos()
	else
		Nx.prt ("Unknown command")
	end
end
function Nx:NXOnLoad (frm)
	SlashCmdList["Carbonite"] = Nx.slashCommand
	SLASH_Carbonite1 = "/Carb"
	SLASH_Carbonite2 = "/Nx"
	self.Frm = frm		
	self.TimeLast = 0
	self.ClassColorStrs = Nx.Util_coltrgb2colstr (RAID_CLASS_COLORS)
	self:RegisterEvent ("ADDON_LOADED", Nx.ADDON_LOADED)
	Nx.Timer:Init()
	Nx.CalendarDate = 0		
end
function Nx:ADDON_LOADED (event, arg1, ...)
	if arg1 == NXTITLELOW then
		
		local fact = UnitFactionGroup ("player")
		Nx.PlFactionNum = strsub (fact, 1, 1) == "A" and 0 or 1
		Nx.AirshipType = Nx.PlFactionNum == 0 and "Airship Alliance" or "Airship Horde"
		Nx:InitGlobal()
		local opts = Nx:GetGlobalOpts()
		Nx:prtSetChatFrame()
		if not opts["LoginHideVer"] then
			Nx.prt (NXTITLE.." |cffffffff"..Nx.VERSION.." B"..Nx.BUILD.." "..NXLOADING)
		end
		Nx:LocaleInit()
		Nx:InitEvents()
		Nx.Proc:Init()
		Nx.Opts:Init()
		Nx:UIInit()
		Nx.Item:Init()
		Nx.Help:Init()
		Nx.Title:Init()
		Nx.NXMiniMapBut:Init()
		Nx.Com:Init()
		Nx.HUD:Init()
		Nx.Map:Init()
		Nx:GatherInit()	
		Nx.Map:Open()
		Nx.Fav:Init()		
		Nx.Travel:Init()
		Nx.Info:Init()
		Nx.Quest:Init()
		Nx.Warehouse:Init()
		Nx.Social:Init()
		Nx.Combat:Init()
			Nx.Combat:Open()
		Nx.UEvents:Init()
		Nx.UEvents.List:Open()
		hooksecurefunc ("ShowUIPanel", Nx.ShowUIPanel)
		hooksecurefunc ("HideUIPanel", Nx.HideUIPanel)
		hooksecurefunc ("CloseWindows", Nx.CloseWindows)
		if not opts["LoginHideVer"] then
			Nx.prt (NXLOAD_DONE)
		end
		Nx.Loaded = true
	end
	if Nx.Font.AddonLoaded then
		Nx.Font:AddonLoaded()
	end
end
function Nx:LocaleInit()
	local opts = Nx:GetGlobalOpts()
	local loc = GetLocale()
	if not opts["LoginHideVer"] then
		Nx.prt (" %s", loc)
	end
	if loc ~= "deDE" and loc ~= "frFR" and loc ~= "esES" and loc ~= "esMX" then
		loc = "enUS"
	end
	Nx.Locale = loc
end
function Nx:InitEvents()
	local Com = Nx.Com
	local Guide = Nx.Map.Guide
	local events = {
		"PLAYER_LOGIN", Nx.OnPlayer_login,
		"TIME_PLAYED_MSG", Nx.OnTime_played_msg,
		"UPDATE_MOUSEOVER_UNIT", Nx.OnUpdate_mouseover_unit,
		"PLAYER_REGEN_DISABLED", Nx.OnPlayer_regen_disabled,
		"PLAYER_REGEN_ENABLED", Nx.OnPlayer_regen_enabled,
		"UNIT_SPELLCAST_SENT", Nx.OnUnit_spellcast_sent,
		"UNIT_SPELLCAST_SUCCEEDED", Nx.OnUnit_spellcast_succeeded,
		"UNIT_SPELLCAST_FAILED", Nx.OnUnit_spellcast_interrupted,
		"UNIT_SPELLCAST_INTERRUPTED", Nx.OnUnit_spellcast_interrupted,
		"ZONE_CHANGED_NEW_AREA", Nx.OnZone_changed_new_area,
		"PLAYER_LEVEL_UP", Nx.OnPlayer_level_up,
		"GROUP_ROSTER_UPDATE", Nx.OnParty_members_changed,
		"UPDATE_BATTLEFIELD_SCORE", Nx.OnUpdate_battlefield_score,
		"UPDATE_WORLD_STATES", Nx.OnUpdate_battlefield_score,
		"PLAYER_LEAVING_WORLD", Com.OnEvent,
		"COMBAT_LOG_EVENT_UNFILTERED", Com.OnCombat_log_event_unfiltered,
		"FRIENDLIST_UPDATE", Com.OnFriendguild_update,
		"GUILD_ROSTER_UPDATE", Com.OnFriendguild_update,
		"CHAT_MSG_CHANNEL_JOIN", Com.OnChatEvent,
		"CHAT_MSG_CHANNEL_NOTICE", Com.OnChatEvent,
		"CHAT_MSG_CHANNEL_LEAVE", Com.OnChatEvent,
		"CHAT_MSG_CHANNEL", Com.OnChat_msg_channel,
		"CHAT_MSG_ADDON", Com.OnChat_msg_addon,
		"CHANNEL_ROSTER_UPDATE", Com.OnChannel_roster_update,
		"CHAT_MSG_COMBAT_FACTION_CHANGE", Nx.Quest.OnChat_msg_combat_faction_change,
		"CHAT_MSG_RAID_BOSS_WHISPER", Nx.Quest.OnChat_msg_raid_boss_whisper,
		"CHAT_MSG_BG_SYSTEM_NEUTRAL", Nx.OnChat_msg_bg_system_neutral,
		"AUCTION_HOUSE_SHOW", Nx.AuctionAssist.OnAuction_house_show,
		"AUCTION_HOUSE_CLOSED", Nx.AuctionAssist.OnAuction_house_closed,
		"AUCTION_ITEM_LIST_UPDATE", Nx.AuctionAssist.OnAuction_item_list_update,
		
		"MERCHANT_SHOW", Guide.OnMerchant_show,
		"MERCHANT_UPDATE", Guide.OnMerchant_update,
		"GOSSIP_SHOW", Guide.OnGossip_show,
		"TRAINER_SHOW", Guide.OnTrainer_show,
		"TAXIMAP_OPENED", Nx.Travel.OnTaximap_opened,
		"BAG_UPDATE", Nx.Warehouse.OnBag_update,
		"PLAYERBANKSLOTS_CHANGED", Nx.Warehouse.OnBag_update,
		"PLAYERBANKBAGSLOTS_CHANGED", Nx.Warehouse.OnBag_update,
		"BANKFRAME_OPENED", Nx.Warehouse.OnBankframe_opened,
		"BANKFRAME_CLOSED", Nx.Warehouse.OnBankframe_closed,
		"GUILDBANKFRAME_OPENED", Nx.Warehouse.OnGuildbankframe_opened,
		"GUILDBANKFRAME_CLOSED", Nx.Warehouse.OnGuildbankframe_closed,
		"ITEM_LOCK_CHANGED", Nx.Warehouse.OnItem_lock_changed,
		"MAIL_INBOX_UPDATE", Nx.Warehouse.OnMail_inbox_update,
		"UNIT_INVENTORY_CHANGED", Nx.Warehouse.OnUnit_inventory_changed,
		"MERCHANT_CLOSED", Nx.Warehouse.OnMerchant_closed,
		"LOOT_OPENED", Nx.Warehouse.OnLoot_opened,
		"LOOT_SLOT_CLEARED", Nx.Warehouse.OnLoot_slot_cleared,
		"LOOT_CLOSED", Nx.Warehouse.OnLoot_closed,
		"CHAT_MSG_SKILL", Nx.Warehouse.OnChat_msg_skill,
		"SKILL_LINES_CHANGED", Nx.Warehouse.OnChat_msg_skill,
		"TRADE_SKILL_UPDATE", Nx.Warehouse.OnTrade_skill_update,
	}
	tinsert(events,"ZONE_CHANGED") tinsert(events,Nx.OnZone_changed_new_area);
	tinsert(events,"ZONE_CHANGED_INDOORS") tinsert(events,Nx.OnZone_changed_new_area);
	tinsert(events,"NEW_WMO_CHUNK") tinsert(events,Nx.OnZone_changed_new_area);
	tinsert(events,"CHAT_MSG_SYSTEM") tinsert(events,Nx.Quest.AnnounceQuestResult);
	tinsert(events,"QUEST_ACCEPTED")  tinsert(events,Nx.Quest.AnnounceQuestResult);
	tinsert(events,"QUEST_FINISHED")  tinsert(events,Nx.Quest.AnnounceQuestResult);
	local n = 1
	while events[n] do
		Nx:RegisterEvent (events[n], events[n + 1])
		n = n + 2
	end
end
function Nx:RegisterEvent (event, handler)
	self.Frm:RegisterEvent (event)
	if not self.Events then
		self.Events = {}
	end
	self.Events[event] = handler
end
function Nx:NXOnEvent (event, ...)
	local h = self.Events[event]
	if h then
		h (nil, event, ...)
	else
		assert (0)
	end
end
function Nx:OnPlayer_login (event, ...)
	Nx.OnParty_members_changed()
	Nx:RecordCharacterLogin()
	Nx.Com:OnEvent (event)
	Nx.BlizzChatFrame_DisplayTimePlayed = ChatFrame_DisplayTimePlayed		
	ChatFrame_DisplayTimePlayed = function() end
	RequestTimePlayed()	
	Nx:OnZone_changed_new_area(eve) 
	Nx.Warehouse.OnChat_msg_skill() 
end
function Nx:OnTime_played_msg (event, arg1)
	Nx.Warehouse.TimePlayed = arg1
end
function Nx:OnUpdate_mouseover_unit (event, ...)
	if Nx.Quest.Enabled then
		Nx.Quest:TooltipProcess (true)
	end
	local data, guid, id, typ = Nx:UnitDGet ("mouseover")
	if guid then
		local tip = GameTooltip
		if typ == 0 then
			tip:AddLine (format (L"GUID player %s", strsub (guid, 6)))
		elseif typ == 3 then
			tip:AddLine (format (L"GUID NPC %d", id))
			Nx:UnitDTip()
		elseif typ == 4 then
			tip:AddLine (format (L"GUID pet %s", strsub (guid, 13)))
		end
		tip:AddLine (format (" %s", guid))
		tip:Show()	
	end
end
function Nx:UnitDGet (target)
	if NxData.DebugUnit then
		local guid = UnitGUID (target)
		if guid then
			local id = tonumber (strsub (guid, 7, 10), 16)
			local typ = tonumber (strsub (guid, 5, 5), 16)
			local data = NxData.NXDBUnit or {}
			local ver = 2
			if (data["Ver"] or 0) < ver then
				data = {}
				data["Ver"] = ver
			end
			NxData.NXDBUnit = data
			return data, guid, id, typ
		end
	end
end
function Nx:UnitDCapture()
	local data, guid, id, typ = self:UnitDGet ("target")
	if data and typ == 3 then
		local mid = GetCurrentMapAreaID()
		local plZX, plZY = GetPlayerMapPosition ("player")
		if mid and (plZX > 0 or plZY > 0) then
			local s = data[id] or "0~0~~~~"
			local reactA, reactH, _, _, _, tipStr = strsplit ("~", s)
			data[id] = format ("%s~%s~%s~%s~0~%s", reactA, reactH, mid, self:PackXY (plZX * 100, plZY * 100), tipStr)
			Nx.prt ("UnitDCap: %s, %s, %s", id, plZX * 10000, plZY * 10000)
		else
			Nx.prt ("Unit map error")
		end
	end
end
function Nx:UnitDTip()
	local data, guid, id, typ = self:UnitDGet ("mouseover")
	if data and typ == 3 then
		local midCur = GetCurrentMapAreaID()
		local plZX, plZY = GetPlayerMapPosition ("player")
		if midCur and (plZX > 0 or plZY > 0) then
			local react = UnitReaction ("mouseover", "player")
			local s = data[id]
			local reactA, reactH, mid, xy, dist = strsplit ("~", s or "0~0~~000000~9")
			reactA = reactA or 0
			reactH = reactH or 0
			local x, y = self:UnpackXY (xy)
			if Nx.PlFactionNum == 0 then
				reactA = react
			else
				reactH = react
			end
			dist = tonumber (dist)
			local dcur = 9
			if CheckInteractDistance ("mouseover", 1) then	
				dcur = 2
			end
			if CheckInteractDistance ("mouseover", 3) then	
				dcur = 1
			end
			if dcur <= dist then
				dist = dcur
				mid = midCur
				x = plZX * 100
				y = plZY * 100
			end
			local tipStr = ""
			local tip = GameTooltip
			local textName = "GameTooltipTextLeft"
			for n = 1, tip:NumLines() do
				local s = _G[textName .. n]:GetText()
				if s then
					tipStr = tipStr .. s .. "^"
				end
			end
			data[id] = format ("%s~%s~%s~%s~%s~%s", reactA, reactH, mid, self:PackXY (x, y), dist, tipStr)
			if IsControlKeyDown() then
				Nx.prt ("UnitDTip: %s %s, %d, %d (%d)", id, react or "nil", x * 100 + .5, y * 100 + .5, dist)
			end
			if IsShiftKeyDown() and IsControlKeyDown() and (x > 0 or y > 0) then
				local Map = Nx.Map
				local mapId = Map:GetCurrentMapId()
				local m = Map:GetMap (1)
				local tar = m:SetTargetXY (mapId, x, y, "UnitD " .. id)
		  		tar.Radius = 1
			end
		else
			Nx.prt ("Unit map error")
		end
	end
end
function Nx:OnPlayer_regen_disabled()
	Nx.Social:PreCombatHide()
	Nx.Window:UpdateCombat()
end
function Nx:OnPlayer_regen_enabled()
	Nx.Window:UpdateCombat()
end
function Nx:OnUnit_spellcast_sent (event, arg1, arg2, arg3, arg4)
	if arg1 == "player" then
		local Nx = Nx
		if arg2 == NXlHERBGATHERING then
			Nx.GatherTarget = Nx.TooltipLastText
			if NxData.NXDBGather then
				Nx.prt ("Gather: %s %s", arg2, Nx.GatherTarget or "nil")
			end
			if Nx.GatherTarget then
				Nx.UEvents:AddHerb (Nx.GatherTarget)
				Nx.GatherTarget = nil
			end
		elseif arg2 == NXlMINING then
			Nx.GatherTarget = Nx.TooltipLastText
			if NxData.NXDBGather then
				Nx.prt ("Gather: %s %s", arg2, Nx.GatherTarget)
			end
			if Nx.GatherTarget then
				Nx.UEvents:AddMine (Nx.GatherTarget)
				Nx.GatherTarget = nil
			end
		elseif arg2 == NXlARTIFACTS then
			Nx.UEvents:AddOpen ("Art", arg4)
		elseif arg2 == NXlEXTRACTGAS then
			Nx.UEvents:AddOpen ("Gas", NXlEXTRACTGAS)
		elseif arg2 == NXlOpening or arg2 == NXlOpeningNoText then
			Nx.GatherTarget = Nx.TooltipLastText
			if arg4 == NXlGLOWCAP then
				Nx.UEvents:AddHerb (arg4)
			elseif arg4 == NXlEverfrost then
				Nx.UEvents:AddOpen ("Everfrost", arg4)
			end
		end
	end
end
function Nx:OnUnit_spellcast_succeeded (event, arg1, arg2, arg3)
	if arg1 == "player" then
		if arg2 == NXlOpening or arg2 == NXlOpeningNoText then
			if Nx.GatherTarget then
				Nx.Warehouse.LootTarget = format ("O^%s", Nx.GatherTarget)
				Nx.GatherTarget = nil
			end
		end
	end
end
function Nx:OnUnit_spellcast_interrupted (event, arg1)
	if arg1 == "player" then
		Nx.GatherTarget = nil
		Nx.Warehouse.LootTarget = nil
	end
end
function Nx:OnZone_changed_new_area (event)
    
    
    Nx.CurrAreaID = nil
    Nx.CurrMapID = nil
    Nx.CurrIsMicroDungeon = nil
    Nx.CurrDungeonLevel = nil
    local b, typ = IsInInstance()
    local map = Nx.Map:GetMap(1);
    if not b then
        SetMapToCurrentZone()
        if map.Scale and map.Scale >= 20 then
            map.Scale=Nx._ScaleBeforeInstance and Nx._ScaleBeforeInstance>0 and Nx._ScaleBeforeInstance or 1.5
            map.StepTime=10
        end
        Nx._ScaleBeforeInstance = -1
    else
        if typ~="pvp" then
            Nx._ScaleBeforeInstance = Nx._ScaleBeforeInstance==-1 and map.Scale or Nx._ScaleBeforeInstance or nil 
            SetMapToCurrentZone()
            map:SetInstanceMap(Nx.Map:GetCurrentMapId()) 
            map.InstanceId=false 
            map:Menu_OnShowPlayerZone()
        else
            SetMapToCurrentZone()
        end
    end
	Nx.UEvents:AddInfo (L"Entered")
	Nx.Com:OnEvent (event)
end
function Nx:OnPlayer_level_up (event, arg1)
	Nx.UEvents:AddInfo (format (L"Level %d", arg1))
	Nx.Com:OnPlayer_level_up (event, arg1)
end
function Nx.OnParty_members_changed()
	local self = Nx
	local members = {}
	self.GroupMembers = members
	local memberCnt = MAX_PARTY_MEMBERS
	local unitName = "party"
	if Nx.GetNumRaidMembers() > 0 then
		memberCnt = MAX_RAID_MEMBERS
		unitName = "raid"
	end
	self.GroupType = unitName
	for n = 1, memberCnt do
		local unit = unitName .. n
		local name = UnitName (unit)
		if name then
			members[name] = n
		end
	end
	if Nx.Quest.Enabled then
		Nx.Quest.OnParty_members_changed()
	end
end
function Nx:OnChat_msg_bg_system_neutral (event, arg1, arg2, arg3)
	
	
	
	
	
	
	
	
	
	if Nx.Info then
		local s1, s2, secs
		if strfind (arg1, L"One minute until the Arena") then
			secs = 60
		end
		if strfind (arg1, L"Thirty seconds until the Arena") then
			secs = 30
		end
		if strfind (arg1, L"Fifteen seconds until the Arena") then
			secs = 15
		end
		if not secs then
			s1, s2, secs = strfind (arg1, L" begins? in (%d+) ")
			if not secs then
				s1, s2, secs = strfind (arg1, L"(%d+) minutes? until the battle")
			end
		end
		if secs then
			secs = tonumber (secs)
			if secs then
				if secs <= 3 then	
					secs = secs * 60
				end
				Nx.Info:SetBGStartTime (secs)
			end
		end
	end
end
function Nx:OnUpdate_battlefield_score (event)
	local plName = UnitName ("player")
	local scores = GetNumBattlefieldScores()
	local cb = Nx.Combat
	local show
	for n = 1, scores do
		local name, kbs, hks, deaths, honor, faction, rank, race, class, classCap, damDone, healDone = GetBattlefieldScore (n)
		if name == plName then
			honor = floor (honor)	
			local any = kbs + deaths + hks + honor
			if any > 0 and (cb.KBs ~= kbs or cb.Deaths ~= deaths or cb.HKs ~= hks or cb.Honor ~= honor) then
				cb.KBs = kbs
				cb.Deaths = deaths
				cb.HKs = hks
				cb.Honor = honor
				show = true
			end
			cb.DamDone = damDone
			cb.HealDone = healDone
			break
		end
	end
	local opts = Nx:GetGlobalOpts()
	if show and opts["BGShowStats"] then
		local kbrank = 1
		for n = 1, scores do
			local name, kbs = GetBattlefieldScore (n)
			if name ~= plName then
				if kbs > cb.KBs then
					kbrank = kbrank + 1
				end
			end
		end
		Nx.prt ("%s KB (#%d), %s Deaths, %s HK, %d Bonus", cb.KBs, kbrank, cb.Deaths, cb.HKs, cb.Honor)
	end
end
function Nx:NXOnUpdate (elapsed)
	local Nx = Nx
	if not Nx.Loaded then	
		return
	end
	Nx.Tick = Nx.Tick + 1 if Nx.Tick>32767 then Nx.Tick=0 end
	if Nx.LootOn then
		Nx:LootIt()
	end
	Nx.Timer:OnUpdate (elapsed)
	Nx.Proc:OnUpdate (elapsed)
	
	if not GameTooltip:IsVisible() then
		Nx.TooltipLastDiffText = nil
	end
	local s = GameTooltipTextLeft1:GetText()
	if s then
		if Nx.Tick % 4 == 1 and GameTooltipTextLeft1:IsVisible() and #s > 5 then
			if Nx.TooltipLastDiffText ~= s or Nx.TooltipLastDiffNumLines ~= GameTooltip:NumLines() then
				if Nx.Quest.Enabled then
					Nx.Quest:TooltipProcess()
				end
			end
		end
		Nx.TooltipLastText = s
	end
	if Nx.TooltipOwner then
		if not Nx.TooltipOwner:IsVisible() then
			if GameTooltip:IsOwned (Nx.TooltipOwner) then
				GameTooltip:Hide()
			end
			Nx.TooltipOwner = nil
		end
	end
	
	if self.NetSendPos then
		local t = GetTime()
		if t > self.NetPlyrSendTime then
			local plX, plY = GetPlayerMapPosition ("player")
			if plX > 0 or plY > 0 then
				local s = format (L"Map~%d~%d~%d", plX * 100000000, plY * 100000000, Nx.Map:GetCurrentMapId())
				Nx.prt ("NetSend %s", s)
				Nx.Com:Send ("Z", s)
				self.NetPlyrSendTime = t + 1.5
			end
		end
	end
	local combat = UnitAffectingCombat ("player")
	if Nx.InCombat ~= combat then
		Nx.InCombat = combat
		if not combat and Nx.Info and Nx.Info.NeedDurability then	
			Nx.Warehouse:CaptureInvDurability()
		end
	end
	Nx.Com:OnUpdate (elapsed)
	Nx.Map:MainOnUpdate (elapsed)
	if Nx.Quest.Enabled then
		Nx.Quest:OnUpdate (elapsed)
	end
	if Nx.Tick % 11 == 0 then
		Nx:RecordCharacter()
	end
	Nx.Social.PunksHUD:Update()
	
	Nx.Social:OnUpdate()
end
function Nx:LootIt()
	local b = getglobal ("GossipTitleButton1")
	if b:IsVisible() then
		b:Click()
	end
end
function Nx.ShowUIPanel (frame)
	if frame then
		local opts = Nx:GetGlobalOpts()
		if frame == _G["FriendsFrame"] and opts["SocialEnable"] then
			Nx.Social:ShowUIPanel (frame)
		elseif frame == _G["QuestLogFrame"] and opts["QEnable"] then
			Nx.Quest:ShowUIPanel (frame)
		else
			if not InCombatLockdown() then
				frame:Raise()
			end
		end
	end
end
function Nx.HideUIPanel (frame)
	if frame then
		local opts = Nx:GetGlobalOpts()
		if frame == _G["FriendsFrame"] and opts["SocialEnable"] then
			Nx.Social:HideUIPanel (frame)
		elseif frame == _G["QuestLogFrame"] and opts["QEnable"] then
			Nx.Quest:HideUIPanel (frame)
		end
	end
end
function Nx.CloseWindows()
	if not InCombatLockdown() then
		Nx.Social:HideUIPanel (_G["FriendsFrame"])		
	end
	if Nx:GetGlobalOpts()["QEnable"] then
		Nx.Quest:HideUIPanel (_G["QuestLogFrame"])
	end
end
function Nx:ShowMessage (msg, func1Txt, func1, func2Txt, func2)
	if not msg then return end
	msg = L[msg]
	func1Txt = func1Txt and L[func1Txt] 
	func2Txt = func2Txt and L[func2Txt]
	local pop = StaticPopupDialogs["NxMsg"]
	if not pop then
		pop = {
			["whileDead"] = 1,
			["hideOnEscape"] = 1,
			["timeout"] = 0,
		}
		StaticPopupDialogs["NxMsg"] = pop
	end
	pop["text"] = msg
	pop["button1"] = func1Txt
	pop["OnAccept"] = func1
	pop["button2"] = func2Txt
	pop["OnCancel"] = func2
	StaticPopup_Show ("NxMsg")
end
function Nx:ShowEditBox (msg, val, userData, funcAccept, funcCancel)
    msg = msg and L[msg] 
	local pop = StaticPopupDialogs["NxEdit"]
	if not pop then
		pop = {
			["whileDead"] = 1,
			["hideOnEscape"] = 1,
			["timeout"] = 0,
			["exclusive"] = 1,
			["hasEditBox"] = 1,
		}
		StaticPopupDialogs["NxEdit"] = pop
	end
	pop["maxLetters"] = 110
	pop["text"] = msg
	Nx.ShowEditBoxVal = tostring (val)
	Nx.ShowEditBoxUData = userData
	Nx.ShowEditBoxFunc = funcAccept
	pop["OnAccept"] = function (this)
		if Nx.ShowEditBoxFunc then
			Nx.ShowEditBoxFunc (_G[this:GetName().."EditBox"]:GetText(), Nx.ShowEditBoxUData)
		end
	end
	pop["EditBoxOnEnterPressed"] = function (this)
		if Nx.ShowEditBoxFunc then
			Nx.ShowEditBoxFunc (_G[this:GetParent():GetName().."EditBox"]:GetText(), Nx.ShowEditBoxUData)
		end
		this:GetParent():Hide()
	end
	pop["EditBoxOnEscapePressed"] = function (this)
		this:GetParent():Hide()
	end
	pop["OnShow"] = function (this)
		ChatEdit_FocusActiveWindow()
		local eb = _G[this:GetName().."EditBox"]
		eb:SetFocus()
		eb:SetText (Nx.ShowEditBoxVal)
		eb:HighlightText()
	end
	pop["OnHide"] = function (this)
		_G[this:GetName().."EditBox"]:SetText ("")
	end
	pop["button1"] = ACCEPT
	pop["button2"] = CANCEL
	pop["OnCancel"] = funcCancel
	StaticPopup_Show ("NxEdit")
end
function Nx:ShowMessageTrial()
end
function Nx:FindActiveChatFrameEditBox()
	return ChatEdit_GetActiveWindow()
end
function Nx:GetNumPartyMembers()
	if not IsInRaid() then
		return GetNumGroupMembers()
	end
	return 0
end
function Nx:GetNumRaidMembers()
	if IsInRaid() then
		return GetNumGroupMembers()
	end
	return 0
end
function Nx:Time()
	local tm = time()
	if tm > self.TimeLast then
		self.TimeFrac = 0
	else
		self.TimeFrac = self.TimeFrac + 1
	end
	self.TimeLast = tm
	return tm * 100 + self.TimeFrac
end
function Nx:UnitIsPlusMob (target)
	local c = UnitClassification (target)
	return c == "elite" or c == "rareelite" or c == "worldboss"
end
function Nx:InitGlobal()
	if NxData.Version < Nx.VERSIONDATA then
		if NxData.Version > 0 then
			Nx.prt ("Reset old data %f", NxData.Version)
		end
		NxData = {}
		NxData.Version = Nx.VERSIONDATA
		NxData.Characters = {}  
	end
	if not NxData.NXVer1 then
		NxData.NXVer1 = Nx.VERSION
	end
	Nx:InitCharacter()
	
	
	local opts = NxData.NXGOpts
	if not opts or opts.Version < Nx.VERSIONGOPTS then
		if opts and opts.Version < Nx.VERSIONGOPTS then
			Nx.prt ("Reset old global options %f", opts.Version)
			Nx:ShowMessage (L"Options have been reset for the new version.\nPrivacy or other settings may have changed.", "OK")
		end
		opts = {}
		NxData.NXGOpts = opts
		opts.Version = Nx.VERSIONGOPTS
		Nx.Opts:Reset()
	end
	
	if not opts.NXCleaned then
		opts.NXCleaned = true
		local keep = {
			["Characters"] = 1,
			["NXCap"] = 1,
			["NXFav"] = 1,
			["NXGather"] = 1,
			["NXGOpts"] = 1,
			["NXHUDOpts"] = 1,
			["NXInfo"] = 1,
			["NXQOpts"] = 1,
			["NXSocial"] = 1,
			["NXTravel"] = 1,
			["NXVendorV"] = 1,
			["NXVendorVVersion"] = 1,
			["NXVer1"] = 1,
			["NXVerT"] = 1,
			["NXWare"] = 1,
			["Version"] = 1,
		}
		local cnt = 0
		for k, v in pairs (NxData) do
			if not keep[k] then
				NxData[k] = nil
				cnt = cnt + 1
			end
		end
		if cnt > 0 then
			Nx.prt ("Cleaned %d items", cnt)
		end
	end
	
	local fav = NxData.NXFav
	if not fav or fav.Version < Nx.VERSIONFAV then
		if fav then
			Nx.prt ("Reset old favorite data %f", fav.Version)
		end
		fav = {}
		NxData.NXFav = fav
		fav.Version = Nx.VERSIONFAV
	end
	
	local opts = NxData.NXHUDOpts
	if not opts or opts.Version < Nx.VERSIONHUDOPTS then
		if opts then
			Nx.prt ("Reset old HUD options %f", opts.Version)
		end
		opts = {}
		NxData.NXHUDOpts = opts
		opts.Version = Nx.VERSIONHUDOPTS
	end
	
	local info = NxData.NXInfo
	if not info or info.Version < Nx.VERSIONINFO then
		if info then
			Nx.prt ("Reset old info data %f", info.Version)
		end
		info = {}
		NxData.NXInfo = info
		info.Version = Nx.VERSIONINFO
	end
 	
	local qopts = NxData.NXQOpts
	if not qopts or qopts.Version < Nx.VERSIONQOPTS then
		if qopts then
			Nx.prt ("Reset old quest options %f", qopts.Version)
		end
		qopts = {}
		NxData.NXQOpts = qopts
		qopts.Version = Nx.VERSIONQOPTS
		Nx.Quest:OptsReset()
	end
	
	local soc = NxData.NXSocial
	if not soc or soc.Version < Nx.VERSIONSOCIAL then
		if soc then
			Nx.prt ("Reset old social data %f", soc.Version)
		end
		soc = {}
		NxData.NXSocial = soc
		soc.Version = Nx.VERSIONSOCIAL
	end
	local rn = GetRealmName()
	if not soc[rn] then
		local t = {}
		soc[rn] = t
		t["Pal"] = {}
		t["Pal"][""] = {}		
		t["Pk"] = {}
	end
	soc[rn]["PkAct"] = soc[rn]["PkAct"] or {}
	
	local tr = NxData.NXTravel
	if not tr or tr.Version < Nx.VERSIONTRAVEL then
		if tr then
			Nx.prt ("Reset old travel data %f", tr.Version)
		end
		tr = {}
		NxData.NXTravel = tr
		tr.Version = Nx.VERSIONTRAVEL
	end
	tr["TaxiTime"] = tr["TaxiTime"] or {}
	
	local ware = NxData.NXWare
	if not ware or ware.Version < Nx.VERSIONWare then
		if ware then
			Nx.prt ("Reset old warehouse data %f", ware.Version)
		end
		ware = {}
		NxData.NXWare = ware
		ware.Version = Nx.VERSIONWare
	end
	
	local gath = NxData.NXGather
	if not gath or gath.Version < Nx.VERSIONGATHER then
		if gath and gath.Version < 0 then
			Nx.DoGatherUpgrade = gath.Version
		else
			if gath then
				Nx.prt ("Reset old gather data %f", gath.Version)
			end
			gath = {}
			NxData.NXGather = gath
			gath.NXHerb = {}
			gath.NXMine = {}
		end
		gath.Version = Nx.VERSIONGATHER
	end
	gath["Misc"] = gath["Misc"] or {}
	
	local cap = NxData.NXCap		
	if not cap or cap.Version < Nx.VERSIONCAP then
		cap = {}
		NxData.NXCap = cap
		cap.Version = Nx.VERSIONCAP
		cap["Q"] = {}
	end
	cap["NPC"] = cap["NPC"] or {}
end
function Nx:GetData (name, ch)
	ch = ch or Nx.CurCharacter
	if name == "Events" then
		return ch.E
	elseif name == "List" then
		return ch["L"]
	elseif name == "Quests" then
		return ch.Q
	elseif name == "Win" then
		return ch.W
	elseif name == "Herb" then
		return NxData.NXGather.NXHerb
	elseif name == "Mine" then
		return NxData.NXGather.NXMine
	end
end
function Nx:CopyCharacterData (srcName, dstName)
	if not srcName then
		
		local sch = Nx.CurCharacter
		for rc, dch in pairs (NxData.Characters) do
			if dch ~= sch then
				Nx.Window:CopyLayoutsCheck (sch.W, dch.W)
				dch.W = sch.W
				dch["L"] = sch["L"]
				dch["TBar"] = sch["TBar"]
			end
		end
	else
		local sch = Nx:FindCharacter (srcName)
		local dch = Nx:FindCharacter (dstName)
		if not sch or not dch then
			Nx.prt ("Missing character data!")
			return
		end
		if not Nx.Window:CopyLayoutsCheck (sch.W, dch.W) then
			return
		end
		
		dch.W = sch.W
		dch["L"] = sch["L"]
		dch["TBar"] = sch["TBar"]
	end
	return true
end
function Nx:DeleteCharacterData (srcName)
	self:DeleteCharacter (srcName)
	self:CalcRealmChars()
	self.Warehouse:Update()
end
function Nx:ImportCharacterData()
	local tData = CarboniteTransferData
	if not tData then
		Nx.prtError (L"Carbonite Transfer addon is not loaded")
		return
	end
	local accountName = GetCVar ("accountName")
	if accountName == "" then
		Nx.prtError (L"'Remember Account Name' must be checked")
		return
	end
	local realmName = GetRealmName()
	for aName, aData in pairs (tData) do
		if aName ~= accountName then
			if aData.Version ~= Nx.VERSIONTransferData then
				Nx.prt ("Account %s data has wrong version", aName)
			else
				for rName, rData in pairs (aData) do
					if rName == realmName then
						Nx.prt ("Importing account %s", aName)
						for cName, cData in pairs (rData) do
							local rc = rName .. "." .. cName
							NxData.Characters[rc] = cData
							cData["Account"] = aName			
						end
						aData[rName] = nil
					end
				end
			end
		end
	end
end
function Nx:ExportCharacterData()
	local tData = CarboniteTransferData
	if not tData then
		Nx.prtError (L"Carbonite Transfer addon is not loaded")
		return
	end
	local accountName = GetCVar ("accountName")
	if accountName == "" then
		Nx.prtError (L"'Remember Account Name' must be checked on Login screen")
		return
	end
	Nx.prt ("Exporting account %s data", accountName)
	local realmName = GetRealmName()
	local act = tData[accountName]
	if not act or act.Version < Nx.VERSIONTransferData then
		act = {}
		act.Version = Nx.VERSIONTransferData
	end
	tData[accountName] = act
	local data = {}
	act[realmName] = data
	for cnum, rc in ipairs (Nx.RealmChars) do
		local rname, cname = strsplit (".", rc)
		local ch = NxData.Characters[rc]
		if ch then
			if not ch["Account"] then		
				Nx.prt (" Exporting %s", cname)
				local t = Nx.Util_TCopyRecurse (ch)
				data[cname] = t
				t["E"] = nil
				t["L"] = nil
				t["Q"] = nil
				t["W"] = nil
				t["TBar"] = nil
			end
		end
	end
end
function Nx:GetDataToolBar()
	return Nx.CurCharacter["TBar"]
end
function Nx:GetGlobalOpts()
	return NxData.NXGOpts
end
function Nx:GetFav()
	return NxData.NXFav
end
function Nx:GetHUDOpts()
	return NxData.NXHUDOpts
end
function Nx:GetQuestOpts()
	return NxData.NXQOpts
end
function Nx:GetSocial (typ)
	local rn = GetRealmName()
	return NxData.NXSocial[rn][typ]
end
function Nx:ClearSocial (typ)
	local rn = GetRealmName()
	NxData.NXSocial[rn][typ] = {}
end
function Nx:GetCap()
	return NxData.NXCap
end
function Nx:CaptureFind (t, key)
	assert (type (t) == "table" and key)
	local d = t[key] or {}
	t[key] = d
	return d
end
function Nx:PackXY (x, y)
	x = max (0, min (100, x))
	y = max (0, min (100, y))
	return format ("%03x%03x", x * 40.9 + .5, y * 40.9 + .5)		
end
function Nx:UnpackXY (xy)
	local x = tonumber (strsub (xy, 1, 3), 16) / 40.9
	local y = tonumber (strsub (xy, 4, 6), 16) / 40.9
	return x, y
end
function Nx:InitCharacter()
	local chars = NxData.Characters
	local fullName = self:GetRealmCharName()
	local ch = chars[fullName]
	if not ch or ch.Version < Nx.VERSIONCHAR then
		
		ch = {}
		chars[fullName] = ch
		ch.Version = Nx.VERSIONCHAR
		ch.E = {}	
		ch.Q = {}	
	end
	Nx.CurCharacter = ch
	ch["Opts"] = ch["Opts"] or {}		
	Nx.CharOpts = ch["Opts"]			
	ch["L"] = ch["L"] or {}	
	ch.W = ch.W or {}			
	if not ch["TBar"] then
		ch["TBar"] = {}	
	end
	ch["Profs"] = ch["Profs"] or {}	
	ch["Professions"] = nil				
	self:DeleteOldEvents()
	ch.NXLoggedOnNum = ch.NXLoggedOnNum or 0 + 1
	
	local cd = NxCData
	if not cd or cd.Version < Nx.VERSIONCharData then
		cd = {}
		NxCData = cd
		cd.Version = Nx.VERSIONCharData
		cd["Taxi"] = {}		
	end
	
	self:CalcRealmChars()
end
function Nx:GetRealmCharName()
	return GetRealmName() .. "." .. UnitName ("player")
end
function Nx:CalcRealmChars()
	local chars = NxData.Characters
	local realmName = GetRealmName()
	local fullName = realmName .. "." .. UnitName ("player")
	local t = {}
	for rc, v in pairs (chars) do
		if v ~= Nx.CurCharacter then
			local rname = strsplit (".", rc)
			if rname == realmName then
				tinsert (t, rc)
			end
		end
	end
	sort (t)		
	tinsert (t, 1, fullName)	
	self.RealmChars = t
	
	for cnum, rc in ipairs (self.RealmChars) do
		local ch = chars[rc]
		if ch then
			if ch["XP"] then
				ch["XPMax"] = ch["XPMax"] or 1
				ch["XPRest"] = ch["XPRest"] or 0
				ch["LXP"] = ch["LXP"] or 0
				ch["LXPMax"] = ch["LXPMax"] or 1
				ch["LXPRest"] = ch["LXPRest"] or 0
			end
			ch["TimePlayed"] = ch["TimePlayed"] or 0
		end
	end
end
function Nx:FindCharacter (name)
	for cnum, rc in ipairs (Nx.RealmChars) do
		local ch = NxData.Characters[rc]
		if ch then
			local rname, cname = strsplit (".", rc)
			if cname == name then
				return ch
			end
		end
	end
	return NxData.Characters[name]
end
function Nx:DeleteCharacter (name)
	for cnum, rc in ipairs (Nx.RealmChars) do
		local ch = NxData.Characters[rc]
		if ch then
			local rname, cname = strsplit (".", rc)
			if cname == name then
				NxData.Characters[rc] = nil
				return
			end
		end
	end
	NxData.Characters[name] = nil
end
function Nx:GetUnitClass()
	local _, cls = UnitClass ("player")
	cls = gsub (Nx.Util_CapStr (cls), "Deathknight", "Death Knight")
	return cls
end
function Nx:RecordCharacterLogin()
	local ch = self.CurCharacter
	ch["LTime"] = time()
	ch["LvlTime"] = time()
	ch["LLevel"] = UnitLevel ("player")
	ch["Class"] = Nx:GetUnitClass()
	ch["LMoney"] = GetMoney()
	ch["LXP"] = UnitXP ("player")
	ch["LXPMax"] = UnitXPMax ("player")
	ch["LXPRest"] = GetXPExhaustion() or 0
	local _, arena = GetCurrencyInfo (390)
	local _, honor = GetCurrencyInfo (392)
	ch["LArenaPts"] = arena		
	ch["LHonor"] = honor			
	Nx.Warehouse:GuildRecord()
	Nx:RecordCharacter()
end
function Nx:RecordCharacter()
	local ch = self.CurCharacter
	local map = self.Map:GetMap (1)
	if map.RMapId then
		ch["Pos"] = format ("%d^%f^%f", map.RMapId, map.PlyrRZX, map.PlyrRZY)
	end
	ch["Time"] = time()
	ch["Level"] = UnitLevel ("player")
	if ch["Level"] > ch["LLevel"] then	
		ch["LLevel"] = ch["Level"]
		ch["LvlTime"] = time()
		ch["LXP"] = UnitXP ("player")
		ch["LXPMax"] = UnitXPMax ("player")
		ch["LXPRest"] = GetXPExhaustion() or 0
	end
	ch["Money"] = GetMoney()
	ch["XP"] = UnitXP ("player")
	ch["XPMax"] = UnitXPMax ("player")
	ch["XPRest"] = GetXPExhaustion() or 0
	local _, arena = GetCurrencyInfo (390)
	local _, honor = GetCurrencyInfo (392)
	ch["ArenaPts"] = arena		
	ch["Honor"] = honor			
	if self.Warehouse.TimePlayed then
		ch["TimePlayed"] = self.Warehouse.TimePlayed
		self.Warehouse.TimePlayed = nil
		if Nx.BlizzChatFrame_DisplayTimePlayed then
			ChatFrame_DisplayTimePlayed = Nx.BlizzChatFrame_DisplayTimePlayed		
			Nx.BlizzChatFrame_DisplayTimePlayed = nil
		end
	end
	Nx.InfoStats["ArenaPts"] = ch["ArenaPts"]
	Nx.InfoStats["Honor"] = ch["Honor"]
	Nx.InfoStats["XPRest%"] = ch["XPRest"] / ch["XPMax"] * 100
end
function Nx:DeleteOldEvents()
	for rc, ch in pairs (NxData.Characters) do
		if not ch.E or ch.E["Info"] then		
			ch.E = {}
		end
		self:DeleteOldEvent (ch.E, 60)
	end
end
function Nx:DeleteOldEvent (ev, maxE)
	if #ev > maxE then
		for n = 1, #ev - maxE do
			tremove (ev, 1)
		end
	end
end
function Nx:AddEvent (event, name, time, mapId, x, y, data)
	local ev = Nx.CurCharacter.E
	local s = Nx:PackXY (x, y)
	name = gsub (name, "^", "")
	s = format ("%s^%.0f^%d^%s^%s", event, time, Nx.MapIdToNxzone[mapId] or 0, s, name)
	if data then
		s = s .. "^" .. data
	end
	tinsert (ev, s)
end
function Nx:GetEventMapId (evStr)
	local _, _, map = strsplit ("^", evStr)
	return self.NxzoneToMapId[tonumber (map)] or 0
end
function Nx:UnpackEvent (evStr)
	local typ, tm, map, xy, text, data = strsplit ("^", evStr)
	tm = tonumber (tm)
	map = self.NxzoneToMapId[tonumber (map)] or 0
	local x, y = Nx:UnpackXY (xy)
	return typ, tm, map, x, y, text, data
end
function Nx:AddInfoEvent (name, time, mapId, x, y)
	self:AddEvent ("I", name, time, mapId, x, y)
end
function Nx:AddDeathEvent (name, time, mapId, x, y)
	self:AddEvent ("D", name, time, mapId, x, y)
end
function Nx:AddKillEvent (name, time, mapId, x, y)
	local ev = self.CurCharacter.E
	local kills = 1
	for k, item in ipairs (ev) do
		local typ, tm, mapId, x, y, text = self:UnpackEvent (item)
		if typ == "K" and text == name then
			kills = kills + 1
		end
	end
	self:AddEvent ("K", name, time, mapId, x, y, format ("%d", kills))
end
function Nx:AddHerbEvent (name, time, mapId, x, y)
	self:AddEvent ("H", name, time, mapId, x, y)
end
function Nx:AddMineEvent (name, time, mapId, x, y)
	self:AddEvent ("M", name, time, mapId, x, y)
end
function Nx:GetQuest (qId)
	local quest = Nx.CurCharacter.Q[qId]
	if not quest then
		return
	end
	local s1, s2, status, time = strfind (quest, "(%a)(%d+)")
	return status, time
end
function Nx:SetQuest (qId, qStatus, qTime)
	qTime = qTime or 0
	Nx.CurCharacter.Q[qId] = qStatus .. qTime
end
function Nx.Title:Init()
	local f = CreateFrame ("Frame", nil, UIParent)
	f.NxInst = self
	self.Frm = f
	f:SetFrameStrata ("HIGH")
	f:SetWidth (400)
	f:SetHeight (192)
	local bk = {
		["bgFile"] = "Interface\\Buttons\\White8x8",
		["edgeFile"] = "Interface\\DialogFrame\\UI-DialogBox-Border",
		["tile"] = true,
		["tileSize"] = 16,
		["edgeSize"] = 16,
		["insets"] = { ["left"] = 2, ["right"] = 2, ["top"] = 2, ["bottom"] = 2 }
	}
	f:SetBackdrop (bk)
	f:SetBackdropColor (0, 0, .1, 1)
	local lf = CreateFrame ("Frame", nil, f)
	lf:SetWidth (256)
	lf:SetHeight (128)
	lf:SetPoint ("CENTER", 0, 0)
	local t = lf:CreateTexture()
	t:SetTexture (Nx.Help.Logo)
	t:SetAllPoints (lf)
	lf.texture = t
	for n = 1, 2 do
		local fstr = f:CreateFontString()
		self["NXFStr"..n] = fstr
		fstr:SetFontObject ("GameFontNormal")
		fstr:SetJustifyH ("CENTER")
		fstr:SetPoint ("TOPLEFT", 0, -158 - (n - 1) * 14)
		fstr:SetWidth (400)
		fstr:Show()
	end
	local str
	if Nx.VERMINOR > 0 then
		str = NXTITLEFULL .. L" |cffe0e0ffVersion %.6f Build %d"
	else
		str = NXTITLEFULL .. L" |cffe0e0ffVersion %.3f Build %d"
	end
	str = format (str, Nx.VERSION, Nx.BUILD)
	self.NXFStr1:SetText (str)
	self.NXFStr2:SetText (L"|cffe0e0ffCopyright 2007-2012 Carbon Based Creations, LLC")
	Nx.Proc:New (self, self.TickWait, 40)
end
function Nx.Title:TickWait (proc)
	Nx.Map:StartupZoom()
	Nx.Proc:SetFunc (proc, self.TickWait2)
	return 30
end
function Nx.Title:TickWait2 (proc)
	Nx.Help.License:ShowOnce()
	self.X = 0
	self.Y = GetScreenHeight() * .4
	self.XV = 0
	self.YV = 0
	self.Scale = .8
	self.ScaleTarget = .8
	self.Alpha = 0
	self.AlphaTarget = 1
	local opts = Nx:GetGlobalOpts()
	if opts["TitleSoundOn"] then
		
	end
	Nx.Proc:SetFunc (proc, self.Tick)
end
function Nx.Title:Tick()
	local this = self.Frm
	local opts = Nx:GetGlobalOpts()
	if opts["TitleOff"] then
		this:Hide()
	end
	self.X = self.X + self.XV
	self.Y = self.Y + self.YV
	self.Scale = Nx.Util_StepValue (self.Scale, self.ScaleTarget, .8 / 60)
	this:SetPoint ("CENTER", self.X / self.Scale, self.Y / self.Scale)
	this:SetScale (self.Scale)
	self.Alpha = Nx.Util_StepValue (self.Alpha, self.AlphaTarget, .8 / 60)
	this:SetAlpha (self.Alpha)
	if self.Alpha == 1 then
		local sw = GetScreenWidth() / 2
		local sh = GetScreenHeight() / 2
		self.XV = (sw * .95 - self.X) / 80
		self.YV = (sh * .95 - self.Y) / 80
		self.ScaleTarget = .03
		self.AlphaTarget = 0
		return 1 * 60
	end
	if self.Alpha == 0 then
		this:Hide()
		collectgarbage ("collect")
		return -1	
	end
end
function Nx.AuctionAssist.OnAuction_house_show()
	if IsAddOnLoaded ("Blizzard_AuctionUI") then
		hooksecurefunc ("AuctionFrameBrowse_Update", Nx.AuctionAssist.AuctionFrameBrowse_Update)
		Nx.AuctionAssist:Create()
	end
end
function Nx.AuctionAssist.OnAuction_house_closed()
	local self = Nx.AuctionAssist
	if self.Win then
		self.Win:Show (false)
		self.ItemList:Empty()
	end
end
function Nx.AuctionAssist.OnAuction_item_list_update()
	Nx.AuctionAssist:Update()
end
function Nx.AuctionAssist:Create()
end
function Nx.AuctionAssist:OnListEvent (eventName, sel, val2, click)
	local name = self.List:ItemGetData (sel)
	Nx.prt ("%s", name)
	BrowseName:SetText (name)
	AuctionFrameBrowse_Search()
end
function Nx.AuctionAssist:Update()
end
function Nx.AuctionAssist.AuctionFrameBrowse_Update()
	if not Nx.AuctionShowBOPer then
		return
	end
	local low = 99999999
	local lowName
	local lowIName
	local numBatchAuctions, totalAuctions = GetNumAuctionItems ("list")
	local offset = FauxScrollFrame_GetOffset (BrowseScrollFrame)
	local last = offset + NUM_BROWSE_TO_DISPLAY
	for n = 1, NUM_AUCTION_ITEMS_PER_PAGE do
		local name, texture, count, quality, canUse, level, _, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner = GetAuctionItemInfo ("list", n) 
		local index = n + NUM_AUCTION_ITEMS_PER_PAGE * AuctionFrameBrowse["page"]
		if index > numBatchAuctions + NUM_AUCTION_ITEMS_PER_PAGE * AuctionFrameBrowse["page"] then
			break
		end
		if bidAmount == 0 then
			requiredBid = minBid
		else
			requiredBid = bidAmount + minIncrement
		end
		if requiredBid >= MAXIMUM_BID_PRICE then
			buyoutPrice = requiredBid
		end
		if buyoutPrice > 0 then
			local price1 = floor (buyoutPrice / count)
			if n > offset and n <= last then
				local buttonName = "BrowseButton" .. (n - offset)
				local itemName = _G[buttonName .. "Name"]
				if itemName then
					if price1 < low then
						low = price1
						lowName = name
						lowIName = itemName
					end
					if count > 1 then
						itemName:SetText (format ("%s *", name))
						local color = ITEM_QUALITY_COLORS[quality]
						itemName:SetVertexColor (color.r, color.g, color.b)
						local bf = _G[buttonName.."BuyoutFrameMoney"]
						if bf then
							MoneyFrame_Update (bf:GetName(), price1)
						end
					end
				end
			elseif price1 < low then
				low = price1
				lowName = nil
			end
		end
	end
	if lowName then
		lowIName:SetText (format ("%s * low", lowName))
	end
end
NxCOMBATOPTS_VERSION	= .01
NxCombatOpts = {
	Version = NxCOMBATOPTS_VERSION,
}
function Nx.Combat:Init()
	self.KBs = 0
	self.Deaths = 0
	self.HKs = 0
	self.Honor = 0
	self.DamDone = 0
	self.HealDone = 0
	local o = NxCombatOpts
	o.FrmX = nil
	o.FrmY = nil
	o.Opened = nil
	o.NXOpened = nil
	self.Frm = nil
	self.HitPeak = 1
	self.HitTotal = 0
	self.HitBest = 0
	self.W = 400
	self.H = 80
	self.InCombat = false
	self.AttackerName = "?"
end
function Nx.Combat:Open()
	local win = self.Win
	if win then
		if win:IsShown() then
			win:Show (false)
		else
			win:Show()
		end
		return
	end
	self.EventTable = {
	}
	
	local win = Nx.Window:Create ("NxCombat", nil, nil, nil, nil, nil, true)
	self.Win = win
	win:InitLayoutData (nil, -.7, -.7, -.3, -.06)
	win:CreateButtons (true)
	
	local f = CreateFrame ("Frame", nil, UIParent)
	self.Frm = f
	f.NxCombat = self
	win:Attach (f, 0, 1, 0, 1)
	f:SetScript ("OnEvent", self.OnEvent)
	f:RegisterEvent ("COMBAT_LOG_EVENT_UNFILTERED")
	f:RegisterEvent ("CHAT_MSG_COMBAT_XP_GAIN")
	f:RegisterEvent ("CHAT_MSG_COMBAT_HONOR_GAIN")
	f:RegisterEvent ("CHAT_MSG_LOOT")
	f:RegisterEvent ("PLAYER_REGEN_DISABLED")
	f:RegisterEvent ("PLAYER_REGEN_ENABLED")
	for k, v in pairs (self.EventTable) do
		f:RegisterEvent (k)
	end
	f:RegisterEvent ("PLAYER_DEAD")
	f:SetScript ("OnUpdate", self.OnUpdate)
	f:SetScript ("OnEnter", self.OnEnter)
	f:SetScript ("OnLeave", self.OnEnter)
	f:EnableMouse (true)
	f:SetFrameStrata ("MEDIUM")
	local t = f:CreateTexture()
	t:SetTexture (.2, .2, .2, .5)
	t:SetAllPoints (f)
	f.texture = t
	f:Show()
	self:OpenGraph()
end
function Nx.Combat:OpenGraph()
	self.GraphHits = Nx.Graph:Create (self.W, 50, self.Frm)
	local f = self.GraphHits.MainFrm
	self.Win:Attach (f, 0, 1, 0, 1)
end
function Nx.Combat:OnEvent (event, ...)
	local arg1, arg2, arg3 = select (1, ...)
	local Combat = Nx.Combat
	local UEvents = Nx.UEvents
	local prtD = Nx.prtD
	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local OBJ_AFFILIATION_MINE = 1
		local OBJ_TYPE_PET			= 0x00001000
		local OBJ_TYPE_GUARDIAN		= 0x00002000
		local time, cEvent, _hideCaster, sId, sName, sFlags, sf2, dId, dName, dFlags, df2, a1, a2, a3, a4 = select (1, ...) 
		local pre, mid, post = strsplit ("_", cEvent)
		if not post then
			post = mid
		end
		if bit.band (sFlags, OBJ_AFFILIATION_MINE) > 0 then
			local spellId, spellName, spellSchool
			local i = 12
			if pre ~= "SWING" then
				spellId, spellName, spellSchool = select (12, ...)
				i = 15
			end
			local amount, school, resist, block, absorb, crit = select (i, ...)
			if post == "DAMAGE" then
				local v = amount
				local hitStr = crit and L"|cffff00ffcrit" or L"hit"
				if spellName then
					hitStr = spellName
					if mid == "PERIODIC" then
						hitStr = spellName .. L" dot"
					end
					if crit then
						hitStr = hitStr .. L" |cffff00ffcrit"
					end
				end
				local s = format ("|cff00ff00%s|r %s |cffff0000'%s'|r %d", sName or "?", hitStr, dName, amount)
				if bit.band (sFlags, OBJ_TYPE_PET + OBJ_TYPE_GUARDIAN) > 0 then
					if pre == "SPELL" then
						if crit then
							Combat:SetLine (v, "e0a000", s)
						else
							Combat:SetLine (v, "906000", s)
						end
					else
						if crit then
							Combat:SetLine (v, "e0a0a0", s)
						else
							Combat:SetLine (v, "806060", s)
						end
					end
				else
					if pre == "SPELL" then
						if crit then
							Combat:SetLine (v, "e0e000", s)
						else
							Combat:SetLine (v, "909000", s)
						end
					else
						if crit then
							Combat:SetLine (v, "e0e0e0", s)
						else
							Combat:SetLine (v, "808080", s)
						end
					end
				end
			elseif cEvent == "PARTY_KILL" then
				Combat:SetLine (-1, "e02020", L"Killed " .. dName)
				UEvents:AddKill (dName)
			end
		elseif bit.band (dFlags, OBJ_AFFILIATION_MINE) > 0 then
			if post == "DAMAGE" and sName then
				Combat.AttackerName = sName
			end
		end
	elseif event == "CHAT_MSG_COMBAT_XP_GAIN" then
		local s1, s2, name = strfind (arg1, "gain (%d+) ex")
		if s1 then
			Combat:SetLine (-1, "20e020", arg1)
			UEvents:AddInfo ("+"..name..L" xp")
		end
	elseif event == "CHAT_MSG_COMBAT_HONOR_GAIN" then
		local s1, s2, val = strfind (arg1, "(%d*%.%d+) %aonor")	
		if s1 then
			UEvents:AddHonor ("+".. val ..L" honor")
			return
		end
		local s1, s2, name = strfind (arg1, "(%d+) %aonor")
		if s1 and name ~= "0" then
			UEvents:AddHonor ("+"..name..L" honor")
		end
	elseif event == "CHAT_MSG_LOOT" then
		
		
		
		local s1, s2 = strfind (arg1, "Honor Points%.")	
		if s1 then
			UEvents:AddHonor (L"+1 honor")
			return
		end
		local s1, s2, val = strfind (arg1, "Honor Points x(%d+)")	
		if s1 then
			UEvents:AddHonor ("+" .. val .. L" honor")
			return
		end
	elseif event == "PLAYER_REGEN_DISABLED" then
		Combat:EnterCombat()
	elseif event == "PLAYER_REGEN_ENABLED" then
		Combat.InCombat = false
	elseif event == "PLAYER_DEAD" then
		UEvents:AddDeath (Combat.AttackerName)
	else
		if Combat.EventTable[event] then
			Combat.EventTable[event] (Combat, arg1)
		end
	end
end
function Nx.Combat:OnUpdate (...)
end
function Nx.Combat:OnEnter (motion)
end
function Nx.Combat:EnterCombat (value)
	if not self.InCombat then
		self.InCombat = true
		self.HitPeak = 10
		self.HitTotal = 0
		self.TimeStart = GetTime()
		self.GraphHits:Clear()
		self.GraphHits:SetPeak (self.HitPeak)
	end
end
function Nx.Combat:SetLine (value, colorStr, infoStr)
	self:EnterCombat()
	if value > self.HitPeak then
		self.HitPeak = value
		self.GraphHits:SetPeak (self.HitPeak)
	end
	self.HitTotal = self.HitTotal + value
	if value > self.HitBest then
		self.HitBest = value
	end
	local time = GetTime() - self.TimeStart + .001		
	self.GraphHits:SetLine (time, value, colorStr, infoStr)
	local txt = string.format (L"Hit %3.0f Peak "..self.HitPeak..L" Best "..self.HitBest..L" Total %.0f Time %.2f DPS %.1f", value, self.HitTotal, time, self.HitTotal / time)
	self.Win:SetTitle (txt)
end
function Nx.UEvents:Init()
end
function Nx.UEvents:AddInfo (name)
	local mapId, x, y = self:GetPlyrPos()
	Nx:AddInfoEvent (name, Nx:Time(), mapId, x, y)
	self:UpdateAll()
	return mapId
end
function Nx.UEvents:AddDeath (name)
	local mapId, x, y = self:GetPlyrPos()
	Nx:AddDeathEvent (name, Nx:Time(), mapId, x, y)
	self:UpdateAll()
	if Nx.Map:IsBattleGroundMap (mapId) then
		RequestBattlefieldScoreData()
	end
end
function Nx.UEvents:AddKill (name)
	local mapId, x, y = self:GetPlyrPos()
	Nx:AddKillEvent (name, Nx:Time(), mapId, x, y)
	self:UpdateAll()
end
function Nx.UEvents:AddHonor (name)
	local mapId = self:AddInfo (name)
	if Nx.Map:IsBattleGroundMap (mapId) then
		RequestBattlefieldScoreData()
	end
end
function Nx.UEvents:AddHerb (name)
	local mapId, x, y = self:GetPlyrPos()
	local id = Nx:HerbNameToId (name)
	if id then
		Nx:AddHerbEvent (name, Nx:Time(), mapId, x, y)
		Nx:GatherHerb (id, mapId, x, y)
	end
	self:UpdateAll (true)
end
function Nx.UEvents:AddMine (name)
	local mapId, x, y = self:GetPlyrPos()
	local id = Nx:MineNameToId (name)
	if id then
		Nx:AddMineEvent (name, Nx:Time(), mapId, x, y)
		Nx:GatherMine (id, mapId, x, y)
	end
	self:UpdateAll (true)
end
function Nx.UEvents:AddOpen (typ, name)
	local mapId = self:AddInfo (name)
	local mapId, x, y = self:GetPlyrPos()
	Nx:Gather ("Misc", typ, mapId, x, y)
	self:UpdateAll()
end
function Nx.UEvents:GetPlyrPos()
	local mapId = Nx.Map:GetRealMapId()
	local map = Nx.Map:GetMap (1)
	return mapId, map.PlyrRZX, map.PlyrRZY
end
function Nx.UEvents:UpdateAll (upGuide)
	self:Sort()
	self:UpdateMap (upGuide)
	self.List:Update()
end
function Nx.UEvents.SortCmp (v1, v2)
	local _, tm1 = strsplit ("^", v1)
	local _, tm2 = strsplit ("^", v2)
	return tonumber (tm1) < tonumber (tm2)
end
function Nx.UEvents:Sort()
	sort (Nx.CurCharacter.E, self.SortCmp)		
end
function Nx.UEvents.List:Open()
	local UEvents = Nx.UEvents
	local win = self.Win
	if win then
		if win:IsShown() then
			win:Show (false)
		else
			win:Show()
		end
		return
	end
	
	local win = Nx.Window:Create ("NxEventsList", nil, nil, nil, nil, nil, true)
	self.Win = win
	win:CreateButtons (true)
	win:InitLayoutData (nil, -.75, -.6, -.25, -.1)
	local list = Nx.List:Create (L"Events", 2, -2, 100, 12 * 3, win.Frm)
	self.List = list
	list:ColumnAdd ("Time", 1, 70)
	list:ColumnAdd ("Event", 2, 140)
	list:ColumnAdd ("#", 3, 30, "CENTER")
	list:ColumnAdd ("Position", 4, 500)
	win:Attach (list.Frm, 0, 1, 0, 1)
	UEvents:UpdateAll()
end
function Nx.UEvents.List:Update()
	local Nx = Nx
	local UEvents = Nx.UEvents
	if not self.Win then
		return
	end
	local sorted = Nx.CurCharacter.E
	self.Win:SetTitle (format (L"Events: %d", #sorted))
	local list = self.List
	local isLast = list:IsShowLast()
	list:Empty()
	for k, item in ipairs (sorted) do
		local typ, tm, mapId, x, y, text, data = Nx:UnpackEvent (item)
		list:ItemAdd()
		list:ItemSet (1, date ("%d %H:%M:%S", tm / 100))
		local eStr = text
		if typ == "D" then
			eStr = L"|cffff6060Died! " .. text
		elseif typ == "K" then
			list:ItemSet (3, data)
			eStr = L"|cffff60ffKilled " .. text
		elseif typ == "H" then
			eStr = L"|cff60ff60Picked " .. text
		elseif typ == "M" then
			eStr = L"|cffc0c0c0Mined " .. text
		end
		list:ItemSet (2, eStr)
		local mapName = Nx.Map:IdToName (mapId)
		local str = format ("%s %.0f %.0f", mapName, x, y)
		list:ItemSet (4, str)
	end
	list:Update (isLast)
end
function Nx.UEvents:UpdateMap (upGuide)
	local Nx = Nx
	local Map = Nx.Map
	local mapId = Map:GetCurrentMapId()
	local m = Map:GetMap (1)
	if m then
		if upGuide then
			m.Guide:Update()
		end
		m:InitIconType ("Kill", nil, "Interface\\TargetingFrame\\UI-TargetingFrame-Skull", 16, 16)
		m:InitIconType ("Death", nil, "Interface\\TargetingFrame\\UI-TargetingFrame-Seal", 16, 16)
		local icon
		for k, item in ipairs (Nx.CurCharacter.E) do
			local iMapId = Nx:GetEventMapId (item)
			if iMapId == mapId then
				local typ, _, _, x, y, text = Nx:UnpackEvent (item)
				if typ == "K" then
					icon = m:AddIconPt ("Kill", x, y)
					m:SetIconTip (icon, text)
				elseif typ == "D" then
					icon = m:AddIconPt ("Death", x, y)
					m:SetIconTip (icon, text)
				end
			end
		end
	end
end
Nx.GatherInfo = {
	[" "] = {	
		["Art"] = { 0, "Trade_Archaeology",					"Artifact", "Artifact", "Artifact", "Artifact"	},
		["Everfrost"] = { 0, "spell_shadow_teleport",			NXlEverfrost, NXlEverfrost, NXlEverfrost, NXlEverfrost	},
		["Gas"] = { 0, "inv_gizmo_zapthrottlegascollector",	NXlGas, NXlGas, NXlGas, NXlGas	},
	},
	["H"] = {	
		{ 340, "INV_Misc_Herb_AncientLichen",		"Ancient Lichen",			"Urflechte",								"Lichen ancien",					"Liquen antiguo" },
		{ 220, "INV_Misc_Herb_13",						"Arthas' Tears",			"Arthas\226\128\153 Tr\195\164nen",	"Larmes d'Arthas ",				"L\195\161grimas de Arthas" },
		{ 300, "INV_Misc_Herb_17",						"Black Lotus",				"Schwarzer Lotus",						"Lotus noir",						"Loto negro" },
		{ 235, "INV_Misc_Herb_14",						"Blindweed",				"Blindkraut",								"Aveuglette",						"Carolina" },
		{ 1,   "INV_Misc_Herb_11a",					"Bloodthistle",			"Blutdistel",								"Chardon sanglant",				"Cardo de sangre" },
		{ 70,	 "INV_Misc_Root_01",						"Briarthorn",				"Wilddornrose",							"Eglantine",						"Brezospina" },
		{ 85, "INV_Misc_Herb_01",						"Bruiseweed",				"Beulengras",								"Doulourante",						"Hierba cardenal" },
		{ 270, "INV_Misc_Herb_DreamFoil",			"Dreamfoil",				"Traumblatt",								"Feuiller\195\170ve",			"Hojasue\195\177o" },
		{ 315, "INV_Misc_Herb_Dreamingglory",		"Dreaming Glory",			"Traumwinde",								"Glaurier",							"Gloria de ensue\195\177o" },
		{ 15,	 "INV_Misc_Herb_07",						"Earthroot",				"Erdwurzel",								"Terrestrine",						"Ra\195\173z de tierra" },
		{ 150, "INV_Misc_Herb_12",						"Fadeleaf",					"Blassblatt",								"P\195\162lerette",				"P\195\161lida" },
		{ 300, "INV_Misc_Herb_Felweed",				"Felweed",					"Teufelsgras",								"Gangrelette",						"Hierba vil" },
		{ 205, "INV_Misc_Herb_19",						"Firebloom",				"Feuerbl\195\188te",						"Fleur de feu",					"Flor de Fuego" },
		{ 335, "INV_Misc_Herb_Flamecap",				"Flame Cap",				"Flammenkappe",							"Chapeflamme",						"Copo de llamas" },
		{ 245, "INV_Mushroom_08",						"Ghost Mushroom",			"Geisterpilz",								"Champignon fant\195\180me",	"Champi\195\177\195\179n fantasma" },
		{ 260, "INV_Misc_Herb_SansamRoot",			"Golden Sansam",			"Goldener Sansam",						"Sansam dor\195\169",			"Sansam dorado" },
		{ 150, "INV_Misc_Herb_15",						"Goldthorn",				"Golddorn",									"Dor\195\169pine",				"Espina de oro" },
		{ 105, "INV_Misc_Dust_02",						"Grave Moss",				"Grabmoos",									"Tombeline",						"Musgo de tumba" },
		{ 250, "INV_Misc_Herb_16",						"Gromsblood",				"Gromsblut",								"Gromsang",							"Gromsanguina" },
		{ 270, "INV_Misc_Herb_IceCap",				"Icecap",					"Eiskappe",									"Chapeglace",						"Setelo" },
		{ 160, "INV_Misc_Herb_08",						"Khadgar's Whisker",		"Khadgars Schnurrbart",					"Moustache de Khadgar",			"Mostacho de Khadgar" },
		{ 125, "INV_Misc_Herb_03",						"Kingsblood",				"K\195\182nigsblut",						"Sang-royal",						"Sangrerregia" },
		{ 150, "INV_Misc_Root_02",						"Liferoot",					"Lebenswurz",								"Viet\195\169rule",				"Vidarra\195\173z" },
		{ 50,  "Spell_Shadow_DeathAndDecay",		"Mageroyal",				"Magusk\195\182nigskraut",				"Mage royal",						"Marregal" },
		{ 375, "INV_Misc_Herb_Manathistle",			"Mana Thistle",			"Manadistel",								"Chardon de mana",				"Cardo de man\195\161" },
		{ 280, "INV_Misc_Herb_MountainSilverSage","Mountain Silversage",	"Bergsilbersalbei",						"Sauge-argent des montagnes",	"Salviargenta de monta\195\177a" },
		{ 350, "INV_Misc_Herb_Netherbloom",			"Netherbloom",				"Netherbl\195\188te",					"N\195\169antine",				"Flor abisal" },
		{ 350, "INV_Enchant_DustSoul",				"Netherdust Bush",		"Netherstaubbusch",						"Buisson de pruin\195\169ante","Arbusto de polvo abisal" },
		{ 365, "INV_Misc_Herb_Nightmarevine",		"Nightmare Vine",			"Alptraumranke",							"Cauchemardelle",					"Vid Pesadilla" },
		{ 1,   "INV_Misc_Flower_02",					"Peacebloom",				"Friedensblume",							"Pacifique",						"Flor de paz" },
		{ 285, "inv_misc_herb_plaguebloom",			"Sorrowmoss",				"Trauermoos",								"Chagrinelle",						"Musgopena" },
		{ 210, "INV_Misc_Herb_17",						"Purple Lotus",			"Lila Lotus",								"Lotus pourpre",					"Loto c\195\161rdeno" },
		{ 325, "INV_Misc_Herb_Ragveil",				"Ragveil",					"Zottelkappe",								"Voile-mis\195\168re",			"Velada" },
		{ 1,   "INV_Misc_Herb_10",						"Silverleaf",				"Silberblatt",								"Feuillargent",					"Hojaplata" },
		{ 85,  "INV_Misc_Herb_11",						"Stranglekelp",			"W\195\188rgetang",						"Etouffante",						"Alga estranguladora" },
		{ 230, "INV_Misc_Herb_18",						"Sungrass",					"Sonnengras",								"Soleillette",						"Solea" },
		{ 325, "INV_Misc_Herb_Terrocone",			"Terocone",					"Terozapfen",								"Teroc\195\180ne",				"Teropi\195\177a" },
		{ 115, "INV_Misc_Flower_01",					"Wild Steelbloom",		"Wildstahlblume",							"Aci\195\169rite sauvage",		"Ac\195\169rita salvaje" },
		{ 195, "inv_misc_flower_03",					"Dragon's Teeth",			"Drachenzahn",								"Dents de dragon",				"Dientes de drag\195\179n" },
		{ 1,   "INV_Mushroom_02",						"Glowcap",					"Gl\195\188hkappe",						"Chapeluisant",					"Fluochampi\195\177\195\179n" },
		{ 350, "inv_misc_herb_goldclover",			"Goldclover",				"Goldklee",									"Tr\195\168fle dor\195\169",	"Tr\195\169bol de oro" },
		{ 385, "inv_misc_herb_talandrasrose",		"Talandra's Rose",		"Talandras Rose",							"Rose de Talandra",				"Rosa de Talandra" },
		{ 400, "inv_misc_herb_evergreenmoss",		"Adder's Tongue",			"Schlangenzunge",							"Verp\195\169renne",				"Lengua de v\195\173boris" },
		{ 400, "inv_misc_herb_goldclover",			"Frozen Herb",				"Gefrorenes Kraut",						"Herbe gel\195\169e",			"Hierba de escarcha" },
		{ 375, "inv_misc_herb_tigerlily",			"Tiger Lily",				"Tigerlilie",								"Lys tigr\195\169",				"Lirio atigrado" },
		{ 425, "inv_misc_herb_whispervine",			"Lichbloom",				"Lichbl\195\188te",						"Fleur-de-liche",					"Flor ex\195\161nime" },
		{ 435, "inv_misc_herb_icethorn",				"Icethorn",					"Eisdorn",									"Glac\195\169pine",				"Espina de hielo" },
		{ 450, "inv_misc_herb_frostlotus",			"Frost Lotus",				"Frostlotus",								"Lotus givr\195\169",			"Loto de escarcha" },
		{ 360, "inv_misc_herb_11a",					"Firethorn",				"Feuerdorn",								"Epine de feu",					"Espino de fuego" },
		{ 425, "inv_misc_herb_azsharasveil",		"Azshara's Veil",			"Azsharas Schleier",						"Voile d'Azshara",				"Velo de Azshara" },
		{ 425, "inv_misc_herb_cinderbloom",			"Cinderbloom",				"Aschenbl\195\188te",					"Cendrelle",						"Flor de ceniza" },
		{ 425, "inv_misc_herb_stormvine",			"Stormvine",				"Sturmwinde",								"Vign\195\169tincelle",			"Vi\195\177\aviento" },
		{ 475, "inv_misc_herb_heartblossom",		"Heartblossom",			"Herzbl\195\188te",						"P\195\169tale de c\195\166ur", "Flor de coraz\195\179n" },
		{ 500, "inv_misc_herb_whiptail",				"Whiptail",					"Gertenrohr",								"Fouettine",						"Col\195\161tigo" },
		{ 525, "inv_misc_herb_twilightjasmine",	"Twilight Jasmine",		"Schattenjasmin",							"Jasmin cr\195\169pusculaire","Jazm\195\173n Crepuscular" },
    {600,"inv_misc_herb_foolscap","Fool's Cap","Narrenkappe","Berluette","Flor del inocente"},
    {550,"inv_misc_herb_goldenlotus","Golden Lotus","Goldlotus","Lotus doré","Loto dorado"},
    {500,"inv_misc_herb_jadetealeaf","Green Tea Leaf","Teepflanze","Feuille de thé vert","Hoja de té verde"},
    {525,"inv_misc_herb_rainpoppy","Rain Poppy","Regenmohn","Pavot de pluie","Amapola de lluvia"},
    {575,"inv_misc_herb_shaherb","Sha-Touched Herb","Sha-berührtes Kraut","Plante touchée par les sha","Hierba influenciada por el sha"},
    {545,"inv_misc_herb_silkweed","Silkweed","Seidenkraut","Herbe à soie","Hierba sedosa"},
    {575,"inv_misc_herb_snowlily","Snow Lily","Schneelilie","Lys des neiges","Lirio de las nieves"},
	},
	["M"] = {	
		{ 325,	"INV_Ore_Adamantium",		"Adamantite Deposit",		"Adamantitvorkommen",			"Gisement d'adamantite",			"Dep\195\179sito de adamantita" },
		{ 375,	"INV_Misc_Gem_01",			"Ancient Gem Vein",			"Uralte Edelsteinader",			"Ancien filon de gemmes",			"Fil\195\179n de gemas antiguo" },
		{ 1,		"INV_Ore_Copper_01",			"Copper Vein",					"Kupferader",						"Filon de cuivre",					"Fil\195\179n de cobre" },
		{ 175,	"INV_Ore_Mithril_01",		"Dark Iron Deposit",			"Dunkeleisenvorkommen",			"Gisement de sombrefer",			"Dep\195\179sito de hierro negro" },
		{ 275,	"INV_Ore_FelIron",			"Fel Iron Deposit",			"Teufelseisenvorkommen",		"Gisement de gangrefer",			"Dep\195\179sito de hierro vil" },
		{ 115,	"INV_Ore_Copper_01",			"Gold Vein",					"Goldader",							"Filon d'or",							"Fil\195\179n de oro" },
		{ 50,		"INV_Ore_Thorium_01",		"Incendicite Mineral Vein","Pyrophormineralvorkommen",	"Filon d'incendicite",				"Fil\195\179n de incendicita" },
		{ 150,	"INV_Ore_Mithril_01",		"Indurium Mineral Vein",	"Induriummineralvorkommen",	"Filon d'indurium",					"Fil\195\179n de indurio" },
		{ 100,	"INV_Ore_Iron_01",			"Iron Deposit",				"Eisenvorkommen",					"Gisement de fer",					"Dep\195\179sito de hierro" },
		{ 375,	"INV_Ore_Khorium",			"Khorium Vein",				"Khoriumader",						"Filon de khorium",					"Fil\195\179n de korio" },
		{ 305,	"INV_Stone_15",				"Large Obsidian Chunk",		"Gro\195\159er Obsidianbrocken", "Grand morceau d'obsidienne", "Trozo de obsidiana grande" },
		{ 65,		"INV_Ore_Thorium_01",		"Lesser Bloodstone Deposit", "Geringes Blutsteinvorkommen", "Gisement de pierre de sang inf\195\169rieure", "Dep\195\179sito de sangrita inferior" },
		{ 150,	"INV_Ore_Mithril_02",		"Mithril Deposit",			"Mithrilvorkommen",				"Gisement de mithril",				"Dep\195\179sito de mitril" },
		{ 275,	"INV_Ore_Ethernium_01",		"Nethercite Deposit",		"Netheritvorkommen",				"Gisement de n\195\169anticite", "Dep\195\179sito de abisalita" },
		{ 350,	"INV_Ore_Adamantium",		"Rich Adamantite Deposit",	"Reiches Adamantitvorkommen",	"Riche gisement d'adamantite",	"Dep\195\179sito rico en adamantita" },
		{ 215,	"INV_Ore_Thorium_02",		"Rich Thorium Vein",			"Reiche Thoriumader",			"Riche filon de thorium",			"Fil\195\179n de torio enriquecido" },
		{ 65,		"INV_Stone_16",				"Silver Vein",					"Silberader",						"Filon d'argent",						"Fil\195\179n de plata" },
		{ 305,	"INV_Misc_StoneTablet_01",	"Small Obsidian Chunk",		"Kleiner Obsidianbrocken",		"Petit morceau d'obsidienne",		"Trozo de obsidiana peque\195\177o" },
		{ 200,	"INV_Ore_Thorium_02",		"Small Thorium Vein",		"Kleine Thoriumader",			"Petit filon de thorium",			"Fil\195\179n peque\195\177o de torio" },
		{ 50,		"INV_Ore_Tin_01",				"Tin Vein",						"Zinnader",							"Filon d'\195\169tain",				"Fil\195\179n de esta\195\177o" },
		{ 165,	"INV_Ore_TrueSilver_01",	"Truesilver Deposit",		"Echtsilbervorkommen",			"Gisement de vrai-argent",			"Dep\195\179sito de veraplata" },
		{ 350,	"inv_ore_cobalt",				"Cobalt Deposit",				"Kobaltvorkommen",				"Gisement de cobalt",				"Dep\195\179sito de cobalto" },
		{ 375,	"inv_ore_cobalt",				"Rich Cobalt Deposit",		"Reiches Kobaltvorkommen",		"Riche gisement de cobalt",		"Dep\195\179sito de cobalto rico" },
		{ 400,	"inv_ore_saronite_01",		"Saronite Deposit",			"Saronitvorkommen",				"Gisement de saronite",				"Dep\195\179sito de saronita" },
		{ 425,	"inv_ore_saronite_01",		"Rich Saronite Deposit",	"Reiches Saronitvorkommen",	"Riche gisement de saronite",		"Dep\195\179sito de saronita rico" },
		{ 450,	"inv_ore_platinum_01",		"Titanium Vein",				"Titanader",						"Veine de titane",					"Fil\195\179n de titanio" },
		{ 425,	"item_elementiumore",		"Obsidium Deposit",			"Obsidiumvorkommen",				"Morceau d'obsidium",						"Dep\195\179sito de obsidium" },
		{ 450,	"item_elementiumore",		"Rich Obsidium Deposit",	"Reiches Obsidiumvorkommen",	"Enorme bloc d'obsidienne",				"Dep\195\179sito de obsidium rico" },
		{ 475,	"item_pyriumore",				"Elementium Vein",			"Elementiumader",					"Filon d\195\169l\195\169mentium",		"Fil\195\179n de elementium" },
		{ 500,	"item_pyriumore",				"Rich Elementium Vein",		"Reiche Elementiumader",		"Riche filon d'\195\169l\195\169mentium", "Fil\195\179n de elementium rico" },
		{ 525,	"inv_ore_arcanite_01",		"Pyrite Deposit",				"Pyritvorkommen",					"Gisement de pyrite",						"Dep\195\179sito de pirita" },
		{ 525,	"inv_ore_arcanite_01",		"Rich Pyrite Deposit",		"Reiches Pyritvorkommen",		"Riche gisement de pyrite",				"Dep\195\179sito de pirita rico" },
        { 515, "inv_ore_ghostiron","Ghost Iron Deposit","Geistereisenvorkommen","Gisement d�ectofer","Dep�sito de hierro fantasma"},
		{ 550, "inv_ore_ghostiron","Rich Ghost Iron Deposit","Reiches Geistereisenvorkommen","Riche gisement d�ectofer","Dep�sito de hierro fantasma rico"},
		{ 550, "inv_ore_manticyte","Kyparite Deposit","Kyparitvorkommen","Gisement de kyparite","Dep�sito de kyparita"},
		{ 575, "inv_ore_manticyte","Rich Kyparite Deposit","Reiches Kyparitvorkommen","Riche gisement de kyparite","Dep�sito de kyparita rico"},
		{ 600, "inv_ore_trilliumwhite","Trillium Vein","Trilliumader","Filon de trillium","Fil�n de trillium"},
		{ 600, "INV_Ore_TrilliumWhite","Rich Trillium Vein","Reiche Trilliumader","Riche filon de trillium","Fil�n de trillium enriquecido"},
	}
}
Nx.GatherRemap = {
	["NXHerb"] = {
		[47] = 46,		
	},
	["NXMine"] = {
		[6] = 9,		
		[17] = 20,	
		[23] = 22,	
		[25] = 24,	
		[26] = 24,	
	}
}
function Nx:GatherInit()
	self.GatherLocaleI = 3
	if Nx.Locale == "deDE" then
		self.GatherLocaleI = 4
	elseif Nx.Locale == "frFR" then
		self.GatherLocaleI = 5
	elseif Nx.Locale == "esES" or Nx.Locale == "esMX" then
		self.GatherLocaleI = 6
	end
	if self.DoGatherUpgrade then
		self.DoGatherUpgrade = nil
		Nx:GatherVerUpgrade()
	end
	Nx.GatherVerUpgrade = nil			
	Nx.GatherVerUpgradeType = nil		
end
function Nx:GetGather (typ, id)
	local v = Nx.GatherInfo[typ][id]
	if v then
        local name = v[self.GatherLocaleI]
        name = NXlGatherNames[name] or name
		return name, v[2], v[1]
	end
end
function Nx:HerbNameToId (name)
	local i = self.GatherLocaleI
	for k, v in ipairs (Nx.GatherInfo["H"]) do
		if v[i] == name then
			return k
		end
	end
	if NxData.NXDBGather then
		Nx.prt ("Unknown herb %s", name)
	end
end
function Nx:MineNameToId (name)
	if Nx.Locale == "deDE" then
		name = gsub (name, "Br\195\188hschlammbedecktes ", "")
		if name == "reiches Thoriumvorkommen" then	
			name = "Reiches Thoriumvorkommen"
		end
		if name == "Thoriumvorkommen" then				
			name = "Kleines Thoriumvorkommen"
		end
	elseif Nx.Locale == "frFR" then
		name = gsub (name, " couvert de limon", "")		
		name = gsub (name, " couvert de vase", "")		
		if name == "Filon de thorium" then					
			name = "Petit filon de thorium"
		end
	elseif Nx.Locale == "esES" or Nx.Locale == "esMX" then
		name = gsub (name, " cubierto de moco", "")		
		name = gsub (name, " cubierta de moco", "")		
		if name == "Fil\195\179n de torio" then			
			name = "Fil\195\179n peque\195\177o de torio"
		end
	else
		name = gsub (name, "Ooze Covered ", "")
		if name == "Thorium Vein" then				
			name = "Small Thorium Vein"
		end
	end
	local i = self.GatherLocaleI
	for k, v in ipairs (Nx.GatherInfo["M"]) do
		if v[i] == name then
			return k
		end
	end
	if NxData.NXDBGather then
		Nx.prt ("Unknown ore %s", name)
	end
end
function Nx:GatherVerUpgrade()
	Nx:GatherVerUpgradeType ("NXHerb")
	Nx:GatherVerUpgradeType ("NXMine")
end
function Nx:GatherVerUpgradeType (tName)
end
function Nx:GatherHerb (id, mapId, x, y)
	self:Gather ("NXHerb", id, mapId, x, y)
end
function Nx:GatherMine (id, mapId, x, y)
	self:Gather ("NXMine", id, mapId, x, y)
end
function Nx:Gather (nodeType, id, mapId, x, y)
	local remap = self.GatherRemap[nodeType]
	if remap then
		id = remap[id] or id
	end
	local data = NxData.NXGather[nodeType]
	local zoneT = data[mapId]
	if not zoneT then
		zoneT = {}
		data[mapId] = zoneT
	end
	local maxDist = (5 / Nx.Map:GetWorldZoneScale (mapId)) ^ 2
	local index
	local nodeT = zoneT[id] or {}
	zoneT[id] = nodeT
	for n, node in ipairs (nodeT) do
		local nx = tonumber (strsub (node, 1, 3), 16) / 40.9
		local ny = tonumber (strsub (node, 4, 6), 16) / 40.9
		local dist = (nx - x) ^ 2 + (ny - y) ^ 2
		if dist < maxDist then		
			index = n
			break
		end
	end
	local cnt = 1
	if not index then
		index = #nodeT + 1
	else
		local xy, nCnt = strsplit ("^", nodeT[index])
		local nx = tonumber (strsub (xy, 1, 3), 16) / 40.9
		local ny = tonumber (strsub (xy, 4, 6), 16) / 40.9
		cnt = nCnt + 1
		x = (nx * nCnt + x) / cnt
		y = (ny * nCnt + y) / cnt
	end
	nodeT[index] = format ("%s^%d", Nx:PackXY (x, y), cnt)
end
function Nx:GatherUnpack (item)
	local xy = strsplit ("^", item)
	local x = tonumber (strsub (xy, 1, 3), 16) / 40.9
	local y = tonumber (strsub (xy, 4, 6), 16) / 40.9
	return x, y
end
function Nx:GatherDeleteHerb()
	NxData.NXGather.NXHerb = {}
end
function Nx:GatherDeleteMine()
	NxData.NXGather.NXMine = {}
end
function Nx:GatherDeleteMisc()
	NxData.NXGather["Misc"] = {}
end
function Nx:GatherImportCarbHerb()
	Nx:GatherImportCarb ("NXHerb")
end
function Nx:GatherImportCarbMine()
	Nx:GatherImportCarb ("NXMine")
end
function Nx:GatherImportCarbMisc()
	Nx:GatherImportCarb ("Misc")
end
function Nx:GatherImportCarb (nodeType)
	if not LoadAddOn ("CarboniteNodes") then
		Nx.prt ("CarboniteNodes addon could not be loaded!")
		return
	end
	if not CarboniteNodes then
		Nx.prt ("CarboniteNodes addon is not loaded!")
		return
	end
	local srcT = CarboniteNodes[nodeType]
	if srcT then
		local cnt = 0
		for mapId, zoneT in pairs (srcT) do
			for nodeId, nodeStr in pairs (zoneT) do
				for n = 1, #nodeStr, 6 do
					cnt = cnt + 1
					local nx = tonumber (strsub (nodeStr, n, n + 2), 16) / 40.9
					local ny = tonumber (strsub (nodeStr, n + 3, n + 5), 16) / 40.9
					if nx < .1 or nx > 99.9 or ny < .1 or ny > 99.9 then
					else
						Nx:Gather (nodeType, nodeId, mapId, nx, ny)
					end
				end
			end
		end
		Nx.prt ("Imported %s %s", L[nodeType], cnt)
	end
end
function Nx.Item:Init()
	self.Needed = {}
	self.Asked = {}
end
function Nx.Item:Load (id)
	if self.Asked[id] then	
		if time() - self.Asked[id] > 600 then
			local name = GetItemInfo (id)
			if not name then
				return -1	
			end
		end
		return
	end
	local name, link = GetItemInfo (id)
	if not name then
		if Nx:GetGlobalOpts()["ItemRequest"] then
			if not self.AskedToLoad then
				Nx:ShowMessage (Nx.TXTBLUE..L"Carbonite:\n|cffffff60Data for some items is not available.\nRetrieve data from the server?\n\n|cffff4040May cause a disconnect if an item is not seen on the server yet.", L"Get Data", self.EnableLoadFromServer, L"Cancel", self.DisableLoadFromServer)
				self.AskedToLoad = true
			end
			self.Needed[id] = true
		end
	end
end
function Nx.Item.EnableLoadFromServer()
	local self = Nx.Item
	self.TooltipFrm = CreateFrame ("GameTooltip", "NxTooltipItem", UIParent, "GameTooltipTemplate")
	self.TooltipFrm:SetOwner (UIParent, "ANCHOR_NONE")		
	self.ItemsRequested = 0
	Nx.Timer:Start ("Item", 1, self, self.Timer)
end
function Nx.Item.DisableLoadFromServer()
	local self = Nx.Item
	self.Needed = {}
	self.Load = function() end		
	Nx.Timer:Start ("AskDeleteVV", 0, self, self.AskDeleteVV)
end
function Nx.Item.AskDeleteVV()
	local function func()
			NxData.NXVendorV = nil
			Nx.Map.Guide:UpdateVisitedVendors()
	end
	Nx:ShowMessage (Nx.TXTBLUE..L"Carbonite:\n|cffffff60Delete visited vendor data?\nThis will stop the attempted retrieval of items on login.", L"Delete", func, L"Cancel")
end
function Nx.Item:ShowTooltip (id, compare)
	local id = tostring (id)
	id = strsplit ("^", id)
	if not strfind (id, "item:") then
		if strfind (id, "quest:") then
		else
			id = "item:" .. id .. ":0:0:0:0:0:0:0"		
		end
	end
	GameTooltip:SetHyperlink (id)
	if compare then
		GameTooltip_ShowCompareItem()
	end
end
function Nx.Item:Timer()
	local id = next (self.Needed)
	if id then
		local tip = self.TooltipFrm
		self.Needed[id] = nil
		local name = GetItemInfo (id)
		if name then
			return .01		
		end
		self.Asked[id] = time()
		if not strfind (id, "item:") then
			id = "item:" .. id
		end
		tip:SetHyperlink (id)
		self.ItemsRequested = self.ItemsRequested + 1
		if next (self.Needed) then		
			if not Nx.Timer:IsActive ("ItemDraw") then
				Nx.Timer:Start ("ItemDraw", 10, self, self.DrawTimer)
			end
			return .1
		end
		Nx.Timer:Start ("ItemDraw", 3, self, self.DrawTimer)
	end
	return 2
end
function Nx.Item:DrawTimer()
	if next (self.Needed) then		
		Nx.prt (" %d items retrieved", self.ItemsRequested)
	else
		Nx.prt ("Item retrieval from server complete")
	end
	Nx.Warehouse:Update()
	local g = Nx.Map:GetMap (1).Guide
	g:UpdateVisitedVendors()
	g:Update()
end
function Nx.NXMiniMapBut:Init()
	local opts = Nx:GetGlobalOpts()
	local f = NXMiniMapBut
	if not opts["MapMMButOwn"] then
		f:RegisterForDrag ("LeftButton")
	end
	
	local menu = Nx.Menu:Create (f)
	self.Menu = menu
	menu:AddItem (0, L"Help", self.Menu_OnShowHelp, self)
	menu:AddItem (0, L"Options", self.Menu_OnOptions, self)
	menu:AddItem (0, L"Show Map", self.Menu_OnShowMap, self)
	if not Nx.Free then
		menu:AddItem (0, L"Show Combat Graph", self.Menu_OnShowCombat, self)
		menu:AddItem (0, L"Show Events", self.Menu_OnShowEvents, self)
		local function func()
			Nx.Fav:ToggleShow()
		end
		menu:AddItem (0, L"Show Favorites", func, self)
		if opts["IWinEnable"] then
			local function func()
				Nx.Info:ToggleShow()
			end
			menu:AddItem (0, L"Show Info 1 2", func, self)
		end
		local function func()
			Nx.Warehouse:ToggleShow()
		end
		menu:AddItem (0, L"Show Warehouse", func, self)
		menu:AddItem (0, L"Start Demo", self.Menu_OnStartDemo, self)
		menu:AddItem (0, "", nil, self)
	end
	local item = menu:AddItem (0, L"Show Auction Buyout Per Item", self.Menu_OnShowAuction, self)
	item:SetChecked (false)
	if NxData.DebugCom then
		menu:AddItem (0, "", nil, self)
		menu:AddItem (0, L"Show Com Window", self.Menu_OnShowCom, self)
	end
	if NxData.DebugMap then
		menu:AddItem (0, "", nil, self)
		menu:AddItem (0, L"Toggle Profiling", self.Menu_OnProfiling, self)
	end
	
	NXMiniMapBut:SetClampedToScreen (true)
	
	local ok, var = pcall (GetCVar, "scriptProfile")
	if ok and var ~= "0" then
		Nx:ShowMessage (L"Profiling is on. This decreases game performance. Disable?", L"Disable and Reload", self.ToggleProfiling, L"Cancel")
	end
end
function Nx.NXMiniMapBut:Menu_OnShowHelp()
	Nx.Help:Open()
end
function Nx.NXMiniMapBut:Menu_OnOptions()
	Nx.Opts:Open()
end
function Nx.NXMiniMapBut:Menu_OnStartDemo()
	Nx.Help.Demo:Start()
end
function Nx.NXMiniMapBut:Menu_OnShowMap()
	Nx.Map:ToggleSize()
end
function Nx.NXMiniMapBut:Menu_OnShowCombat()
	Nx.Combat:Open()
end
function Nx.NXMiniMapBut:Menu_OnShowEvents()
	Nx.UEvents.List:Open()
end
function Nx.NXMiniMapBut:Menu_OnHideWatch (item)
	local hide = item:GetChecked()
	Nx.Quest.Watch.Win:Show (not hide)
end
function Nx.NXMiniMapBut:Menu_OnShowAuction (item)
	Nx.AuctionShowBOPer = item:GetChecked()
	if AuctionFrame and AuctionFrame:IsShown() then
		AuctionFrameBrowse_Update()
	end
end
function Nx.NXMiniMapBut:Menu_OnShowCom()
	Nx.Com.List:Open()
end
function Nx.NXMiniMapBut:Menu_OnProfiling()
	Nx:ShowMessage (L"Toggle profiling? Reloads UI", L"Reload", self.ToggleProfiling, L"Cancel")
end
function Nx.NXMiniMapBut:ToggleProfiling()
	RegisterCVar ("scriptProfile")
	local var = GetCVar ("scriptProfile")
	var = var == "0" and "1" or "0"
	SetCVar ("scriptProfile", var)
	ReloadUI()
end
function Nx.NXMiniMapBut:NXOnEnter (frm)
	local gopts = Nx.GetGlobalOpts()
	local mmown = gopts["MapMMButOwn"]
	local tip = GameTooltip
	
	tip:SetOwner (frm, "ANCHOR_LEFT")
	tip:SetText (NXTITLEFULL .. " " .. Nx.VERSION)
	tip:AddLine (Nx.WebSite, .6, .6, 1, 1)
	tip:AddLine(L["w.163.com/163ui"], .6, .6, 1, 1)
	tip:AddLine (L"Left click toggle Map", 1, 1, 1, 1)
	if mmown then
		tip:AddLine (L"Shift left click toggle minimize", 1, 1, 1, 1)
	end
	tip:AddLine (L"Alt left click toggle Watch List", 1, 1, 1, 1)
	tip:AddLine (L"Middle click toggle Guide", 1, 1, 1, 1)
	tip:AddLine (L"Right click for Menu", 1, 1, 1, 1)
	if not mmown then
		tip:AddLine (L"Shift drag to move", 1, 1, 1, 1)
	end
	tip:AppendText ("")
end
function Nx.NXMiniMapBut:NXOnClick (button, down)
	if button == "LeftButton" then
		if IsShiftKeyDown() then
			local opts = Nx:GetGlobalOpts()
			opts["MMButWinMinimize"] = not opts["MMButWinMinimize"]
			Nx.Map.Dock:UpdateOptions()
		elseif IsAltKeyDown() then
			local w = Nx.Quest.Watch.Win
			w:Show (not w:IsShown())
		else
			Nx.Map:ToggleSize (0)
		end
	elseif button == "MiddleButton" then
		Nx.Map:GetMap (1).Guide:ToggleShow()
	else
		self:OpenMenu()
	end
end
function Nx.NXMiniMapBut:OpenMenu()
	if self.Menu then			
		self.Menu:Open()
	end
end
function Nx.NXMiniMapBut:NXOnUpdate (frm)
	
	if frm.NXDrag then
		local mm = _G["Minimap"]
		local x, y = GetCursorPosition()
		local s = mm:GetEffectiveScale()
		self:Move (x / s, y / s)
	end
end
function Nx.NXMiniMapBut:Move (x, y)
	local but = NXMiniMapBut		
	local mm = _G["Minimap"]
	local l = mm:GetLeft() + 70				
	local b = mm:GetBottom() + 70
	x = x - l
	y = y - b
	local ang = atan2 (y, x)
	local r = (x ^ 2 + y ^ 2) ^ .5
	r = max (r, 79)
	r = min (r, 110)
	x = r * cos (ang)
	y = r * sin (ang)	
	but:SetPoint ("TOPLEFT", mm, "TOPLEFT", x + 54, y - 54)
	but:SetUserPlaced (true)
end
