local L, _TRANS, CreateFrame, hooksecurefunc, getreplacehook = unpack((select(2, ...)).locals)
function Nx.Help:Init()
	Nx.Timer:Start ("HelpSC", 5, self, self.StartupCheckTimer)
end
function Nx.Help:StartupCheckTimer()
	if _G["Cartographer3"] then
		Nx.prt ("\n|cffffff00Cartographer 3 may conflict with Carbonite\nThis can cause BLAH! to appear")
	end
end
function Nx.Help:Open()
	local win = self.Win
	if not win then
		self:Create()
		win = self.Win
	end
	win:Show()
end
function Nx.Help:Create()
	
	local win = Nx.Window:Create ("NxHelp", nil, nil, nil, 1)
    win:Show(false);
    win.Show = function() end; 
	self.Win = win
	local frm = win.Frm
	win:CreateButtons (true, true)
	win:InitLayoutData (nil, -.25, -.1, -.5, -.7)
	tinsert (UISpecialFrames, frm:GetName())
	frm:SetToplevel (true)
	local str = Nx.TXTBLUE .. NXTITLEFULL .. " " .. Nx.VERSION .. L"|cffffffff Help"
	win:SetTitle (str)
	
	local listW = 70
	local data = { "Welcome", "Using", "WotLK Help", "Keys", "Map", "5.041", "4.301", "4.3", "4.22", "4.21", "4.2", "4.11", "4.1", "4.034", "4.033", "4.032", "4.031", "4.013", "4.012", "4.011" }
	local list = Nx.List:Create (false, 0, 0, 1, 1, frm)
	self.List = list
	list:SetUser (self, self.OnListEvent)
	win:Attach (list.Frm, 0, listW, 0, 1)
	list:ColumnAdd ("Page", 1, listW)
	for k, str in ipairs (data) do
		list:ItemAdd()
		list:ItemSet (1, _TRANS(str))
	end
	
	local scf = CreateFrame ("ScrollFrame", nil, UIParent)
	self.ScFrm = scf
	win:Attach (scf, listW, 1, 0, 1)
	
	
	local f = CreateFrame ("Frame", nil, UIParent)
	self.Frm = f
	local fstr = f:CreateFontString()
	self.FStr = fstr
	fstr:SetFontObject ("GameFontNormalSmall")
	fstr:SetJustifyH ("LEFT")
	fstr:SetPoint ("TOPLEFT", 0, -6)
	f.NxSetSize = self.OnSetSize
	win:Attach (f, listW, 1, 0, 1)
	scf:SetScrollChild (f)
	self:SetText (1)
end
function Nx.Help:OnSetSize (w, h)
	Nx.Help.FStr:SetWidth (w)
end
function Nx.Help:OnListEvent (eventName, sel, val2)
	if eventName == "select" or eventName == "back" then
		self:SetText (sel)
	end
end
function Nx.Help:SetText (page)
	self.FStr:SetText ("") 
end
function Nx.Help.Demo:Create()
	if self.NXFrm then		
		self.NXFrm:Show()
		return
	end
	local f = CreateFrame ("Frame", "NxDemo", UIParent)
	f.NxInst = self
	self.NXFrm = f
	tinsert (UISpecialFrames, f:GetName())
	f:SetFrameStrata ("DIALOG")
	f:SetWidth (400)
	f:SetHeight (100)
	local t = f:CreateTexture()
	t:SetTexture (.05, .05, .05, .95)
	t:SetAllPoints (f)
	f.texture = t
	local fstr = f:CreateFontString()
	fstr:SetFontObject ("GameFontNormalSmall")
	fstr:SetJustifyH ("CENTER")
	fstr:SetJustifyV ("TOP")
	fstr:SetPoint ("TOPLEFT", 0, -3)
	fstr:SetWidth (400)
	fstr:SetHeight (100)
	fstr:SetText (L"CARBONITE demo. Press escape key to cancel")
	for n = 1, 1 do
		local fstr = f:CreateFontString()
		self["NXFStr"..n] = fstr
		fstr:SetFontObject ("GameFontNormal")
		fstr:SetJustifyH ("CENTER")
		fstr:SetJustifyV ("CENTER")
		fstr:SetPoint ("TOPLEFT", 0, 0)
		fstr:SetWidth (400)
		fstr:SetHeight (100)
	end
end
function Nx.Help.Demo:StartOnce()
	local opts = Nx:GetGlobalOpts()
	if not opts["DemoShown"] then
		opts["DemoShown"] = true
		Nx.Help.Demo:Start (true)
	end
end
function Nx.Help.Demo:Start (quick)
	self:Create()
	self.X = 0
	self.Y = 0
	self.NXXV = 0
	self.NXYV = 0
	self.Scale = 1
	self.ScaleTarget = 1
	self.Alpha = 0
	self.NXAlphaTarget = 1
	local cmds = {
		"Text^NXFStr1^Demo starting...",
		"^240",
		"Text^NXFStr1^The CARBONITE minimap icon can be clicked",
		"^240",
		"Text^NXFStr1^Left click to toggle map\nRight click for menu",
		"^240",
		"Text^NXFStr1^The menu can be used to open the help window",
		"^240",
		"Func^NXOpenHelp",
		"Text^NXFStr1^Read the help to learn the basic features\n\nThe End",
		"^240",
		"Set^NXAlphaTarget^0",
		"Set^NXYV^-2",
		"^240",
	}
	if quick then
		cmds = {
			"Func^NXOpenHelp",
		}
	end
	self.Script = Nx.Script:New (self, cmds)
	Nx.Proc:New (self, self.Tick, 1)
end
function Nx.Help.Demo:NXOpenHelp()
	Nx.Help:Open()
end
function Nx.Help.Demo:Tick()
	local f = self.NXFrm
	local ret = Nx.Script:Tick (self.Script)
	if ret or not f:IsShown() then
		f:Hide()
		return -1
	end
	self.X = self.X + self.NXXV
	self.Y = self.Y + self.NXYV
	self.Scale = Nx.Util_StepValue (self.Scale, self.ScaleTarget, .8 / 60)
	f:SetPoint ("CENTER", self.X / self.Scale, self.Y / self.Scale)
	f:SetScale (self.Scale)
	self.Alpha = Nx.Util_StepValue (self.Alpha, self.NXAlphaTarget, .8 / 120)
	f:SetAlpha (self.Alpha)
end
function Nx.Script:New (data, cmds)
	local script = {}
	script.Data = data
	script.Cmds = cmds
	script.Pos = 1
	script.Delay = 0
	return script
end
function Nx.Script:Tick (script)
	script.Delay = script.Delay - 1
	if script.Delay > 0 then
		return
	end
	local pos = script.Pos
	local cmd = script.Cmds[pos]
	while cmd do
		pos = pos + 1
		local name, a1, a2, a3 = strsplit ("^", cmd)
		if name == "" then	
			script.Delay = tonumber (a1)
			break
		elseif name == "Restart" then
			pos = 1
		elseif name == "Show" then
			script.Data[a1]:Show()
		elseif name == "Hide" then
			script.Data[a1]:Hide()
		elseif name == "Text" then
			script.Data[a1]:SetText (_TRANS(a2))
		elseif name == "Func" then
			script.Data[a1] (script.Data, a2, a3)
		elseif name == "Set" then
			script.Data[a1] = tonumber (a2)
		elseif name == "PosAt" then
		elseif name == "Prt" then
			Nx.prt (a1)
		end
		cmd = script.Cmds[pos]
	end
	if not cmd then
		return true		
	end
	script.Pos = pos
end
function Nx.Proc:Init()
	self.Procs = {}
	self.TimeLeft = 0
end
function Nx.Proc:New (user, func, delay)
	local p = {}
	tinsert (self.Procs, p)
	p.User = user
	p.Func = func
	p.Delay = delay or 1
end
function Nx.Proc:SetFunc (proc, func)
	proc.Func = func
end
function Nx.Proc:OnUpdate (elapsed)
	elapsed = min (elapsed, .2) * 60
	elapsed = elapsed + self.TimeLeft
	while elapsed >= 1 do
		elapsed = elapsed - 1
		local n = 1
		while 1 do
			local p = self.Procs[n]
			if not p then
				break
			end
			local d = p.Delay - 1
			if d <= 0 then
				d = p.Func (p.User, p) or 1
				if d < 0 then						
					tremove (self.Procs, n)		
					n = n - 1						
				end
			end
			p.Delay = d
			n = n + 1
		end
	end
	self.TimeLeft = elapsed
end
function Nx.Help.License:ShowOnce()
	Nx.Sec:Start()
end
function Nx.Help.License:Create()
	self.Top = 0
	
	Nx.Window:ClrSaveData ("NxLic")
	local win = Nx.Window:Create ("NxLic", nil, nil, nil, 1, false)
	self.Win = win
	local frm = win.Frm
	win:InitLayoutData (nil, -.3, -.15, -.4, -.6, 3)
	frm:SetToplevel (true)
	win:SetTitle (Nx.TXTBLUE..NXCarboniteTitle .. Nx.VERSION)
	win:SetBGColor (.1, .1, .1, 0)
	local bk = {
		["bgFile"] = "Interface\\Buttons\\White8x8",
		["edgeFile"] = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border",
		["tile"] = true,
		["tileSize"] = 16,
		["edgeSize"] = 16,
		["insets"] = { ["left"] = 2, ["right"] = 2, ["top"] = 2, ["bottom"] = 2 }
	}
	frm:SetBackdrop (bk)
	frm:SetBackdropColor (.1, .1, .1, 1)
	
	local scf = CreateFrame ("ScrollFrame", nil, UIParent)
	self.ScFrm = scf
	scf.NxInst = self
	scf.NxSetSize = self.OnSetSize
	scf:SetScript ("OnMouseWheel", self.OnMouseWheel)
	scf:EnableMouseWheel (true)
	
	local f = CreateFrame ("Frame", nil, UIParent)
	self.Frm = f
	f:SetPoint ("TOPLEFT", 0, 0)
	f:SetWidth (1)
	f:SetHeight (1)
	local fstr = f:CreateFontString()
	self.FStr = fstr
	fstr:SetFontObject ("GameFontNormal")
	fstr:SetJustifyH ("LEFT")
	fstr:SetPoint ("TOPLEFT", 0, 0)
	f.NxSetSize = self.OnSetSize
	scf:SetScrollChild (f)
	self:SetText (1)
	
	local buta = Nx.Button:Create (f, "Txt64", L"Accept", nil, x, 0, "TOPLEFT", 64, 20, self.OnButAccept, self)
	buta.Frm:SetPoint ("TOPLEFT", self.FStr, "BOTTOMLEFT", 10, 0)
	local butd = Nx.Button:Create (f, "Txt64", L"Decline", nil, x, 0, "TOPLEFT", 64, 20, self.OnButDecline, self)
	butd.Frm:SetPoint ("TOPLEFT", buta.Frm, "TOPRIGHT", 10, 0)
	
	win:Attach (scf, 0, 1, 0, 1)
	
	self.Slider = Nx.Slider:Create (scf, "V", 10, 0)
	self.Slider:SetUser (self, self.OnSlider)
	self.Slider:Set (0, 0, 1700, 100)
	self.Slider:Update()
end
function Nx.Help.License:OnSetSize (w, h)
	local self = Nx.Help.License
	self.Frm:SetPoint ("TOPLEFT", 0, self.Top)
	self.FStr:SetWidth (w - 20)
end
function Nx.Help.License:OnMouseWheel (value)
	value = value * 30
	if IsShiftKeyDown() then
		value = value * 5
	end
	local self = this.NxInst
	self.Top = max (self.Top - value, 0)
	self.Frm:SetPoint ("TOPLEFT", 0, self.Top)
	self.Slider:Set (self.Top)
	self.Slider:Update()
end
function Nx.Help.License:OnSlider (slider, pos)
	self.Top = floor (pos)
	self.Frm:SetPoint ("TOPLEFT", 0, self.Top)
end
function Nx.Help.License:OnButAccept()
	self.Win:Show (false)
	local opts = Nx:GetGlobalOpts()
	opts["LicenseAccept" .. Nx.VERSION] = true
	Nx.Sec:Start()
end
function Nx.Help.License:OnButDecline()
	self.Frm:Hide()
	Nx:ShowMessage (L"|cffff4f4fYou have declined the license agreement:\n\n|rPress the Escape key twice.\nSelect 'Exit Game'.\nDelete your copy of CARBONITE from the AddOns folder.", L"OK", Nx.Help.License.OnCancel, nil, Nx.Help.License.OnCancel)
end
function Nx.Help.License:OnCancel()
	Nx.Help.License.Frm:Show()
end
function Nx.Help.License:SetText()
	local str =
[[
Copyright 2007-2012 Carbon Based Creations, LLC

LICENSE AGREEMENT

Click a button below to "Accept" or "Decline".
]]
	self.FStr:SetText (str)
end
