local L, _TRANS, CreateFrame, hooksecurefunc, getreplacehook = unpack((select(2, ...)).locals)
function Nx.Travel:Init()
	local gopts = Nx.GetGlobalOpts()
	self.GOpts = gopts
	self.OrigTakeTaxiNode = TakeTaxiNode
	TakeTaxiNode = self.TakeTaxiNode		
	local tr = {}
	self.Travel = tr
	for n = 1, Nx.Map.ContCnt do 
		tr[n] = {}
		self:Add ("Flight Master", n)
	end
	self.ColdFlyName = 54197
	self.AzerothFlyName = 90267
	self.FlySkillPandaria=115913
end
function Nx.Travel:Add (typ, cont)
	local tdata = self.Travel[cont]
	local Map = Nx.Map
	local Quest = Nx.Quest
	local hideFac = UnitFactionGroup ("player") == "Horde" and 1 or 2
	if 1 then
		local dataStr = Nx.GuideData[typ][cont] or ""
		for n = 1, #dataStr, 2 do
			local npcI = (strbyte (dataStr, n) - 35) * 221 + (strbyte (dataStr, n + 1) - 35)
			local npcStr = Nx.NPCData[npcI]
			local fac = strbyte (npcStr, 1) - 35
			if fac ~= hideFac then
				local oStr = strsub (npcStr, 2)
				local desc, zone, loc = Quest:UnpackObjective (oStr)
				local name, locName = strsplit ("!", desc)
				if strbyte (oStr, loc) == 32 then  
					local mapId = Map.NxzoneToMapId[zone]
					local x, y = Quest:UnpackLocPtOff (oStr, loc + 1)
					local wx, wy = Map:GetWorldPos (mapId, x, y)
					local node = {}
					node.Name = desc
					node.LocName = locName  
					node.MapId = mapId
					node.WX = wx
					node.WY = wy
					tinsert (tdata, node)
				else
					assert (0)
				end
			end
		end
	end
end
function Nx.Travel.OnTaximap_opened()
	local self = Nx.Travel
	self:CaptureTaxi()
end
function Nx.Travel:CaptureTaxi()
	self.TaxiNameStart = false
	local taxiT = NxCData["Taxi"]
	for n = 1, NumTaxiNodes() do
		local locName = TaxiNodeName (n)
		taxiT[locName] = true
		if TaxiNodeGetType (n) == "CURRENT" then
			self.TaxiNameStart = locName
			if NxData.DebugMap then
				local name = Nx.Map.Guide:FindTaxis (locName)
				Nx.prt ("Taxi current %s (%s)", name or L"nil", locName)
			end
		end
	end
end
function Nx.Travel.TakeTaxiNode (node)
	local self = Nx.Travel
	local map = Nx.Map
	map.TaxiName = TaxiNodeName (node)
	local name, x, y = Nx.Map.Guide:FindTaxis (map.TaxiName)
	map.TaxiX = x
	map.TaxiY = y
	Nx.Map.TaxiETA = false
	local tm = self:TaxiCalcTime (node)
	if tm > 0 and self.TaxiNameStart then
		self.TaxiTimeEnd = GetTime() + tm
		Nx.Timer:Start ("TaxiTime", 1, self, self.TaxiTimer)
	end
	if NxData.DebugMap then
		Nx.prt ("Taxi %s (%s) %.2f secs, node %d, %s %s", name or L"nil", map.TaxiName, tm, node, x or "?", y or "?")
	end
	Nx.Travel.OrigTakeTaxiNode (node)
end
function Nx.Travel:TaxiCalcTime (dest)
	local tm = 0
	local num = NumTaxiNodes()
	if num > 0 then
		TaxiNodeSetCurrent (dest)
		local rCnt = GetNumRoutes (dest)
		for n = 1, rCnt do
			local x = TaxiGetSrcX (dest, n)
			local y = TaxiGetSrcY (dest, n)
			local srcNode = self:TaxiFindNodeFromRouteXY (x, y)
			local x = TaxiGetDestX (dest, n)
			local y = TaxiGetDestY (dest, n)
			local destNode = self:TaxiFindNodeFromRouteXY (x, y)
			if srcNode and destNode then
				local srcName = TaxiNodeName (srcNode)
				local destName = TaxiNodeName (destNode)
				local t = self:TaxiFindConnectionTime (srcName, destName)
				local routeName = srcName .. "#" .. destName
				if t == 0 then
					local tt = NxData.NXTravel["TaxiTime"]
					t = tt[routeName]
					if not t then
						if NxData.DebugMap then
							Nx.prt (" No taxi data %s to %s", srcName, destName)
						end
						if rCnt == 1 then
							self.TaxiSaveName = routeName
						end
						return 0
					end
				end
				tm = tm + t
				if NxData.DebugMap then
					Nx.prt (" #%s %s to %s, %s secs", n, srcName, destName, t)
				end
			end
		end
	end
	return tm
end
function Nx.Travel:TaxiFindNodeFromRouteXY (x, y)
	for n = 1, NumTaxiNodes() do
		local x2, y2 = TaxiNodePosition (n)
		local dist = (x - x2) ^ 2 + (y - y2) ^ 2
		if dist < .000001 then
			return n
		end
	end
end
function Nx.Travel:TaxiFindConnectionTime (srcName, destName)
    do return 0 end
	local Quest = Nx.Quest
	local srcNPCName, x, y = Nx.Map.Guide:FindTaxis (srcName)
	local destNPCName, x, y = Nx.Map.Guide:FindTaxis (destName)
	
	
	
	
	
	
	local conn = Nx.FlightConnection
	for n = 1, #conn, 6 do
		local a1, a2, b1, b2, c1, c2 = strbyte (conn, n, n + 5)
		local i = (a1 - 35) * 221 + a2 - 35
		local npc = Nx.NPCData[i]
		if npc then
			local oStr = strsub (npc, 2)
			local desc, zone, loc = Quest:UnpackObjective (oStr)
			local name = strsplit ("!", desc)
			if name == srcNPCName then
				local i = (b1 - 35) * 221 + b2 - 35
				local npc = Nx.NPCData[i]
				if npc then
					local oStr = strsub (npc, 2)
					local desc, zone, loc = Quest:UnpackObjective (oStr)
					local name = strsplit ("!", desc)
					if name == destNPCName then
						return ((c1 - 35) * 221 + c2 - 35) / 10
					end
				else
					Nx.prt ("Travel: missing dnpc %s %s", destName, i)
				end
			end
		else
			Nx.prt ("Travel: missing snpc %s %s", srcName, i)
		end
	end
	return 0
end
function Nx.Travel:TaxiTimer()
	if UnitOnTaxi ("player") then
		Nx.Map.TaxiETA = max (0, self.TaxiTimeEnd - GetTime())
		return .5
	end
end
function Nx.Travel:TaxiSaveTime (tm)
	if self.TaxiSaveName then		
		NxData.NXTravel["TaxiTime"][self.TaxiSaveName] = tm
		self.TaxiSaveName = false
	end
end
function Nx.Travel:MakePath (tracking, srcMapId, srcX, srcY, dstMapId, dstX, dstY, targetType)
	if not self.GOpts["MapRouteUse"] then
		return
	end
	if UnitOnTaxi ("player") then
		return
	end
	local Map = Nx.Map
	local winfo = Map.MapWorldInfo
	local srcInfo = winfo[srcMapId]
	srcMapId = srcInfo.EntryMId or srcMapId
	local dstInfo = winfo[dstMapId]
	dstMapId = dstInfo.EntryMId or dstMapId
	local x = dstX - srcX
	local y = dstY - srcY
	local tarDist = (x * x + y * y) ^ .5
	if srcMapId == dstMapId and tarDist < 500 / 4.575 then		
		return
	end
	local riding = Nx.Warehouse.SkillRiding
	if IsAltKeyDown() then
		riding = 0
	end
	local cont1 = Map:IdToContZone (srcMapId)
	local cont2 = Map:IdToContZone (dstMapId)
	local lvl = UnitLevel ("player")
	self.FlyingMount = false
	if riding >= 225 then
		if cont1 == 1 or cont1 == 2 or cont1 == 5 then
			self.FlyingMount = IsSpellKnown(self.AzerothFlyName) 
		elseif cont1 == 3 then
			self.FlyingMount = true
		elseif cont1 == 4 then
			self.FlyingMount = IsSpellKnown(self.ColdFlyName) 
        elseif cont1 == 6 then
            self.FlyingMount = IsSpellKnown(self.FlySkillPandaria)            
		end
	end
	
    
	local speed = 2 / 4.5
	if riding < 75 then
		speed = 1 / 4.5
	elseif riding < 150 then
		speed = 1.6 / 4.5
	elseif self.FlyingMount then
		speed = 2.5 / 4.5
	end
	self.Speed = speed
	if cont1 == cont2 then
		if riding >= 300 and self.FlyingMount then	
			return
		end
		self.VisitedMapIds = {}
		local path = {}
		local node1 = {}
		node1.MapId = srcMapId
		node1.X = srcX
		node1.Y = srcY
		tinsert (path, node1)
		local node2 = {}
		node2.MapId = dstMapId
		node2.X = dstX
		node2.Y = dstY
		tinsert (path, node2)
		local watchdog = 10
		repeat
			local nodeCnt = #path
			for n = 1, #path - 1 do
				local node1 = path[n]
				local node2 = path[n + 1]
				if not node1.NoSplit then
					if node1.MapId ~= node2.MapId then
						local conDist, con = self:FindConnection (node1.MapId, node1.X, node1.Y, node2.MapId, node2.X, node2.Y)
						local flyDist, fpath = self:FindFlight (node1.MapId, node1.X, node1.Y, node2.MapId, node2.X, node2.Y)
						if conDist and (not fpath or conDist < flyDist) then
							if con then
								local ang1 = math.deg (math.atan2 (srcX - con.StartX, srcY - con.StartY))
								local ang2 = math.deg (math.atan2 (srcX - con.EndX, srcY - con.EndY))
								local ang = abs (ang1 - ang2)
								ang = ang > 180 and 360 - ang or ang
								if con.StartMapId ~= node1.MapId then	
									node1.NoSplit = true
								end
								local name = format (L"Connection: %s to %s", Nx.MapIdToName[con.StartMapId], Nx.MapIdToName[con.EndMapId])
								local node = {}
								node.NoSplit = true
								node.MapId = con.StartMapId
								node.X = con.StartX
								node.Y = con.StartY
								node.Name = name
								node.Tex = "Interface\\Icons\\Spell_Nature_FarSight"
								tinsert (path, n + 1, node)
								self.VisitedMapIds[con.StartMapId] = true
								if ang > 90 then
									node.Die = true
								end
								local node = {}
								node.MapId = con.EndMapId
								node.X = con.EndX
								node.Y = con.EndY
								node.Name = name
								node.Tex = "Interface\\Icons\\Spell_Nature_FarSight"
								tinsert (path, n + 2, node)
							end
						else
							if fpath then
								tinsert (path, n + 1, fpath[1])
								tinsert (path, n + 2, fpath[2])
							end
						end
					else
						local directDist = ((node1.X - node2.X) ^ 2 + (node1.Y - node2.Y) ^ 2) ^ .5		
						local flyDist, fpath = self:FindFlight (node1.MapId, node1.X, node1.Y, node2.MapId, node2.X, node2.Y)
						if fpath and flyDist < directDist then
							tinsert (path, n + 1, fpath[1])
							tinsert (path, n + 2, fpath[2])
						end
					end
				end
			end
			watchdog = watchdog - 1
			if watchdog < 0 then
				break
			end
		until nodeCnt == #path
		
		for n = 2, #path - 1 do
			local node1 = path[n]
			if not node1.Die then
				local x, y = node1.X, node1.Y
				local t1 = {}
				t1.TargetType = targetType
				t1.TargetX1 = x
				t1.TargetY1 = y
				t1.TargetX2 = x
				t1.TargetY2 = y
				t1.TargetMX = x
				t1.TargetMY = y
				t1.TargetTex = node1.Tex
				t1.TargetName = node1.Name
				if node1.Flight then
					t1.Mode = "F"
				end
				tinsert (tracking, t1)
			end
		end
	end
end
function Nx.Travel:FindFlight (srcMapId, srcX, srcY, dstMapId, dstX, dstY)
	local t1Dist, t1Node, t1tex = self:FindClosest (srcMapId, srcX, srcY)
	if t1Node then
		local speed = self.Speed
		local t1Name = t1Node.Name
		local t1x, t1y = t1Node.WX, t1Node.WY
		local bt2Node
		local bestDist = 9999999999
		local distX = dstX - srcX
		local distY = dstY - srcY
		for per = 0, .5, .2 do
			local dx = dstX - distX * per		
			local dy = dstY - distY * per
			local t2Dist, t2Node, t2tex = self:FindClosest (dstMapId, dx, dy)
			if t2Node then
				if t1Name == t2Node.Name then	
					break
				end
				local t2x, t2y = t2Node.WX, t2Node.WY
				local fltDist = ((t1x - t2x) ^ 2 + (t1y - t2y) ^ 2) ^ .5 * speed
				t2Dist = ((dstX - t2x) ^ 2 + (dstY - t2y) ^ 2) ^ .5	
				local travelDist = t1Dist + fltDist + t2Dist
				if bestDist > travelDist then
					bestDist = travelDist
					bt2Node = t2Node
				end
			end
		end
		if not bt2Node then
			return
		end
		local path = {}
		local name = format (L"Fly: %s to %s", gsub (t1Node.Name, ".+!", ""), gsub (bt2Node.Name, ".+!", "")) 
		local node1 = {}
		node1.NoSplit = true
		node1.MapId = t1Node.MapId
		node1.X = t1x
		node1.Y = t1y
		node1.Name = name
		node1.Tex = "Interface\\Icons\\Ability_Mount_Wyvern_01"
		tinsert (path, node1)
		local node2 = {}
		node2.Flight = true
		node2.MapId = bt2Node.MapId
		node2.X = bt2Node.WX
		node2.Y = bt2Node.WY
		node2.Name = name
		node2.Tex = "Interface\\Icons\\Ability_Mount_Wyvern_01"
		tinsert (path, node2)
		return bestDist, path
	end
end
function Nx.Travel:FindClosest (mapId, posX, posY)
	local Quest = Nx.Quest
	local Map = Nx.Map
	local cont = Map:IdToContZone (mapId)
	local tr = self.Travel[cont]
	if not tr then		
		return
	end
	local taxiT = NxCData["Taxi"]
	local closeNode
	local closeDist = 9000111222333444
	for n, node in ipairs (tr) do
		if taxiT[node.LocName] then
			local dist
			if mapId == node.MapId then
				dist = (node.WX - posX) ^ 2 + (node.WY - posY) ^ 2
			else
				dist = self:FindConnection (mapId, posX, posY, node.MapId, node.WX, node.WY)
				if not dist then
					dist = 9900111222333444
				else
					dist = dist ^ 2
				end
			end
			if dist < closeDist then
				closeDist = dist
				closeNode = node
			end
		end
	end
	if closeNode then
		local tex = "Interface\\Icons\\Ability_Mount_Wyvern_01"
		return closeDist ^ .5, closeNode, tex
	end
end
function Nx.Travel:FindConnection (srcMapId, srcX, srcY, dstMapId, dstX, dstY, skipIndirect)
	if self.FlyingMount then		
		return ((srcX - dstX) ^ 2 + (srcY - dstY) ^ 2) ^ .5	
	end
	local winfo = Nx.Map.MapWorldInfo
	local srcT = winfo[srcMapId]
	if not srcT or not srcT.Connections then
		return
	end
	local zcon = srcT.Connections[dstMapId]
	if zcon and not self.VisitedMapIds[dstMapId] then
		if #zcon == 0 then
			return ((srcX - dstX) ^ 2 + (srcY - dstY) ^ 2) ^ .5	
		end
		local closeCon
		local closeDist = 9000111222333444
		for n, con in ipairs (zcon) do
			local dist1 = ((con.StartX - srcX) ^ 2 + (con.StartY - srcY) ^ 2) ^ .5
			local dist2 = ((con.EndX - dstX) ^ 2 + (con.EndY - dstY) ^ 2) ^ .5
			local d = dist1 + con.Dist + dist2
			if d < closeDist then
				closeCon = con
				closeDist = d
			end
		end
		return closeDist, closeCon
	elseif not skipIndirect then	
		local closeCon
		local closeDist = 9000111222333444
		for mapId, zcon in pairs (srcT.Connections) do
			if not self.VisitedMapIds[mapId] then
				if #zcon == 0 then
					local d, con = self:FindConnection (mapId, srcX, srcY, dstMapId, dstX, dstY, true)
					if d and d < closeDist then
						closeDist = d
						closeCon = con
					end
				else
					for n, con in ipairs (zcon) do
						local dist1 = ((con.StartX - srcX) ^ 2 + (con.StartY - srcY) ^ 2) ^ .5
						local dist2 = ((con.EndX - dstX) ^ 2 + (con.EndY - dstY) ^ 2) ^ .5
						local penalty = winfo[mapId].Connections[dstMapId] and 1 or 2
						local d = dist1 + con.Dist + dist2 * penalty	
						if d < closeDist then
							closeDist = d
							closeCon = con
						end
					end
				end
			end
		end
		if closeCon then
			local d, con = self:FindConnection (closeCon.EndMapId, closeCon.EndX, closeCon.EndY, dstMapId, dstX, dstY, true)	
			if con then
				closeDist = closeDist + d	
			end
		end
		return closeDist, closeCon
	end
end
function Nx.Travel:DebugCaptureTaxi()
	local num = NumTaxiNodes()
	if num > 0 then
		local map = Nx.Map:GetMap (1)
		local mid = map:GetRealMapId()
		local cap = NxData.TaxiCap or {}
		NxData.TaxiCap = cap
		local d = {}
		cap[mid] = d
		for n = 1, num do
			local name = TaxiNodeName (n)
			local typ = TaxiNodeGetType (n)		
			local x, y = TaxiNodePosition (n)
			Nx.prt ("Taxi #%s %s, %s %f %f", n, name, typ, x, y)
			tinsert (d, name)
		end
	end
end
