local L, _TRANS, CreateFrame, hooksecurefunc, getreplacehook = unpack((select(2, ...)).locals)
NxMAPOPTS_VERSION	= .26
NxMapOpts = {
	Version = 0
}
NxMapOptsDefaults = {
	Version = NxMAPOPTS_VERSION,
	NXMaps = {
		[1] = {
			[0] = {	
				NXPlyrFollow = true,
				NXWorldShow = true,
			},
			NXAutoScaleOn = true,
			NXKillShow = false,
			NXMMFull = false,
			NXMMAlpha = .5,
			NXMMDockScale = 1,
			NXMMDockScaleBG = .4,
			NXMMDockAlpha = 1,
			NXMMDockOnAtScale = .6,
			NXBackgndAlphaFade = .6,
			NXBackgndAlphaFull = 1,
			NXAutoScaleMin = .01,
			NXAutoScaleMax = 4,
			NXDotZoneScale = 1,
			NXDotPalScale = 1,
			NXDotPartyScale = 1,
			NXDotRaidScale = 1,
			NXIconNavScale = 1,
			NXIconScale = 1,
			NXDetailScale = 2,
			NXDetailAlpha = 1,
			NXPOIAtScale = 1,
			NXShowUnexplored = false,
			NXUnexploredAlpha = .35,
			
			NXOverlayAlpha = nil,
			NXMiniAlpha = nil,
			NXMiniShow = nil,
		}
	}
}
for n = 9001, 9100 do
    if Nx.Map.MapWorldInfo[n] and not Nx.Map.MapWorldInfo[n].Arena then
        NxMapOptsDefaults.NXMaps[1][n] = { NXPlyrFollow = false, NXWorldShow = false, }
    end
end
function Nx.Map:Init()
	local gopts = Nx.GetGlobalOpts()
	self.GOpts = gopts
	local plFaction = UnitFactionGroup ("player")
	plFaction = strsub (plFaction, 1, 1)
	self.PlFactionNum = plFaction == "A" and 0 or 1
	self.PlFactionShort = plFaction == "A" and "Ally" or "Horde"
	self.Maps = {}
	self.Created = false
	self:InitFuncs()
	self:InitTables()
	self.PlyrNames = {}
	self.AFKers = {}
	self.PlyrNamesTipStr = ""
	self.ScanContinentsMod = 10
	self.ContPOIs = {}
	for cont = 1, self.ContCnt do
		self.ContPOIs[cont] = {}
	end
	self.BGTimers = {}
	local hist = {}
	self.PlyrHist = hist
	hist.LastX = -99999999
	hist.LastY = -99999999
	hist.Next = 1
	hist.Cnt = self.GOpts["MapTrailCnt"]
	for n = 1, hist.Cnt * 4, 4 do
		hist[n] = 0				
		hist[n + 1] = 0		
		hist[n + 2] = 0		
		hist[n + 3] = 0		
	end
	Nx.MapPOITypes = {
		[0] =
		0, 0, 2, 1, 1, 0, 0, 0,  0, 1, 2, 1, 2, 2, 2, 1,
		0, 1, 1, 2, 2, 0, 1, 1,  2, 2, 0, 1, 1, 2, 2, 0,
		1, 1, 2, 2, 0, 1, 1, 2,  2, 0, 0, 1, 2, 0, 1, 1,
		2, 2,
		[136] = 1,
		[137] = 1,
		[138] = 2,
		[139] = 2,
		[141] = 1,
		[142] = 1,
		[143] = 2,
		[144] = 2,
		[146] = 1,
		[147] = 1,
		[148] = 2,
		[149] = 2,
		[151] = 1,
		[152] = 1,
		[153] = 2,
		[154] = 2,
	}
	self.WorldMapHideNames = {
		"WorldMapCorpse", "WorldMapDeathRelease", "WorldMapPing", "OutlandButton", "AzerothButton"
	}
	self.AddonMinimapNames = NXMapAddonMinimapNames
	NXMapAddonMinimapNames = nil
	
	if gopts["EmuTomTom"] and not TomTom then
		local tom = {}
		TomTom = tom
		tom["version"] = "v40200"
		tom["AddWaypoint"] = Nx.TTAddWaypoint
		tom["AddZWaypoint"] = Nx.TTAddZWaypoint
		tom["SetCustomWaypoint"] = Nx.TTSetCustomWaypoint
		tom["SetCustomMFWaypoint"] = Nx.TTSetCustomMFWaypoint
		tom["RemoveWaypoint"] = Nx.TTRemoveWaypoint
		tom["SetCrazyArrow"] = Nx.TTSetCrazyArrow
	end
	if gopts["EmuCartWP"] and not Cartographer then
		local cart = {}
		Cartographer = cart
		cart["HasModule"] = function (self, module)
				return module == "Waypoints" or module == Cartographer_Waypoints
			end
		cart["IsModuleActive"] = cart["HasModule"]
		cart["GetDistanceToPoint"] = Nx.CartGetDistanceToPoint
		local cartwp = {}
		Cartographer_Waypoints = cartwp
		cartwp["SetPointAsWaypoint"] = Nx.CartSetPointAsWaypoint
		cartwp["AddLHWaypoint"] = Nx.CartAddLHWaypoint
		cartwp["AddRoutesWaypoint"] = Nx.CartAddRoutesWaypoint
		cartwp["AddWaypoint"] = Nx.CartAddWaypoint
		cartwp["UpdateWaypoint"] = function (self) end
		cartwp["CancelWaypoint"] = Nx.CartCancelWaypoint
		cartwp["GetWaypointHitDistance"] = function() return 7 end
		cartwp["SetWaypointHitDistance"] = Nx.CartSetWaypointHitDistance
		if not NotePoint then
			local np = {}
			NotePoint = np
			np["new"] = Nx.CartNotePointNew
		end
	end
end
function Nx.Map:Open()
	local Map = Nx.Map
	local m = self.Maps[1]
	if not NxMapOpts.NXMaps then		
		NxMapOpts.Version = 0
	end
	if NxMapOpts.Version < NxMAPOPTS_VERSION then
		if NxMapOpts.Version > 0 then
			Nx.prt ("Reset map options %f", NxMapOpts.Version)
		end
		NxMapOpts = NxMapOptsDefaults
	end
	local opts = NxMapOpts.NXMaps[1]
	for k, v in pairs (NxMapOptsDefaults.NXMaps[1]) do
		if opts[k] == nil then
			opts[k] = v
		end
	end
	if self.Created then
		if m.Frm:IsShown() then
			m.Frm:Hide()
		else
			m.Frm:Show()
		end
		return
	end
	
	self.Maps[1] = self:Create (1)
	self.Dock:Create()
	self.Created = true
	
end
function Nx.Map:UpdateOptions (index)
	local src = Nx.Map.Maps[index]
	local dst = NxMapOpts.NXMaps[index]
	assert (src)
	assert (dst)
	dst.NXShowUnexplored = src.ShowUnexplored
	dst.NXKillShow = src.KillShow
	dst.NXBackgndAlphaFade = src.BackgndAlphaFade
	dst.NXBackgndAlphaFull = src.BackgndAlphaFull
	dst.NXDotZoneScale = src.DotZoneScale
	dst.NXDotPalScale = src.DotPalScale
	dst.NXDotPartyScale = src.DotPartyScale
	dst.NXDotRaidScale = src.DotRaidScale
	dst.NXIconNavScale = src.IconNavScale
	dst.NXIconScale = src.IconScale
	local opts = src.CurOpts
	if opts then
		opts.NXMapPosX = src.MapPosX
		opts.NXMapPosY = src.MapPosY
		opts.NXScale = src.Scale
	end
end
function Nx.Map:SwitchOptions (id, startup)
	local opts = NxMapOpts.NXMaps[self.MapIndex]
	local copts = opts[id] or opts[0]
	if copts ~= self.CurOpts then
		self.CurOpts = copts
		if copts.NXPlyrFollow then
			self:GotoPlayer()
		end
		if (not copts.NXPlyrFollow or startup) and copts.NXMapPosX then
			self.MapPosX = copts.NXMapPosX
			self.MapPosY = copts.NXMapPosY
			self.Scale = copts.NXScale
			self.StepTime = 1
		elseif copts.NXPlyrFollow or Nx.InBG then
			self:GotoCurrentZone()
		end
		local mode = opts[id] and tostring (id) or ""
		self.Win:SwitchLayoutMode (mode)
	end
end
function Nx.Map:GetOptionsT (index)
	local map = Nx.Map.Maps[index]
	local opts = NxMapOpts.NXMaps[index]
	return opts[map.RMapId] or opts[0]
end
function Nx.Map:GetOption (index, name)
	local map = Nx.Map.Maps[index]
	local opts = NxMapOpts.NXMaps[index]
	local id = map.RMapId
	id = opts[id] and id or 0
	return opts[id][name]
end
function Nx.Map:SetOption (index, name, value)
	local map = Nx.Map.Maps[index]
	local opts = NxMapOpts.NXMaps[index]
	local id = map.RMapId
	id = opts[id] and id or 0
	opts[id][name] = value
end
function Nx.Map:InitFuncs()
	self.Funcs = {
		["None"] = function() end,
		["Add Note"] = self.Menu_OnAddNote,
		["Goto"] = self.SetTargetAtClick,
		["Show Player Zone"] = self.GotoCurrentZone,
		["Show Selected Zone"] = self.CenterMap,
		["Menu"] = self.OpenMenu,
		["Zoom In"] = self.ClickZoomIn,
		["Zoom Out"] = self.ClickZoomOut,
	}
end
function Nx.Map:GetFuncs()
	local t = {}
	for name in pairs (self.Funcs) do
		tinsert (t, name)
	end
	sort (t)
	return t
end
function Nx.Map:CallFunc (optName)
	local name = self.GOpts[optName]
	if name == "None" then
		return	
	end
	local func = self.Funcs[name]
	if func then
		func (self)
	else
		Nx.prt ("Unknown map function %s", name)
	end
	return true	
end
function Nx.Map:Create (index)
	local Map = Nx.Map
	local m = {}
	local gopts = Nx.GetGlobalOpts()
	m.GOpts = gopts
	local opts = NxMapOpts.NXMaps[index]
	m.LOpts = opts		
	opts.NXPOIAtScale = opts.NXPOIAtScale or 1
	setmetatable (m, self)
	self.__index = self
	m.Tick = 0												
	m.Debug = nil											
	m.DebugTime = nil
	m.DebugFullCoords = nil								
	m.DebugAdjustScale = .1
	m.MapIndex = index
	m.MMOwn = gopts["MapMMOwn"] and index == 1
	m.ShowUnexplored = opts.NXShowUnexplored
	m.KillShow = opts.NXKillShow
	m.TitleH = 0
	m.PadX = 0
	m.Scale = .025
	m.ScaleDraw = .025									
	m.MapScale = opts.NXMapScale or 1
	m.MapW = 150
	m.MapH = 140
	m.W = m.MapW + m.PadX * 2
	m.H = m.MapH + m.TitleH + 1
	m.LClickTime = 0
	m.MouseEnabled = true
	m.Scrolling = false
	m.StepTime = 0
	m.MapId = 0
	m.BaseScale = 1										
	m.PlyrX = 0
	m.PlyrY = 0
	m.PlyrRZX = 0
	m.PlyrRZY = 0
	m.PlyrDir = 0
	m.PlyrLastDir = 999
	m.PlyrSpeed = 0
	m.PlyrSpeedX = 0
	m.PlyrSpeedY = 0
	m.PlyrSpeedCalcTime = GetTime()
	m.MoveDir = 0
	m.MoveLastX = 0
	m.MoveLastY = 0
	m.ViewSavedData = {}
	m.MapPosX = 2200											
	m.MapPosY = -100
	m.MapPosXDraw = m.MapPosX								
	m.MapPosYDraw = m.MapPosY
	m.MapsDrawnOrder = {}									
	m.MapsDrawnFade = {}										
	m.MiniBlks = gopts["MapDetailSize"]
	m.BackgndAlphaFade = opts.NXBackgndAlphaFade
	m.BackgndAlphaFull = opts.NXBackgndAlphaFull
	m.BackgndAlpha = 0									
	m.BackgndAlphaTarget = m.BackgndAlphaFade		
	
	m.DotZoneScale = opts.NXDotZoneScale
	m.DotPalScale = opts.NXDotPalScale
	m.DotPartyScale = opts.NXDotPartyScale
	m.DotRaidScale = opts.NXDotRaidScale
	m.IconNavScale = opts.NXIconNavScale
	m.IconScale = opts.NXIconScale
	m.ArrowPulse = 1
	m.ArrowScroll = 0
	m.UpdateTargetDelay = 0
	m.UpdateTrackingDelay = 0
	m.Targets = {}
	m.TargetNextUniqueId = 1
	m.Tracking = {}
	m.TrackPlyrs = {}
	m.Data = {}
	m.IconFrms = {}
	m.IconFrms.Next = 1
	m.IconNIFrms = {}				
	m.IconNIFrms.Next = 1
	m.IconStaticFrms = {}
	m.IconStaticFrms.Next = 1
	m.TextFStrs = {}
	m.TextFStrs.Next = 1
	m.MMGathererUpdateDelay = 1
	
	Nx.Window:SetCreateFade (1, 0)
	local wname = m:GetWinName()
	local i = gopts["MapShowTitle2"] and 2 or 1
	local win = Nx.Window:Create (wname, nil, nil, nil, i)
	m.Win = win
	win:SetBGAlpha (0, 1)
	win:CreateButtons (true)
	win:InitLayoutData (nil,-.75,-.225,-.18,-.25, 1) 
	for n = 9001, 9100 do
        if Nx.Map.MapWorldInfo[n] and not Nx.Map.MapWorldInfo[n].Arena then
		    win:InitLayoutData (tostring (n), -.0001, -.4, -.19, -.3, 1)
        end
	end
	
	
	
	win:SetUser (m, self.OnWin)
	win.UserUpdateFade = m.WinUpdateFade
	win.Frm:SetToplevel (true)
	win.Frm.NxMap = m
	m.StartupShown = win:IsShown()
	win.Frm:Show()
	
	local f = CreateFrame ("Frame", nil, UIParent)
	m.Frm = f
	f.NxMap = m
	win:Attach (f, 0, 1, 0, 1)
	win:RegisterEvent ("WORLD_MAP_UPDATE", self.OnEvent)
	f:SetScript ("OnMouseDown", self.OnMouseDown)
	f:SetScript ("OnMouseUp", self.OnMouseUp)
	f:SetScript ("OnMouseWheel", self.OnMouseWheel)
	f:EnableMouse (true)
	f:EnableMouseWheel (true)
	f:SetScript ("OnUpdate", self.OnUpdate)
	f:SetMovable (true)
	f:SetResizable (true)
	f:SetWidth (m.W)
	f:SetHeight (m.H)
	f:SetMinResize (50, 50)
	local t = f:CreateTexture()
	t:SetTexture (0, 0, 0, .2)
	t:SetAllPoints (f)
	f.texture = t
	f:Show()
	
	local tsf = CreateFrame ("ScrollFrame", nil, f)
	m.TextScFrm = tsf
	tsf:SetAllPoints (f)
	local tf = CreateFrame ("Frame", nil, tsf)
	m.TextFrm = tf
	tf:SetPoint ("TOPLEFT", 0, 0)
	tf:SetWidth (100)
	tf:SetHeight (100)
	tsf:SetScrollChild (tf)
	
	m:CreateLocationTip()
	
	m:CreateToolBar()
	
	local bw, bh = win:GetBorderSize()
	local function func (self, but)
		self.LOpts.NXAutoScaleOn = but:GetPressed()
	end
	m.ButAutoScaleOn = Nx.Button:Create (win.Frm, "MapAutoScale", nil, nil, -20, -bh, "TOPRIGHT", 12, 12, func, m)
	m.ButAutoScaleOn:SetPressed (opts.NXAutoScaleOn)
	
	local menu = Nx.Menu:Create (f)
	m.Menu = menu
	menu:AddItem (0, "Goto", self.Menu_OnGoto, m)
	menu:AddItem (0, "Clear Goto", self.Menu_OnClearGoto, m)
	menu:AddItem (0, "Add Note", self.Menu_OnAddNote, m)
	menu:AddItem (0, "Save Map Scale", self.Menu_OnScaleSave, m)
	menu:AddItem (0, "Restore Map Scale", self.Menu_OnScaleRestore, m)
	m.MenuIPlyrFollow = menu:AddItem (0, "Follow You", self.Menu_OnPlyrFollow, m)
	local item = menu:AddItem (0, "Select Cities Last", self.SetLevelWorldHotspots, m)
	item:SetChecked (m, "NXCitiesUnder")
	m.MenuIMonitorZone = menu:AddItem (0, "Monitor Zone", self.Menu_OnMonitorZone, m)
	local item = menu:AddItem (0, "Integrate Minimap", function() Nx.Opts:NXCmdMMOwnChange(nil, Nx.Opts:GetVar("MapMMOwn")) end)
    item:SetChecked (gopts, "MapMMOwn")
	menu:AddItem (0, "", nil, self)
	
	local routeMenu = Nx.Menu:Create (f)
	menu:AddSubMenu (routeMenu, "Route...")
	local function func (self)
		self:RouteGathers()
	end
	local item = routeMenu:AddItem (0, "Current Gather Locations", func, m)
	local function func (self)
		self:RouteTargets()
	end
	local item = routeMenu:AddItem (0, "Current Goto Targets", func, m)
	local function func (self)
		self.ShowUnexplored = false
		self:UpdateOverlayUnexplored()
		self:TargetOverlayUnexplored()
		self:RouteTargets()
	end
	routeMenu:AddItem (0, "Unexplored Locations", func, m)
	local function func (self)
		self:ReverseTargets()
	end
	routeMenu:AddItem (0, "Reverse Targets", func, m)
	local item = routeMenu:AddItem (0, "Recycle Reached Targets")
	item:SetChecked (gopts, "RouteRecycle")
	local item = routeMenu:AddItem (0, "Gather Target Radius")
	item:SetSlider (gopts, 7, 300, nil, "RouteGatherRadius")
	local item = routeMenu:AddItem (0, "Gather Merge Radius")
	item:SetSlider (gopts, 0, 100, nil, "RouteMergeRadius")
	
	local showMenu = Nx.Menu:Create (f)
	menu:AddSubMenu (showMenu, "Show...")
	showMenu:AddItem (0, "Show Player Zone", self.Menu_OnShowPlayerZone, m)
    
    
	local function func(self,but)
        local b = Nx.Quest.Watch.ButQGivers
        b:SetState(but:GetChecked() and 2 or 1)
        b.UserFunc(b.User, b)
    end
    local item=showMenu:AddItem(0, L["Show Quest Givers"], func, m)
    item:SetChecked(Nx.CharOpts["QMapShowQuestGivers3"]==2)
    
	
	local function func (self)
		self.Guide:UpdateGatherFolders()
	end
	local item = showMenu:AddItem (0, "Show Herb Locations", func, m)
	m.MenuIShowHerb = item
	item:SetChecked (Nx.CharOpts, "MapShowGatherH")
	local item = showMenu:AddItem (0, "Show Mining Locations", func, m)
	m.MenuIShowMine = item
	item:SetChecked (Nx.CharOpts, "MapShowGatherM")
	local item = showMenu:AddItem (0, "Show Artifact Locations", func, m)
	m.MenuIShowArt = item  
	item:SetChecked (Nx.CharOpts, "MapShowGatherA")
	local function func (self)
		self.Guide.POIDraw = nil
	end
	local item = showMenu:AddItem (0, "Show Mailboxes", func, m)
	item:SetChecked (gopts, "MapShowMailboxes")
	local item = showMenu:AddItem (0, "Show Notes")
	item:SetChecked (gopts, "MapShowNotes")
	local item = showMenu:AddItem (0, "Show Punks")
	item:SetChecked (gopts, "MapShowPunks")
	local function func (self, item)
		self.ShowUnexplored = item:GetChecked()
	end
	local item = showMenu:AddItem (0, "Show Unexplored Areas", func, m)
	item:SetChecked (m.ShowUnexplored)
	m.MenuIShowWorld = showMenu:AddItem (0, "Show World", self.Menu_OnShowWorld, m)
	local function forceShowCont (self)
		self.ScanContinentsMod = 10
	end
	local item = showMenu:AddItem (0, "Show Cities", forceShowCont, Map)
	item:SetChecked (gopts, "MapShowCCity")
	local item = showMenu:AddItem (0, "Show Towns", forceShowCont, Map)
	item:SetChecked (gopts, "MapShowCTown")
	local item = showMenu:AddItem (0, "Show Extras", forceShowCont, Map)
	item:SetChecked (gopts, "MapShowCExtra")
	local item = showMenu:AddItem (0, "Show Kill Icons", self.Menu_OnShowKills, m)
	item:SetChecked (m.KillShow)
	
	if not Nx.Free then
		local mmmenu = Nx.Menu:Create (f, 290) 
		menu:AddSubMenu (mmmenu, "Minimap...")
		local function func (self, item)
			self.LOpts.NXMMFull = item:GetChecked()
			self.MMZoomChanged = true
		end
		local item = mmmenu:AddItem (0, "Full Size", func, m)
		self.MMMenuIFull = item
		item:SetChecked (opts.NXMMFull)
		local function func (self, item)
			self.LOpts.NXMMAlpha = item:GetSlider()
		end
		local item = mmmenu:AddItem (0, "Transparency", func, m)
		item:SetSlider (opts.NXMMAlpha, 0, 1)
		local function func (self, item)
			self.LOpts.NXMMDockScale = item:GetSlider()
			self.MMZoomChanged = true
		end
		local item = mmmenu:AddItem (0, "Docked Scale", func, m)
		item:SetSlider (opts.NXMMDockScale, .01, 3)
		local function func (self, item)
			self.LOpts.NXMMDockScaleBG = item:GetSlider()
			self.MMZoomChanged = true
		end
		local item = mmmenu:AddItem (0, "Docked Scale In BG", func, m)
		item:SetSlider (opts.NXMMDockScaleBG, .01, 3)
		
		
		local function func (self, item)
			self.LOpts.NXMMDockOnAtScale = item:GetSlider()
		end
		local item = mmmenu:AddItem (0, "Docking Below Map Scale", func, m)
		item:SetSlider (opts.NXMMDockOnAtScale, 0, 5)
	end
	
	local smenu = Nx.Menu:Create (f, 270)
	menu:AddSubMenu (smenu, "Scale...")
	local item = smenu:AddItem (0, "Auto Scale Min")
	item:SetSlider (opts, .01, 10, nil, "NXAutoScaleMin")
	local item = smenu:AddItem (0, "Auto Scale Max")
	item:SetSlider (opts, .25, 10, nil, "NXAutoScaleMax")
	local item = smenu:AddItem (0, "Zone Dot Scale", self.Menu_OnDotZoneScale, m)
	item:SetSlider (m.DotZoneScale, 0.1, 2)
	local item = smenu:AddItem (0, "Friend/Guild Dot Scale", self.Menu_OnDotPalScale, m)
	item:SetSlider (m.DotPalScale, 0.1, 2)
	local item = smenu:AddItem (0, "Party Dot Scale", self.Menu_OnDotPartyScale, m)
	item:SetSlider (m.DotPartyScale, 0.1, 2)
	local item = smenu:AddItem (0, "Raid Dot Scale", self.Menu_OnDotRaidScale, m)
	item:SetSlider (m.DotRaidScale, 0.1, 2)
	local item = smenu:AddItem (0, "Icon Scale", self.Menu_OnIconScale, m)
	item:SetSlider (m.IconScale, 0.1, 3)
	local item = smenu:AddItem (0, "Navigation Icon Scale", self.Menu_OnIconNavScale, m)
	item:SetSlider (m.IconNavScale, 0.1, 3)
	local function func (self, item)
		self.LOpts.NXDetailScale = item:GetSlider()
	end
	local item = smenu:AddItem (0, "Details At Scale", func, m)
	item:SetSlider (opts.NXDetailScale, .05, 10)
	local item = smenu:AddItem (0, "Gather Icons At Scale")
	item:SetSlider (gopts, .01, 10, nil, "MapIconGatherAtScale")
	local item = smenu:AddItem (0, "POI Icons At Scale")
	item:SetSlider (opts, .1, 10, nil, "NXPOIAtScale")
	
	local tmenu = Nx.Menu:Create (f, 230)
	m.TransMenu = tmenu
	menu:AddSubMenu (tmenu, "Transparency...")
	local item = tmenu:AddItem (0, "Detail Transparency", self.Menu_OnDetailAlpha, m)
	item:SetSlider (opts.NXDetailAlpha, .25, 1)
	local item = tmenu:AddItem (0, "Fade In Transparency", self.Menu_OnBackgndAlphaFull, m)
	item:SetSlider (m.BackgndAlphaFull, .25, 1)
	local item = tmenu:AddItem (0, "Fade Out Transparency", self.Menu_OnBackgndAlphaFade, m)
	item:SetSlider (m.BackgndAlphaFade, 0, 1)
	local function func (self)
		self.Guide:UpdateGatherFolders()
	end
	local item = tmenu:AddItem (0, "Gather Icon Transparency", func, m)
	item:SetSlider (gopts, .2, 1, nil, "MapIconGatherA")
	local item = tmenu:AddItem (0, "POI Icon Transparency")
	item:SetSlider (gopts, .2, 1, nil, "MapIconPOIAlpha")
	local function func (self, item)
		self.LOpts.NXUnexploredAlpha = item:GetSlider()
	end
	local item = tmenu:AddItem (0, "Unexplored Transparency", func, m)
	item:SetSlider (opts.NXUnexploredAlpha, 0, .9)
	
	local item = menu:AddItem (0, "Options...", self.Menu_OnOptions, m)
	
	if NxData.DebugMap then
		m.DebugMap = true
		local dbmenu = Nx.Menu:Create (f)
		menu:AddItem (0, "", nil, self)
		menu:AddSubMenu (dbmenu, "Debug...")
		local function func (self, item)
			self.Debug = item:GetChecked()
		end
		local item = dbmenu:AddItem (0, "Map Debug", func, m)
		item:SetChecked (false)
		
		local item = dbmenu:AddItem (0, "Hotspots", func, m)
		item:SetChecked (m, "DebugHotspots")
		dbmenu:AddItem (0, "Hotspots pack", self.PackHotspotsDebug, m)
		local function func (self, item)
			self.DebugTime = item:GetChecked()
		end
		local item = dbmenu:AddItem (0, "Map Debug Time", func, m)
		item:SetChecked (false)
		local item = dbmenu:AddItem (0, "Map Full Coords", self.Menu_OnMapDebugFullCoords, m)
		item:SetChecked (m.DebugFullCoords)
		local item = dbmenu:AddItem (0, "Quest Debug", self.Menu_OnQuestDebug, m)
		item:SetChecked (Nx.Quest.Debug)
		local function func (self, item)
			self.DebugScale = item:GetSlider()
		end
		local item = dbmenu:AddItem (0, "Scale", func, m)
		item:SetSlider (0, 4, 6)
	end
	
	local menu = Nx.Menu:Create (f)
	m.PIconMenu = menu
	menu:AddItem (0, "Whisper", self.Menu_OnWhisper, m)
	menu:AddItem (0, "Invite", self.Menu_OnInvite, m)
	menu:AddItem (0, "Get Quests", self.Menu_OnGetQuests, m)
	local item = menu:AddItem (0, "Track Player", self.Menu_OnTrackPlyr, m)
	local item = menu:AddItem (0, "Remove From Tracking", self.Menu_OnRemoveTracking, m)
	menu:AddItem (0, "Report Player AFK", self.Menu_OnReportPlyrAFK, m)
	menu:AddItem (0, "")
	local item = menu:AddItem (0, "Grow Conflict Bars", self.Menu_OnGrowConflictBars, m)
	item:SetChecked (true)
	m.BGGrowBars = true
	
	m:CreateIconMenu (f)
	
	m.BGIncNum = 0
	local menu = Nx.Menu:Create (f)
	m.BGIconMenu = menu
	for n = 1, #NXlBGMessages, 2 do
		local function func (self)
			self:BGMenu_Send (NXlBGMessages[n + 1])	
		end
		menu:AddItem (0, NXlBGMessages[n], func, m)
	end
	menu:AddItem (0, NXlBGStatus, self.BGMenu_OnStatus, m)
	
	local plf = CreateFrame ("Frame", nil, f)
	m.PlyrFrm = plf
	plf.NxMap = m
	plf:SetWidth (3)
	plf:SetHeight (3)
	t = plf:CreateTexture()
	plf.texture = t
	t:SetTexture ("Interface\\Minimap\\MinimapArrow")
	t:SetAllPoints (plf)
	plf:SetPoint ("CENTER", 0, (m.TitleH - 1) * -.5)
	plf:Show()
	
	m:InitFrames()
	
	
	self.RMapId = 9000		
	m:SwitchOptions (-1, true)
	m:UpdateAll()
	m.Guide = Map.Guide:Create (m)
	
	self.MMFrm = _G["Minimap"]
	assert (self.MMFrm)
	m:MinimapOwnInit()
	
	local function func (self)
		if not Nx.InBG then
			self:GotoPlayer()
		end
	end
	Nx.Timer:Start ("MapIShow" .. m.MapIndex, 1, m, func)
	
	return m
end
function Nx.Map:GetWinName()
	return "NxMap" .. self.MapIndex
end
function Nx.Map:CreateToolBar()
	local bar = Nx.ToolBar:Create (self:GetWinName().."TB", self.Frm, 22, true, true)
	self.ToolBar = bar
	bar:SetUser (self)
	local data = {
		{ "MapZIn", "Zoom In", self.OnButZoomIn, false },
		{ "MapZOut", "Zoom Out", self.OnButZoomOut, false },
		
		{ "MapGuide", "-Guide-", self.OnButToggleGuide, false },
		
		{ "MapWarehouse", "-Warehouse-", self.OnButToggleWarehouse, false },
		
		
		
		
		{"MapOriginMap","打开系统原有的世界地图\n快捷键为ALT+M",self.OpenBlizzardWorldMap,false},
	}
	for i, b in ipairs (data) do
		if Nx.Free and i > 3 then
			break
		end
		bar:AddButton (b[1], _TRANS(b[2]), nil, b[3], b[4])
	end
	bar:Update()
	self:UpdateToolBar()
end
function Nx.Map:UpdateToolBar()
	local frm = self.ToolBar.Frm
	local opts = Nx:GetGlobalOpts()
	if opts["MapShowToolBar"] then
		frm:Show()
	else
		frm:Hide()
	end
end
function Nx.Map:CreateIconMenu (frm)
	
	local menu = Nx.Menu:Create (frm)
	self.GIconMenu = menu
	self.GIconMenuITogInst = menu:AddItem (0, "Toggle Instance Map", self.GMenu_OnTogInst, self)
	self.GIconMenuIFindNote = menu:AddItem (0, "Find Note", self.GMenu_OnFindNote, self)
	Nx.Quest:CreateGiverIconMenu (menu, frm)
	menu:AddItem (0, "Goto", self.GMenu_OnGoto, self)
	menu:AddItem (0, "Clear Goto", self.Menu_OnClearGoto, self)
	menu:AddItem (0, "Paste Link", self.GMenu_OnPasteLink, self)
	menu:AddItem (0, "Add Note", self.Menu_OnAddNote, self)
end
function Nx.Map:CreateLocationTip()
	local f = CreateFrame ("Frame", "NxMapTip", self.Frm)
	self.LocTipFrm = f
	f:SetClampedToScreen()
	local t = f:CreateTexture()
	f.texture = t
	t:SetAllPoints (f)
	t:SetTexture (0, 0, 0, .85)
	
	local fstrs = {}
	self.LocTipFStrs = fstrs
	local h = Nx.Font:GetH ("FontMapLoc")
	for n = 1, 4 do
		local fstr = f:CreateFontString()
		tinsert (fstrs, fstr)
		fstr:SetFontObject ("NxFontMapLoc")
		fstr:SetJustifyH ("LEFT")
	end
end
function Nx.Map:SetLocationTip (tipStr)
	local f = self.LocTipFrm
	local a = self.GOpts["MapLocTipAnchor"]
	if tipStr and a ~= "None" then
		local ar = self.GOpts["MapLocTipAnchorRel"]
		ar = ar == "None" and a or ar
		f:ClearAllPoints()
		f:SetPoint (a, self.Frm, ar)
		local h = Nx.Font:GetH ("FontMapLoc")
		local fstrs = self.LocTipFStrs
		local i = 1
		local textW = 0
		for s in gmatch (tipStr, "(%C+)") do		
			local fstr = fstrs[i]
			fstr:SetPoint ("TOPLEFT", 2, 0 - (i - 1) * h)
			fstr:SetText (s)
			textW = max (textW, fstr:GetStringWidth())
			i = i + 1
		end
		for n = i, #fstrs do
			fstrs[n]:SetText ("")
		end
		f:SetWidth (4 + textW)
		f:SetHeight (2 + (i - 1) * h)
		f:Show()
	else
		f:Hide()
	end
end
function Nx.Map:StartupZoom()
end
function Nx.Map:MainOnUpdate (elapsed)
	if self.Created then
		local map = self:GetMap (1)
		local win = map.Win
		local show, showsv = win:IsShown()
		if not show then
			if showsv and not win:IsCombatHidden() then	
				win:Show()
				map:RestoreSize()
				return
			end
			self.OnUpdate (map.Frm, elapsed)
		end
	end
end
function Nx.Map:OnWin (typ)
	if typ == "SizeNorm" then
		self:RestoreSize()
	elseif typ == "SizeMax" then
		if WorldMapFrame:IsShown() then
			HideUIPanel (WorldMapFrame)
		end
		tinsert (UISpecialFrames, self:GetWinName())
		self:AttachWorldMap()
	elseif typ == "Close" then
	end
end
function Nx.Map:AttachWorldMap()
	if not self.GOpts["MapWOwn"] then
		return
	end
	local f = getglobal ("WorldMapButton")
	if f then
		self.WorldMapFrm = f
		self.WorldMapFrmParent = f:GetParent()
		self.WorldMapFrmScale = f:GetScale()
		f:SetParent (self.TextFrm)
		f:Show()
		f:EnableMouse (false)
		self:SetWorldMapIcons (.001)
		local tipf = getglobal ("WorldMapTooltip")
		if tipf then
			tipf:SetParent (self.Frm)
		end
		local af = getglobal ("WorldMapFrameAreaFrame")
		if af then
			af:Hide()
		end
		
		for n = 1, NUM_WORLDMAP_POIS do
			local f = getglobal ("WorldMapFramePOI" .. n)
			f:Hide()
		end
		self.WorldMapFrmMapId = 0
	end
end
function Nx.Map:DetachWorldMap()
	local f = self.WorldMapFrm
	if f then
		self.WorldMapFrm = nil
		f:SetParent (self.WorldMapFrmParent)
		f:SetScale (self.WorldMapFrmScale)
		f:SetPoint ("TOPLEFT", "WorldMapDetailFrame", "TOPLEFT", 0, 0)
		f:EnableMouse (true)
		self:SetWorldMapIcons (1)
		local tipf = getglobal ("WorldMapTooltip")
		if tipf then
			tipf:SetParent (self.WorldMapFrmParent)
			tipf:SetFrameStrata ("TOOLTIP")
		end
		local af = getglobal ("WorldMapFrameAreaFrame")
		if af then
			af:Show()
		end
	end
end
function Nx.Map:UpdateWorldMap()
	local f = self.WorldMapFrm
	if f then
		if self.StepTime ~= 0 or self.Scrolling or IsShiftKeyDown() then
			f:Hide()
		else
			local tipf = getglobal ("WorldMapTooltip")
			if tipf then
				tipf:SetFrameStrata ("TOOLTIP")
			end
			local af = getglobal ("WorldMapFrameAreaFrame")
			if af then
				af:SetFrameStrata ("HIGH")
			end
			f:Show()
			self:ClipZoneFrm (self.Cont, self.Zone, f, 1)
			f:SetFrameLevel (self.Level)
			if self.WorldMapFrmMapId ~= self.MapId then
				self.WorldMapFrmMapId = self.MapId
				self:SetChildLevels (f, self.Level + 1)
				self.Level = self.Level + 4
			end
		end
		for k, f in ipairs (_G["MAP_VEHICLES"]) do
			f:SetScale (.001)
		end
	end
end
function Nx.Map:SetChildLevels (frm, lvl)
	local ch = { frm:GetChildren() }
	for n, chf in pairs (ch) do
		chf:SetFrameLevel (lvl)
		if chf:GetNumChildren() > 0 then
			self:SetChildLevels (chf, lvl + 1)
		end
	end
end
function Nx.Map:SetWorldMapIcons (scale)
	for n = 1, MAX_PARTY_MEMBERS do
		local f = getglobal ("WorldMapParty" .. n)
		if f then
			f:SetScale (scale)
		end
	end
	for n = 1, MAX_RAID_MEMBERS do
		local f = getglobal ("WorldMapRaid" .. n)
		if f then
			f:SetScale (scale)
		end
	end
	local flags = GetNumBattlefieldFlagPositions()
	for n = 1, flags do
		local f = getglobal ("WorldMapFlag" .. n)
		if f then
			f:SetScale (scale)
		end
	end
	for k, f in ipairs (_G["MAP_VEHICLES"]) do
		f:SetScale (scale)
	end
	for k, name in ipairs (Nx.Map.WorldMapHideNames) do
		local f = getglobal (name)
		if f then
			f:SetScale (scale)
		end
	end
end
function Nx.Map:OnButZoomIn()
	self:SetScaleOverTime (6)
end
function Nx.Map:OnButZoomOut()
	self:SetScaleOverTime (-6)
end
function Nx.Map:OnButToggleFav (but)
	Nx.Fav:ToggleShow()
end
function Nx.Map:OnButToggleGuide (but)
	self.Guide:ToggleShow()
end
function Nx.Map:OnButToggleWarehouse (but)
	Nx.Warehouse:ToggleShow()
end
function Nx.Map:OnButToggleCombat (but)
	Nx.Combat:Open()
end
function Nx.Map:OnButToggleEvent (but)
	Nx.UEvents.List:Open()
end
function Nx.Map:InitFrames()
	local f = self.Frm
	local m = self
	
	self.TileFrms = {}
	local tf
	for i = 1, 12 do
		tf = CreateFrame ("Frame", nil, f)
		m.TileFrms[i] = tf
		local t = tf:CreateTexture()
		t:SetAllPoints (tf)
        t:SetTexture(1,1,1,1)  
		tf.texture = t
	end
	
	Nx.ContBlks = {
		{ 0,1,1,0, 0,1,1,0, 0,1,1,0 },
		{ 0,1,1,0, 0,1,1,0, 0,1,1,0 },
		{ 1,1,1,1, 1,1,1,1, 1,1,1,1 },
		{ 1,1,1,1, 1,1,1,1, 1,1,1,1 },
		{ 1,1,1,0, 1,1,1,0, 1,1,1,0 },
		{ 1,1,1,1, 1,1,1,1, 1,1,1,1 },
	}
	self.ContFrms = {}
	for n = 1, Nx.Map.ContCnt do
		self.ContFrms[n] = {}
		local mapFileName = self.MapInfo[n].FileName
		local texi = 1
		for i = 1, 12 do
			if Nx.ContBlks[n][i] ~= 0 then
				local cf = CreateFrame ("Frame", nil, f)
				m.ContFrms[n][i] = cf
				local t = cf:CreateTexture()
				t:SetAllPoints (cf)
				cf.texture = t
				if n == 0 then
					t:SetTexture ("Interface\\AddOns\\Carbonite\\Gfx\\Map\\Cont\\".."Kal"..texi)
					texi = texi + 1
				else
					t:SetTexture ("Interface\\WorldMap\\"..mapFileName.."\\"..mapFileName..i)
				end
			end
		end
	end
	
	self.MiniFrms = {}
	for n = 1, self.MiniBlks ^ 2 do
		local tf = CreateFrame ("Frame", nil, f)
		m.MiniFrms[n] = tf
		local t = tf:CreateTexture()
		tf.texture = t
		t:SetAllPoints (tf)
	end
	self:InitHotspots()
    
    
    
end
function Nx.Map:InitHotspots()
	local quad = {}
	self.WorldHotspots = quad
	local quadCity = {}
	self.WorldHotspotsCity = quadCity
	for contN = 1, Nx.Map.ContCnt do
		cname = self:GetWorldContinentInfo (contN)
		cname=_TRANS(cname)
		if not cname then
			break
		end
		local zoneN = 1
		while true do
			zname, zx, zy, zw, zh = self:GetWorldZoneInfo (contN, zoneN)
			if not zx then
				break
			end
			local mapId = self:CZ2MapId (contN, zoneN)
			local nxz = Nx.MapIdToNxzone[mapId] or 0
			local color, infoStr = self:GetMapNameDesc (mapId)
			local tipStr = format ("%s, %s%s (%s)", cname, color, zname, infoStr)
			local loc = Nx.MapWorldHotspots[nxz]	
			local locSize = 4
			if not loc then
				loc = Nx.MapWorldHotspots2[mapId]
				if loc then
					locSize = 12
				else
					loc = format ("%c%c%c%c", 85, 85, 135, 135)
				end
			end
			for n = 0, 100 do
				local locN = n * locSize + 1
				local loc1 = strsub (loc, locN, locN + locSize - 1)
				if loc1 == "" then
					break
				end
				local zx, zy, zw, zh
				if locSize == 4 then
					zx, zy, zw, zh = Nx.Quest:UnpackLocRect (loc1)
				else
					zx = tonumber (strsub (loc1, 1, 3), 16) * 100 / 4095
					zy = tonumber (strsub (loc1, 4, 6), 16) * 100 / 4095
					zw = tonumber (strsub (loc1, 7, 9), 16) * 1002 / 4095
					zh = tonumber (strsub (loc1, 10, 12), 16) * 668 / 4095
				end
				local spot = {}
				local wzone = self:GetWorldZone (mapId)
				if wzone.City or wzone.StartZone then
					tinsert (quadCity, spot)
				else
					tinsert (quad, spot)
				end
				spot.MapId = mapId
				local wx, wy = self:GetWorldPos (mapId, zx, zy)
				spot.WX1 = wx
				spot.WY1 = wy
				zw = zw / 1002 * 100
				zh = zh / 668 * 100
				local wx, wy = self:GetWorldPos (mapId, zx + zw, zy + zh)
				spot.WX2 = wx
				spot.WY2 = wy
				spot.NxTipBase = tipStr
			end
			zoneN = zoneN + 1
		end
	end
end
function Nx.Map:GetMapNameDesc (mapId)
	local nxz = Nx.MapIdToNxzone[mapId] or 0
	local _, minLvl, maxLvl, faction = strsplit ("!", Nx.Zones[nxz])
	minLvl = tonumber (minLvl)
	faction = tonumber (faction)
	local infoStr = format ("%d-%d", minLvl, maxLvl)
	local color = "|cffffffff"
	if self.PlFactionNum == faction then
		color = "|cff20ff20"
	elseif faction == 2 then
		color = "|cffffff00"
	elseif faction < 2 then
		color = "|cffff6060"
	end
	if minLvl == 0 then
		infoStr = L"Any"
	end
	if self:GetWorldZone (mapId).City then
		infoStr = L"City"
		minLvl = -1
	end
	return color, infoStr, minLvl
end
function Nx.Map:MinimapOwnInit()
	self.MMScales = {}
	for n = 1, 6 do
		self.MMScales[n] = (8 - n) * 66.6666666666666 / 5.0
	end
	self.MMScalesC = { 300, 240, 180, 120, 80, 50 }
	for n = 1, 6 do
		self.MMScalesC[n] = self.MMScalesC[n] / 5.0
	end
	
	local mm = self.MMFrm
	local mmc = getglobal ("MinimapCluster")
	
	mm:SetMaskTexture ("textures\\MinimapMask")
	self:MinimapNodeGlowInit()
	
	self.MMChkDelay = 5		
	self.MMOwnedFrms = {}
	
	if not self.MMOwn then
		if MinimapZoom then MinimapZoom:Show() end
		self.Win:Show (self.StartupShown)
		Nx.Map:MinimapButtonShowUpdate()
		return
	end
	if MinimapZoom then MinimapZoom:Hide() end
	Nx.Map:MinimapButtonShowUpdate (true)
	mm:SetClampedToScreen (true)
	mm:SetWidth (140)
	mm:SetHeight (140)
	self.MMAlphaDelay = 100
	mm:SetParent (self.Frm)
    self.MMFrm:SetQuestBlobRingAlpha(1)
	self.MMFrm:SetPOIArrowTexture("")
	mm:SetScript ("OnMouseDown", self.MinimapOnMouseDown)
	mm:SetScript ("OnMouseUp", self.MinimapOnMouseUp)
	mm:SetScript ("OnEnter", self.MinimapOnEnter)
	mm:SetScript ("OnLeave", self.MinimapOnLeave)
	
	
	self.MMModels = {}
	self.MMAddonFrms = {}
	local f = getglobal ("MinimapBackdrop")
	if f then
		f:Hide()
		f:SetParent (mmc)
	end
	hooksecurefunc ("Minimap_ZoomIn", Nx.Map.Minimap_ZoomInClick)
	hooksecurefunc ("Minimap_ZoomOut", Nx.Map.Minimap_ZoomOutClick)
end
function Nx.Map.Minimap_ZoomInClick()
	local map = Nx.Map:GetMap (1)
	map:MinimapZoom (2)
end
function Nx.Map.Minimap_ZoomOutClick()
	local map = Nx.Map:GetMap (1)
	map:MinimapZoom (-2)
end
function Nx.Map.Minimap_OnEvent()
	local map = Nx.Map:GetMap (1)
	map:MinimapZoom()
end
function Nx.Map:MinimapZoom (value)
	if value then
		self:SetScaleOverTime (value)
	end
	local f = getglobal ("MinimapZoomIn")
	if f then
		f:Enable()
	end
	local f = getglobal ("MinimapZoomOut")
	if f then
		f:Enable()
	end
end
function Nx.Map:MinimapOnMouseDown (button)
	local this = self			
	local map = Nx.Map.Maps[1]
	if (map.MMZoomType == 0 and button == "LeftButton") or
			(IsShiftKeyDown() and not IsControlKeyDown()) then
		this.NXPing = true
	else
		this.NXPing = nil
		this.NxMap = map
		map.OnMouseDown (this, button)
	end
end
function Nx.Map:MinimapOnMouseUp (button)
	local this = self			
	local map = Nx.Map.Maps[1]
	if this.NXPing then
		if map.MMZoomType == 0 then
			Minimap_OnClick (this)
		else
			map:Ping()
		end
	else
		this.NxMap = map
		map.OnMouseUp (this, button)
	end
end
function Nx.Map:Ping()
	local frm = self.Frm
	local mx, my = Nx.Util_GetMouseClampedXY (frm)
	local top = frm:GetTop()
	local bottom = frm:GetBottom()
	my = top - (my + bottom)
	local mm = self.MMFrm
	local scales = self.MMScales
	local info = self.MapWorldInfo[self.MapId]
	if info.City and not info.MMOutside then
		scales = self.MMScalesC
	end
	local zoom = mm:GetZoom() + 1
	local wx, wy = self:FramePosToWorldPos (mx, my)
	local sc = scales[zoom] / mm:GetWidth()
	local x = wx - self.PlyrX
	local y = self.PlyrY - wy
	mm:PingLocation (x / sc, y / sc)
end
function Nx.Map:MinimapOnEnter (motion)
	local map = Nx.Map.Maps[1]
	if map.MMZoomType ~= 0 then
		local this = self			
		this.NxMap = map
		map.IconOnEnter (self, motion)
	end
end
function Nx.Map:MinimapOnLeave (motion)
	local map = Nx.Map.Maps[1]
	if map.MMZoomType ~= 0 then
		local this = self			
		this.NxMap = map
		map.IconOnLeave (self, motion)
	end
end
function Nx.Map:MinimapButtonShowUpdate (justNameplate)
	local opts = Nx:GetGlobalOpts()
	local t = {
		"MinimapCluster", "MapMMShowOldNameplate",
		"NXMiniMapBut", "MapMMButShowCarb",
		"GameTimeFrame", "MapMMButShowCalendar",
		"TimeManagerClockButton", "MapMMButShowClock",
		"MiniMapWorldMapButton", "MapMMButShowWorldMap",
	}
	for n = 1, #t, 2 do
		local skip
		if Nx.Free then
			if t[n] == "MinimapCluster" then
				skip = true
			end
		end
		if not skip then
			local f = getglobal (t[n])
			if f then
				if opts[t[n + 1]] then
					f:Show()
				else
					f:Hide()
				end
			end
		end
		if justNameplate then
			break
		end
	end
end
function Nx.Map:MinimapNodeGlowInit (reset)
	local mm = self.MMFrm
	Nx.Timer:Stop ("MapNodeGlow")
	if reset then
		mm:SetBlipTexture ("Interface\\Minimap\\objecticons")
	end
	local delay = self.GOpts["MapMMNodeGD"]
	if delay > 0 then
		if not self.MMGlowInited then
			self.MMGlowInited = true
			
			local t = mm:CreateTexture (nil, "BACKGROUND")
			t:SetAllPoints()
			t:SetTexture ("Interface\\AddOns\\Carbonite\\Gfx\\Map\\MMOIcons")
			t:Hide()
			local t = mm:CreateTexture (nil, "BACKGROUND")
			t:SetAllPoints()
			t:SetTexture ("Interface\\AddOns\\Carbonite\\Gfx\\Map\\MMOIconsG")
			t:Hide()
		end
		Nx.Timer:Start ("MapNodeGlow", .1, self, self.OnMinimapNodeGlowTimer)
	end
end
function Nx.Map:OnMinimapNodeGlowTimer (name)
	self:MinimapNodeGlowSet ("")
	Nx.Timer:SetFunc (name, self.OnMinimapNodeGlowTimerG)
	return self.GOpts["MapMMNodeGD"] * 2
end
function Nx.Map:OnMinimapNodeGlowTimerG (name)
	self:MinimapNodeGlowSet ("G")
	Nx.Timer:SetFunc (name, self.OnMinimapNodeGlowTimer)
	return self.GOpts["MapMMNodeGD"] * 2
end
function Nx.Map:MinimapNodeGlowSet (letter)
	local count = GetNumTrackingTypes()
	for n = 1, count do 
		local name, texture, active, category = GetTrackingInfo (n)
		if active and category == "spell" then
				self.MMFrm:SetBlipTexture ("Interface\\AddOns\\Carbonite\\Gfx\\Map\\MMOIcons" .. letter)
			break
		end
	end
end
function Nx.Map:MinimapUpdate()
	if not self.MMOwn then
		self:MinimapDetachFrms()
		return
	end
	
	if self.GOpts["MapMMMoveCapBars"] then
		local y = 0
		for n = 1, NUM_EXTENDED_UI_FRAMES do
			local f = getglobal ("WorldStateCaptureBar" .. n)
			if f and f:IsShown() then
				f:SetPoint ("TOPRIGHT", self.Win.Frm, "BOTTOMRIGHT", 0, y)
				y = y + f:GetHeight()
			end
		end
	end
	
	if self.DebugScale then
		self.MMScale = 0
		local sc = self.DebugScale
		for n = 1, 6 do
			self.MMScales[n] = (8 - n) * 66.6666666666666 / sc
		end
	end
	
	local mm = self.MMFrm
	local lOpts = self.LOpts
	local scales = self.MMScales
	local info = self.MapWorldInfo[self.RMapId]
	if info.City and not info.MMOutside then
		scales = self.MMScalesC
	end
	local zoomType = 0
	local zoom = mm:GetZoom (1)
	local dock = lOpts.NXMMFull or self.GOpts["MapMMDockAlways"]
	if self.Win:IsSizeMax() and self.GOpts["MapMMDockOnMax"] then
		dock = true
	end
	if not dock and not self.InstanceId
			and self.ScaleDraw > lOpts.NXMMDockOnAtScale then
		mm:ClearAllPoints()
		for n = 1, 6 do
			local sz = scales[n]
			if self:ClipMMW (mm, self.PlyrX, self.PlyrY, sz, sz) then
				zoomType = n
				break
			end
		end
	end
	local al = lOpts.NXMMAlpha
	local indoors = IsIndoors()
	local indoorChange = self.Indoors ~= indoors
	self.Indoors = indoors
	if self.InstanceId then
		al = 1
	else
		if indoors and self.GOpts["MapMMDockIndoors"] then
			zoomType = 0
		end
		if indoorChange and self.GOpts["MapMMIndoorTogFullSize"] then
			lOpts.NXMMFull = false
			if not info.City and indoors then
				lOpts.NXMMFull = true
			end
			self.MMMenuIFull:SetChecked (lOpts.NXMMFull)
			Nx.Menu:CheckUpdate (self.MMMenuIFull)
		end
		if zoomType == 0 then
			al = lOpts.NXMMDockAlpha
		end
		if IsControlKeyDown() then
			al = IsAltKeyDown() and 1 or .8
			self.MMZoomChanged = true
		end
	end
	if self.MMZoomType ~= zoomType or zoomType > 0 and self.MMScale ~= self.ScaleDraw
			or indoorChange then
		self.MMZoomType = zoomType
		self.MMScale = self.ScaleDraw
		self.MMZoomChanged = true
		if self.MMAlphaDelay == 0 then
			self.MMAlphaDelay = 2
		end
	end
	if self.MMAlphaDelay > 0 then
		self.MMAlphaDelay = self.MMAlphaDelay - 1
		self.MMZoomChanged = true
	end
	mm:SetAlpha (al)
	self:MinimapDetachFrms()
	if zoomType > 0 then
        
        if MinimapZoom then MinimapZoom:Hide() end
		self:MinimapUpdateMask ("MapMMSquare")
		local above = IsControlKeyDown()
		if self.GOpts["MapMMAboveIcons"] then
			above = not above
		end
		local lvl = self.Level
		if above then
			lvl = lvl + 15
		end
		mm:SetFrameLevel (lvl)
		self:MinimapUpdateDetachedFrms (lvl + 1)
		self.Level = self.Level + 2
	else
        if MinimapZoom then MinimapZoom:Show() end
		local sc = self.MMFScale
		self.MMFScale = Nx.InBG and lOpts.NXMMDockScaleBG or lOpts.NXMMDockScale
		if lOpts.NXMMFull then
			self.MMFScale = min (self.MapW, self.MapH) / 140
		end
	end
end
function Nx.Map:MinimapUpdateEnd()
	if not self.MMOwn then
		return
	end
	local mm = self.MMFrm
	local mmfull = self.LOpts.NXMMFull
	if self.Win:IsSizeMax() and self.GOpts["MapMMHideOnMax"] or self.MMFScale < .02 then
		mm:SetPoint ("TOPLEFT", 1, 0)
		mm:SetScale (.02)
		mm:SetFrameLevel (1)
		for n, f in ipairs (self.MMModels) do
			f:SetScale (.001)
		end
		return
	end
	if self.MMZoomType == 0 then
		self:MinimapUpdateMask ("MapMMDockSquare")
		local iconScale = self.GOpts["MapMMDockIScale"]
		self:MinimapSetScale (self.MMFScale, iconScale)
		local x = 0
		local y = 0
		local sz = 140 * self.MMFScale
		if self.GOpts["MapMMDockRight"] then
			x = (self.MapW - sz + 1)
		end
		if self.GOpts["MapMMDockBottom"] then
			y = (self.MapH - sz + 1)
		end
		mm:ClearAllPoints()
		mm:SetPoint ("TOPLEFT", (x + self.GOpts["MapMMDXO"]) / iconScale,
										(-y - self.GOpts["MapMMDYO"]) / iconScale)
		mm:Show()
		mm:SetFrameLevel (self.Level)
		self:MinimapUpdateDetachedFrms (self.Level + 1)
		self.Level = self.Level + 2
	end
    
	if self.MMZoomChanged then
		self.MMZoomChanged = false
		local zoom = max (self.MMZoomType - 1, 0)
		if self.MMZoomType == 0 then
			zoom = self.GOpts["MapMMDockZoom"]
		end
		local z = zoom - 1
		if z < 0 then
			z = 1
		end
		
		
		mm:SetZoom (zoom)
		if self.MMZoomType == 0 then
			mm:SetAlpha (1)
		end
	end
	
	
end
function Nx.Map:MinimapSetScale (scale, iconScale)
	local mm = self.MMFrm
	local sz = 140 * scale / iconScale
	mm:SetWidth (sz)
	mm:SetHeight (sz)
	mm:SetScale (iconScale)
end
function Nx.Map:MinimapUpdateMask (optName)
	local name = self.GOpts[optName] and "Interface\\Buttons\\White8x8" or "textures\\MinimapMask"
	if self.MMMaskName ~= name then
		self.MMMaskName = name
		local mm = self.MMFrm
		mm:SetMaskTexture (name)
	end
	local name = self.MMZoomType == 0 and "Interface\\Minimap\\MinimapArrow" or ""
	if self.MMArrowName ~= name then
		self.MMArrowName = name
		
	end
end
function Nx.Map:MinimapDetachFrms()
	local mm = self.MMFrm
	local mmc = getglobal ("MinimapCluster")
	local winf = self.Win.Frm
	local dock = Nx.Map.Dock
	if dock.InitPending then
		return
	end
	self.MMChkDelay = self.MMChkDelay - 1
	if self.MMChkDelay < 1 then
		self.MMChkDelay = 40		
		
		local mmNames = self.AddonMinimapNames
		local ch = { mm:GetChildren() }
		for n = 1, #ch do
			local c = ch[n]
			if c ~= mmc then
				if c:IsShown() and not self.MMOwnedFrms[c] then
					if c:IsObjectType ("Model") then
						if self.MMOwn then
							c:SetParent (winf)
							self.MMOwnedFrms[c] = 0
							tinsert (self.MMModels, c)
						end
					elseif c:IsObjectType ("Frame") then
						local name = gsub (c:GetName() or "", "%d", "")
						if mmNames[name] then
							if self.MMOwn then
								self.MMOwnedFrms[c] = 0
								self.MMAddonFrms[c] = 1
							end
						elseif dock.MMFrms then
							self.MMOwnedFrms[c] = 0
							tinsert (dock.MMFrms, c)
							if c:GetNumChildren() > 0 then
								local ch = { c:GetChildren() }
								for k, c in ipairs (ch) do
									if c:IsShown() then
										if c:IsObjectType ("Frame") then
											local pt, relTo = c:GetPoint()
											if relTo == mm then
												tinsert (dock.MMFrms, c)
											end
										end
									end
								end
							end
						end
					end
				end
			end
		end
	end
	
	dock:MinimapDetachFrms(self)  
end
function Nx.Map:MinimapUpdateDetachedFrms (lvl)
	local sc = self.MMFScale
	local arrowsc = sc
	local msc = min (1 / sc, 1) * .5
	if Nx.InBG then
		arrowsc = .001
	end
	local mmplyr = Nx.Map.MinimapPlyrModel		
	for n, f in ipairs (self.MMModels) do
		if f:IsShown() then
			f:SetFrameLevel (lvl)
			local name = f:GetModel()
			if name == "interface\\minimap\\ping\\minimapping.m2" then
				f:SetScale (sc)
				f:SetModelScale (msc)
				f:SetAlpha (1)
			elseif f == mmplyr then
				if self.MMZoomType == 0 then
					f:SetScale (max (.4, min (.9, sc)) * self.GOpts["MapPlyrArrowSize"] / 28)
					f:SetModelScale (1)
				else
					f:SetScale (.1)
					f:SetModelScale (1)
				end
			else
				f:SetScale (arrowsc)
				f:SetModelScale (msc)
			end
		end
	end
	for f, v in pairs (self.MMAddonFrms) do
		f:SetFrameLevel (lvl)
	end
end
function Nx.Map:Menu_OnGoto (item)
	self:SetTargetAtClick()
end
function Nx.Map:Menu_OnClearGoto (item)
	self:ClearTargets()
	self.Guide:ClearAll()
end
function Nx.Map:Menu_OnAddNote()
	local wx, wy = self:FramePosToWorldPos (self.ClickFrmX, self.ClickFrmY)
	local zx, zy = self:GetZonePos (self.MapId, wx, wy)
	self:AddNote ("\230\160\135\232\174\176", self.MapId, zx, zy)
end
function Nx.Map:AddNote (name, id, x, y)
	Nx.Fav:Record ("Note", name, id, x, y)
end
function Nx.Map:Menu_OnMonitorZone (item)
	Nx.Com:MonitorZone (self.MenuMapId, item:GetChecked())
end
function Nx.Map:Menu_OnScaleSave()
	self.CurOpts.NXScaleSave = self.Scale
end
function Nx.Map:Menu_OnScaleRestore()
	local s = self.CurOpts.NXScaleSave
	if s then
		self.Scale = s
		self.StepTime = 10
	else
		Nx.prt ("Scale not set")
	end
end
function Nx:NXMapKeyScaleRestore()
	local map = self.Map:GetMap (1)
	map:Menu_OnScaleRestore()
end
function Nx.Map:Menu_OnPlyrFollow (item)
	self.CurOpts.NXPlyrFollow = item:GetChecked()
end
function Nx.Map:Menu_OnShowWorld (item)
	self.CurOpts.NXWorldShow = item:GetChecked()
end
function Nx.Map:Menu_OnShowPlayerZone()
	self:GotoCurrentZone()
end
function Nx.Map:Menu_OnShowKills (item)
	self.KillShow = item:GetChecked()
end
function Nx.Map:Menu_OnDetailAlpha (item)
	self.LOpts.NXDetailAlpha = item:GetSlider()
end
function Nx.Map:Menu_OnBackgndAlphaFade (item)
	self.BackgndAlphaFade = item:GetSlider()
end
function Nx.Map:Menu_OnBackgndAlphaFull (item)
	self.BackgndAlphaFull = item:GetSlider()
end
function Nx.Map:Menu_OnDotZoneScale (item)
	self.DotZoneScale = item:GetSlider()
end
function Nx.Map:Menu_OnDotPalScale (item)
	self.DotPalScale = item:GetSlider()
end
function Nx.Map:Menu_OnDotPartyScale (item)
	self.DotPartyScale = item:GetSlider()
end
function Nx.Map:Menu_OnDotRaidScale (item)
	self.DotRaidScale = item:GetSlider()
end
function Nx.Map:Menu_OnIconScale (item)
	self.IconScale = item:GetSlider()
end
function Nx.Map:Menu_OnIconNavScale (item)
	self.IconNavScale = item:GetSlider()
end
function Nx.Map:Menu_OnOptions (item)
	Nx.Opts:Open ("Map")
end
function Nx.Map:Menu_OnMapDebugFullCoords (item)
	self.DebugFullCoords = item:GetChecked()
end
function Nx.Map:Menu_OnQuestDebug (item)
	Nx.Quest.Debug = item:GetChecked()
end
function Nx.Map:Menu_OnWhisper()
	for _, name in pairs (Nx.Map.PlyrNames) do
		local box = ChatEdit_ChooseBoxForSend()
		ChatEdit_ActivateChat (box)
		box:SetText ("/w " .. name .. " " .. box:GetText())
		break
	end
end
function Nx.Map:Menu_OnInvite()
	for _, name in pairs (Nx.Map.PlyrNames) do
		InviteUnit (name)
		break
	end
end
function Nx.Map:Menu_OnGetQuests (item)
	for _, name in pairs (Nx.Map.PlyrNames) do
		Nx.Quest:GetFromPlyr (name)
		break
	end
end
function Nx.Map:Menu_OnTrackPlyr (item)
	for _, name in pairs (Nx.Map.PlyrNames) do
		self.TrackPlyrs[name] = true
	end
end
function Nx.Map:Menu_OnRemoveTracking (item)
	for _, name in pairs (Nx.Map.PlyrNames) do
		self.TrackPlyrs[name] = nil
	end
end
function Nx.Map:Menu_OnReportPlyrAFK (item)
	local n = 0
	for k, v in pairs (Nx.Map.AFKers) do
		ReportPlayerIsPVPAFK (v)
		n = n + 1
	end
	Nx.prt ("%d reported", n)
end
function Nx.Map:Menu_OnGrowConflictBars (item)
	self.BGGrowBars = item:GetChecked()
end
function Nx.Map:GMenuOpen (icon, typ)
	self.GIconMenuITogInst:Show (false)
	self.GIconMenuIFindNote:Show (false)
	if typ == 3000 then
		if icon.UData then
			self.GIconMenuITogInst:Show()
		end
		if icon.FavData1 then
			self.GIconMenuIFindNote:Show()
		end
	end
	Nx.Quest:OpenGiverIconMenu (icon, typ)
	self.GIconMenu:Open()
end
function Nx.Map:GMenu_OnTogInst()
	local icon = self.ClickIcon
	local mapId = icon.UData
	if mapId then
		if self.InstMapId == mapId then
			self:SetInstanceMap()
		else
			
			self:SetInstanceMap (mapId)
		end
	end
end
function Nx.Map:GMenu_OnFindNote()
	Nx.Fav:ShowIconNote (self.ClickIcon)
end
function Nx.Map:GMenu_OnGoto()
	Nx.Quest.Watch:ClearAutoTarget()
	if self.ClickType == 3001 then
		Nx.Social:GotoPunk (self.ClickIcon)
	else
		local icon = self.ClickIcon
		local x = icon.X
		local y = icon.Y
		local name = icon.Tip and strsplit ("\n", icon.Tip) or ""
		self:SetTarget ("Goto", x, y, x, y, false, 0, name)
	end
end
function Nx.Map:GMenu_OnPasteLink()
	local name
	if self.ClickType == 3001 then
		name = Nx.Social:GetPunkPasteInfo (self.ClickIcon)
	else
		local icon = self.ClickIcon
		name = gsub (icon.Tip, "\n", ", ")
	end
	name = gsub (name, "|cff......", "")
	name = gsub (name, "|r", "")
	local frm = DEFAULT_CHAT_FRAME
	local eb = frm["editBox"]
	if eb:IsVisible() then
		eb:SetText (eb:GetText() .. name)
	else
		Nx.prt ("No edit box open!")
	end
end
function Nx.Map:BGMenu_OnIncoming (item)
	self:BGMenu_Send (NXlBGMsgIncoming)
end
function Nx.Map:BGMenu_OnClear (item)
	self:BGMenu_Send ("Clear")
end
function Nx.Map:BGMenu_OnHelp (item)
	self:BGMenu_Send ("Help")
end
function Nx.Map:BGMenu_OnAttack (item)
	self:BGMenu_Send ("Attack")
end
function Nx.Map:BGMenu_OnGuard (item)
	self:BGMenu_Send ("Guard")
end
function Nx.Map:BGMenu_OnLosing (item)
	self:BGMenu_Send ("Losing")
end
function Nx.Map:BGMenu_OnStatus (item)
	local id, x, y, str = strsplit ("~", self.BGMsg)
	if id == "1" then
		self:BGMenu_Send()
	else
		Nx.prt ("No Status")
	end
end
function Nx.Map:BGMenu_Send (msg)
	local id, tx, ty, str = strsplit ("~", self.BGMsg)
	tx, ty = self:GetWorldPos (self.RMapId, tonumber (tx), tonumber (ty))
	local members = MAX_PARTY_MEMBERS
	local unitName = "party"
	if Nx.GetNumRaidMembers() > 0 then
		members = MAX_RAID_MEMBERS
		unitName = "raid"
	end
	local cnt = 0
	local maxDist = (100 / 4.575) ^ 2	
	for i = 1, members do
		local unit = unitName..i
		local pX, pY = GetPlayerMapPosition (unit)
		if (pX > 0 or pY > 0) and not UnitIsDeadOrGhost (unit) then
			local x, y = self:GetWorldPos (self.RMapId, pX * 100, pY * 100)
			local dist = (tx - x) ^ 2 + (ty - y) ^ 2
			if dist <= maxDist then
				cnt = cnt + 1
			end
		end
	end
	local dstr = L", No "
	if cnt > 0 then
		dstr = format (L", %d ", cnt)
	end
	
	dstr = format(L"%s comrades in area", dstr)  
	if msg then
		SendChatMessage ("[\231\189\145 \230\152\147\230\156\137\231\136\177\230\138\165\229\145\138] " .. msg .. " -> " .. str .. dstr, "BATTLEGROUND")
	else
		SendChatMessage (str .. dstr, "BATTLEGROUND")
	end
end
function Nx.Map:BGIncSendTimer()
	local str = format (L"Inc %s", self.BGIncNum)
	self:BGMenu_Send (str)
	self.BGIncNum = 0
end
function Nx.Map:BlizzToggleWorldMap()
	if WorldMapFrame:IsShown() then
		HideUIPanel (WorldMapFrame)
	else
		local map = self:GetMap (1)
		map:DetachWorldMap()
		ShowUIPanel (WorldMapFrame)
	end
end
function Nx:NXMapKeyTogOriginal()
	
	Nx.Map.BlizzToggling = true
	NxToggleWorldMap() 
	Nx.Map.BlizzToggling = nil
end
function Nx:NXMapKeyTogNormalMax()
	Nx.Map:ToggleSize()
end
function Nx:NXMapKeyTogNoneMax()
	Nx.Map:ToggleSize (1)
end
function Nx:NXMapKeyTogNoneNormal()
	Nx.Map:ToggleSize (0)
end
function Nx.Map:ToggleSize (szmode)
	if not self.Maps then	
		return
	end
	local map = self:GetMap (1)
	local win = map.Win
	if not win:IsShown() then
		win:Show()
		if szmode == 0 then
			map:RestoreSize()
		elseif szmode == 1 then
			map:MaxSize()
		elseif self.GOpts["MapMaxCenter"] then
			map:MaxSize()
		end
	elseif szmode then
		win:Show (false)
	elseif not win:IsSizeMax() then
		map:MaxSize()
	else
		map:RestoreSize()
	end
	if Nx.TooltipOwner == win.Frm then
		GameTooltip:Hide()
		Nx.TooltipOwner = nil
	end
end
function Nx.Map:RestoreSize()
	self:MouseEnable (false)
	if self.Win:IsSizeMax() then
		self.Win:ToggleSize()
		self:RestoreView ("")
		self:DetachWorldMap()
		if self.GOpts["MapMaxRestoreHide"] then
			self.Win:Show (false)
		end
	end
	local wname = self:GetWinName()
	for n, name in pairs (UISpecialFrames) do
		if name == wname then
			tremove (UISpecialFrames, n)
			break
		end
	end
end
function Nx.Map:MaxSize()
	if not self.Win:IsSizeMax() then
		if NxData.NXDBMapMax then
			Nx.prt ("MapMax %s", debugstack (2, 4, 0))
		end
		self.Win:ToggleSize()
		self:SaveView ("")
		self:MouseEnable (true)
		if self.GOpts["MapMaxCenter"] then
			self:CenterMap()
		end
		self.StepTime = min (self.StepTime, 1)
	end
end
function Nx:NXMapKeyTogMiniFull()
	if Nx.Free then
		return
	end
	local map = Nx.Map:GetMap (1)
	map.LOpts.NXMMFull = not map.LOpts.NXMMFull
	map.MMZoomChanged = true
	map.MMMenuIFull:SetChecked (map.LOpts.NXMMFull)
	Nx.Menu:CheckUpdate (map.MMMenuIFull)
end
function Nx:NXMapKeyTogHerb()
	local map = Nx.Map:GetMap (1)
	Nx.CharOpts["MapShowGatherH"] = not Nx.CharOpts["MapShowGatherH"]
	map.MenuIShowHerb:SetChecked (Nx.CharOpts, "MapShowGatherH")
	map.Guide:UpdateGatherFolders()
end
function Nx:NXMapKeyTogMine()
	local map = Nx.Map:GetMap (1)
	Nx.CharOpts["MapShowGatherM"] = not Nx.CharOpts["MapShowGatherM"]
	map.MenuIShowMine:SetChecked (Nx.CharOpts, "MapShowGatherM")
	map.Guide:UpdateGatherFolders()
end
function Nx.Map:MouseEnable (max)
	local on = true
	if max then
		if self.GOpts["MapMaxMouseIgnore"] then
			on = IsAltKeyDown() and true or false		
		end
	else
		if self.GOpts["MapMouseIgnore"] then
			on = IsAltKeyDown() and true or false		
		end
	end
	if self.MouseEnabled ~= on then
		self.MouseEnabled = on
		self.Win:EnableMouse (on)
		if on then
			self.ButAutoScaleOn.Frm:Show()
			self:UpdateToolBar()		
		else
			self.ButAutoScaleOn.Frm:Hide()
			self.ToolBar.Frm:Hide()
		end
		self.Frm:EnableMouse (on)
		self.Frm:EnableMouseWheel (on)
		self.MMFrm:EnableMouse (on)
		self.MMFrm:EnableMouseWheel (on)
		for n, f in ipairs (self.IconFrms) do
			f:EnableMouse (on)
		end
		for n, f in ipairs (self.IconStaticFrms) do
			f:EnableMouse (on)
		end
	end
end
function Nx.Map:OnEvent (event, ...)
	local this = self.Win.Frm
	if event == "WORLD_MAP_UPDATE" then
		if Nx.Quest then
			Nx.Quest:MapChanged()
		end
		if this:IsVisible() then
			this.NxMap:UpdateAll()
		end
	end
end
function Nx.Map:OnMouseDown (button)
	local map = self.NxMap	
	local this = map.Frm
	local x, y = GetCursorPosition()
	x = x / this:GetEffectiveScale()
	y = y / this:GetEffectiveScale()
	map:CalcClick()
	ResetCursor()
	
	if button == "LeftButton" then
	
		if map["DebugHotspots"] then
			map.HotspotDebugCurT = nil
			if map:IsDoubleClick() then
				map.DebugMapId = map.MapId
			else
				map.LClickTime = GetTime()
				map.Scrolling = true
				map.ScrollingX = x
				map.ScrollingY = y
				map.ScrollingFrm = map.ClickFrm
			end
			return
		end
	
		if IsControlKeyDown() and map:CallFunc ("MapButLCtrl") then	
		elseif IsAltKeyDown() and map:CallFunc ("MapButLAlt") then	
		elseif IsShiftKeyDown() then
			map:Ping()
		else
			if map:IsDoubleClick() then
				map:CenterMap()
				map.DebugMapId = map.MapId
			else
				map.LClickTime = GetTime()
				map.Scrolling = true
				map.ScrollingX = x
				map.ScrollingY = y
				map.ScrollingFrm = map.ClickFrm
			end
		end
	elseif button == "MiddleButton" then
		if IsControlKeyDown() then
			map:CallFunc ("MapButMCtrl")
		elseif IsAltKeyDown() then
			map:CallFunc ("MapButMAlt")
		else
			map:CallFunc ("MapButM")
		end
	elseif button == "RightButton" then
		if IsControlKeyDown() and map:CallFunc ("MapButRCtrl") then
		elseif IsAltKeyDown() and map:CallFunc ("MapButRAlt") then
		else
			map:CallFunc ("MapButR")
		end
	elseif button == "Button4" then
		if IsControlKeyDown() then
			map:CallFunc ("MapBut4Ctrl")
		elseif IsAltKeyDown() then
			map:CallFunc ("MapBut4Alt")
		else
			map:CallFunc ("MapBut4")
		end
	end
end
function Nx.Map:CalcClick()
	local f = self.Frm
	local x, y = GetCursorPosition()
	x = x / f:GetEffectiveScale()
	y = y / f:GetEffectiveScale()
	self.ClickFrmX = x - f:GetLeft()
	self.ClickFrmY = f:GetTop() - y
end
function Nx.Map:IsDoubleClick()
	if GetTime() - self.LClickTime < .5 then
		self.LClickTime = 0
		return true
	end
end
function Nx.Map:OpenMenu()
	local opts = self:GetOptionsT (self.MapIndex)
	self.MenuIPlyrFollow:SetChecked (self.CurOpts.NXPlyrFollow)
	self.MenuIShowWorld:SetChecked (self.CurOpts.NXWorldShow)
	self.MenuIMonitorZone:SetChecked (Nx.Com:IsZoneMonitored (self.MapId))
	self.MenuMapId = self.MapId
	self.Menu:Open()
end
function Nx.Map:OnMouseUp (button)
	local this = self			
	local map = this.NxMap
	map.Scrolling = false
end
function Nx.Map:ClickZoomIn()
	self:MouseWheel (3)
end
function Nx.Map:ClickZoomOut()
	self:MouseWheel (-3)
end
function Nx.Map:OnMouseWheel (value)
	self.NxMap:MouseWheel (value)
end
function Nx.Map:MouseWheel (value)
	local map = self
	local this = map.Frm
	if map.MMZoomType == 0 and Nx.Util_IsMouseOver (map.MMFrm) then
		map.MMZoomChanged = true
		local i = map.GOpts["MapMMDockZoom"]
		if value < 0 then
			i = max (i - 1, 0)
		else
			i = min (i + 1, 5)
		end
		map.GOpts["MapMMDockZoom"] = i
		return
	end
	local x, y = GetCursorPosition()
	x = x / this:GetEffectiveScale()
	y = y / this:GetEffectiveScale()
	local left = this:GetLeft()
	local rgt = this:GetRight()
	local top = this:GetTop()
	local bot = this:GetBottom()
	local ox = map.MapPosX + (x - left - map.PadX - map.MapW / 2) / map.Scale
	local oy = map.MapPosY + (top - y - map.TitleH - map.MapH / 2) / map.Scale
	map.Scale = map:ScrollScale (value)
	map.StepTime = 10
	map.MapScale = map.Scale / 10.02  
	local nx = map.MapPosX + (x - left - map.PadX - map.MapW / 2) / map.Scale
	local ny = map.MapPosY + (top - y - map.TitleH - map.MapH / 2) / map.Scale
	map.MapPosX = map.MapPosX + ox - nx
	map.MapPosY = map.MapPosY + oy - ny
end
function Nx.Map:ScrollScale (value)
	local s = self.Scale
	if value < 0 then
		value = value * .76923
	end
	return math.max (s + value * s * .3, .015)
end
function Nx.Map:SetScaleOverTime (steps)
	local step = steps >= 0 and 1 or -1
	for n = 1, abs (steps) do
		self.Scale = self:ScrollScale (step)
	end
	self.StepTime = 10
end
function Nx.Map.OnUpdate (this, elapsed)	
    
    if(Nx._MapUpdateThrottle and Nx._MapUpdateInterval and Nx._MapUpdateInterval>0)then
        this.ela = this.ela or 0 
        if(this.ela<Nx._MapUpdateInterval)then this.ela=this.ela+elapsed return end
        elapsed = this.ela
        this.ela=0
    end
	local Nx = Nx
	Nx.Timer:ProfilerStart ("Map OnUpdate")
	local profileTime = GetTime()
	local map = this.NxMap
	local gopts = map.GOpts
	local Quest = Nx.Quest
	map.Tick = map.Tick + 1 if map.Tick>32767 then map.Tick = 0 end
	map.EffScale = this:GetEffectiveScale()
	map.Size1 = gopts["MapLineThick"] * .75 / map.EffScale
	Nx.Map:UpdateOptions (map.MapIndex)
	local winx, winy = Nx.Util_IsMouseOver (this)
	if not this:IsVisible() or not map.MouseEnabled then
		winx = nil
		map.Scrolling = false
	end
	if map.MMZoomType == 0 and Nx.Util_IsMouseOver (map.MMFrm) then
		winx = nil
	end
	map.MouseIsOver = winx
	
	if map.Scrolling then
		local cx, cy = GetCursorPosition()
		cx = cx / map.EffScale
		cy = cy / map.EffScale
		local x = cx - map.ScrollingX
		local y = cy - map.ScrollingY
		
		if map["DebugHotspots"] or (map.Debug and IsAltKeyDown()) then
			if map:OnButScrollDebug (0, 0, x, -y) then
				x = 0
				y = 0
			end
		end
		
		if x ~= 0 or y ~= 0 then		
			map.LClickTime = 0
		end
		map.ScrollingX = cx
		map.ScrollingY = cy
		local left = this:GetLeft()
		local top = this:GetTop()
		local mx = x / map.ScaleDraw
		local my = y / map.ScaleDraw
		map.MapPosXDraw = map.MapPosXDraw - mx
		map.MapPosYDraw = map.MapPosYDraw + my
		map.MapPosX = map.MapPosXDraw
		map.MapPosY = map.MapPosYDraw
		map.Scale = map.ScaleDraw
	end
	map:Update (elapsed)
	
	local title = ""
	if gopts["MapShowTitleName"] then
		title = map:IdToName (map.RMapId)
		for n = 1, GetMaxBattlefieldID() do		
			local status, _, instId = GetBattlefieldStatus (n)
			if status == "active" then
				title = title .. format (" #%s", instId)
				break
			end
		end
	end
	if gopts["MapShowTitleXY"] then
		if map.DebugFullCoords then
			title = title .. format (" %4.2f, %4.2f", map.PlyrRZX, map.PlyrRZY)
		else
			title = title .. format (" %4.1f, %4.1f", map.PlyrRZX, map.PlyrRZY)
		end
	end
	if map.PlyrSpeed > 0 and gopts["MapShowTitleSpeed"] then
		local speed = map.PlyrSpeed
		local sa = Nx.Map.MapWorldInfo[map.MapId].ScaleAdjust
		if sa then
			speed = speed * sa
		end
		speed = speed / 6.4 * 100 - 100
		if abs (speed) < .5 then	
			speed = 0
		end
		title = title..format (L" |cffa0a0a0Speed %+.0f%%", speed)
	end
	local cursorLocStr = ""
	local cursorLocXY = ""
	local menuOpened = Nx.Menu:IsAnyOpened()
    
	if winx then
		map.BackgndAlphaTarget = map.BackgndAlphaFull
		winy = this:GetHeight() - winy
		if winy >= map.TitleH then
			local wx, wy = map:FramePosToWorldPos (winx, winy)
			if not menuOpened then
				map:CheckWorldHotspots (wx, wy)
			end
			local x, y = map:GetZonePos (map.MapId, wx, wy)
			x = floor (x * 10) / 10	
			y = floor (y * 10) / 10
			local dist = ((wx - map.PlyrX) ^ 2 + (wy - map.PlyrY) ^ 2) ^ .5 * 4.575
			cursorLocXY = format (L"|cff80b080%.1f %.1f %.0f yds", x, y, dist)
			cursorLocStr = cursorLocXY
			local name = UpdateMapHighlight (x / 100, y / 100)
			if name then
				cursorLocStr = format ("%s\n|cffafafaf%s", cursorLocStr, name)
			end
		end
	else
		if not map.Scrolling and not menuOpened then
			map.BackgndAlphaTarget = map.BackgndAlphaFade
			local rid = map:GetRealMapId()
			if rid ~= 9000 and not WorldMapFrame:IsShown() then
				local mapId = map:GetCurrentMapId()
				if map:IsInstanceMap (rid) then
					if not Nx.Map.InstanceInfo[rid] then		
						rid = Nx.Map.MapWorldInfo[rid].EntryMId
					end
					local lvl = GetCurrentMapDungeonLevel()
					if lvl ~= map.InstLevelSet then
						mapId = 0	
					end
				end
				if mapId ~= rid then
			
					
					
					if map:IsBattleGroundMap (rid) then
						
						map:GotoCurrentZone()
					else
						if GetPlayerMapPosition("player")>0 then
							
							map:SetCurrentMap (rid)
                        end
					end
				end
			end
		end
	end
	
	if map.Guide.Win.Frm:IsVisible() or Quest.List.Win and Quest.List.Win.Frm:IsVisible() then
		map.BackgndAlphaTarget = map.BackgndAlphaFull
	end
	
	if map.DebugTime then
		profileTime = GetTime() - profileTime
		local t = map.DebugProfileTime or .01
		t = t * .95 + profileTime * .05
		map.DebugProfileTime = t
		UpdateAddOnMemoryUsage()
		local mem = GetAddOnMemoryUsage ("Carbonite")
		local memdif = mem - (map.DebugMemUse or 0)
		map.DebugMemUse = mem
		title = title..format (L" Time %.4f Mem %d %.4f", t, mem, memdif)
	end
	if false and GetCVar ("scriptProfile") == "1" then
		UpdateAddOnCPUUsage()
		title = title..format (L" |cffffffffCPU %6.3f %6.3f", GetAddOnCPUUsage ("CARBONITE"), GetScriptCPUUsage())
		ResetCPUUsage()
	end
	
	if map.Tick % 3 == 0 then	
		local tip = format (" %s", cursorLocStr)
		if map.Debug and winx then
			local x, y = map:FramePosToWorldPos (winx, winy)
			tip = tip .. format (L"\n|cffc080a0%.2f WXY %6.2f %6.2f PXY %6.2f %6.2f", map.Scale, x, y, map.PlyrX, map.PlyrY)
			map.DebugWX = x
			map.DebugWY = y
		end
		local over = winx and not Nx.Util_IsMouseOver (map.ToolBar.Frm)
		map:SetLocationTip (over and not menuOpened and map.WorldHotspotTipStr and (map.WorldHotspotTipStr .. tip))
	end
	if map.Win:IsSizeMax() then
		local s = Nx.Quest:GetZoneAchievement (true)
		if s then
			title = title .. "  " .. s
		end
	end
	map.Win:SetTitle (title, 1)
	if map.GOpts["MapShowTitle2"] then
		local s = GetSubZoneText()
		local pvpType = GetZonePVPInfo()
		if pvpType then
			s = s .. " (" .. pvpType .. ")"
		end
		map.Win:SetTitle (format ("%s %s", s, cursorLocXY), 2)
	end
	Nx.Timer:ProfilerEnd ("Map OnUpdate")
end
function Nx.Map:UpdateAll()
	self.NeedWorldUpdate = true
end
function Nx.Map:UpdateWorld()
	if self.Debug then
		Nx.prt ("%d Map UpdateWorld1 %d L%d",
				self.Tick, self:GetCurrentMapId(), GetCurrentMapDungeonLevel())
	end
	self.NeedWorldUpdate = false
	local mapId = self:GetCurrentMapId()
	
	
	local i = self:GetExploredOverlayNum()
	if self.CurWorldUpdateMapId == mapId and i == self.CurWorldUpdateOverlayNum and GetCurrentMapDungeonLevel()==self.LastDungeonLevel then
		return
	end
	self.LastDungeonLevel = GetCurrentMapDungeonLevel()
	self.CurWorldUpdateMapId = mapId
	self.CurWorldUpdateOverlayNum = i
	local mapFileName,_,_,isMacro,microTex = GetMapInfo() 
	if not mapFileName then
		if GetCurrentMapContinent() == WORLDMAP_COSMIC_ID then
			mapFileName = "Cosmic"
		else
			mapFileName = "World"
		end
	end
    local texPath = "Interface\\WorldMap\\"..(isMacro and "MicroDungeon\\"..mapFileName.."\\"..microTex or mapFileName).."\\"
    local texName = microTex or mapFileName
	self:UpdateOverlayUnexplored()
	if self.Debug then
		Nx.prt ("%d Map UpdateWorld %d", self.Tick, self:GetCurrentMapId())
		Nx.prt (" File %s", mapFileName)
	end
	Nx.UEvents:UpdateMap (true)
    local dungeonLevel = GetCurrentMapDungeonLevel();
    if (DungeonUsesTerrainMap()) then
        dungeonLevel = dungeonLevel - 1;
    end
    if dungeonLevel>0 then texName = texName..dungeonLevel.."_" end
	
	
	
		for i = 1, 12 do
			self.TileFrms[i].texture:SetTexture (texPath..texName..i)
		end
	
end
function Nx.Map:WinUpdateFade (fade)
	self.ToolBar:SetFade (fade)
	self.ButAutoScaleOn.Frm:SetAlpha (fade)
end
function Nx.Map:Update (elapsed)
	local Nx = Nx
	local Map = Nx.Map
	self:MouseEnable (self.Win:IsSizeMax())
	if self.NeedWorldUpdate then
		self:UpdateWorld()
	end
	self.MapW = self.Frm:GetWidth() - self.PadX * 2
	self.MapH = self.Frm:GetHeight() - self.TitleH
	self.Level = self.Frm:GetFrameLevel() + 1
	local mapId = self:GetCurrentMapId()
	self.Cont, self.Zone = self:IdToContZone (mapId)
	Nx.InSanctuary = GetZonePVPInfo() == "sanctuary"
	local doSetCurZone
	local mapChange
	if self.MapId ~= mapId then
		if self.Debug then
			Nx.prt ("%d Map change %d to %d", self.Tick, self.MapId, mapId)
		end
		self.CurMapBG = self:IsBattleGroundMap (mapId)
		if not self:IsBattleGroundMap (self.MapId) then
			self:AddOldMap (mapId)
		end
		self.MapId = mapId
		mapChange = true
		Nx.Com.PlyrChange = GetTime()
	end
	local rid = self:GetRealMapId() 
	local inBG = self:IsBattleGroundMap (rid)
	if Nx.InBG and Nx.InBG ~= rid then	
		local cb = Nx.Combat
		if Nx.InArena then
			local s = Nx.Map:GetShortName (Nx.InArena)
			Nx.UEvents:AddInfo (format (L"Left %s %d %d %dD %dH", s, cb.KBs, cb.Deaths, cb.DamDone, cb.HealDone))
		else
			local total = cb.KBs + cb.Deaths + cb.HKs + cb.Honor
			if total > 0 then
				local sname = Nx.Map:GetShortName (Nx.InBG)
				Nx.UEvents:AddInfo (format (L"Left %s %d %d %d %d", sname, cb.KBs, cb.Deaths, cb.HKs, cb.Honor))
				local tm = GetTime() - cb.BGEnterTime
				local _, honor = GetCurrencyInfo (392)		
				local hGain = honor - cb.BGEnterHonor
				Nx.UEvents:AddInfo (format (L" %s +%d honor, +%d hour", Nx.Util_GetTimeElapsedMinSecStr (tm), hGain, hGain / tm * 3600))
				local xpGain = UnitXP ("player") - cb.BGEnterXP
				if xpGain > 0 then
					Nx.UEvents:AddInfo (format (L" +%d xp, +%d hour", xpGain, xpGain / tm * 3600))
				end
			end
		end
		cb.KBs = 0
		cb.Deaths = 0
		cb.HKs = 0
		cb.Honor = 0
		Nx.InBG = nil
		if Nx.InArena then
			self.LOpts.NXMMFull = false
		end
		Nx.InArena = nil
	end
	if inBG and Nx.InBG ~= rid then
		Nx.InBG = rid
		local cb = Nx.Combat
		cb.BGEnterTime = GetTime()
		local _, honor = GetCurrencyInfo (392)		
		cb.BGEnterHonor = honor
		cb.BGEnterXP = UnitXP ("player")
		if self.MapWorldInfo[rid].Arena then
			Nx.InArena = rid
			self.LOpts.NXMMFull = true
		end
		doSetCurZone = true
	end
	
	local ontaxi = UnitOnTaxi ("player")
	if ontaxi then
		if not Map.TaxiOn then	
			Map.TaxiStartTime = GetTime()
			Map.TaxiOn = true
			if NxData.DebugMap then
				Nx.prt ("Taxi start")
			end
		end
	elseif Map.TaxiOn then	
		Map.TaxiOn = false
		Map.TaxiX = nil		
		local tm = GetTime() - Map.TaxiStartTime
		Nx.Travel:TaxiSaveTime (tm)
		if NxData.DebugMap then
			Nx.prt ("Taxi time %.1f seconds", tm)
		end
	end
	
	if self.RMapId ~= rid then
		if rid ~= 9000 then
			if self.RMapId == 9000 then	
				self.CurOpts = nil
				self:SwitchOptions (rid, true)
			end
			self.RMapId = rid
			self:SwitchOptions (rid)
			self:SwitchRealMap (rid)
		end
	end
	local plZX, plZY = GetPlayerMapPosition ("player")
	self.InstanceId = false
	if self:IsInstanceMap (rid) then
		self.InstanceId = rid
		plZX = plZX * 100
		plZY = plZY * 100
		self.PlyrRZX = plZX
		self.PlyrRZY = plZY
		local x, y = self:GetWorldPos (rid, 0, 0)
		local lvl = max (GetCurrentMapDungeonLevel(), 1)		
		if not self.InstMapId then		
			plZX = 0
			plZY = 0
		elseif plZX == 0 and plZY == 0 then
			self.InstLevelSet = -1
		end
		local _, first = GetNumDungeonMapLevels() first = max(first, 1)   
		self.PlyrX = x + plZX * 1002 / 25600
		self.PlyrY = y + plZY * 668 / 25600 + (lvl - first) * 668 / 256
		self.PlyrSpeed = 0
	elseif plZX > 0 or plZY > 0 then	
		plZX = plZX * 100
		plZY = plZY * 100
		local x, y = self:GetWorldPos (mapId, plZX, plZY)
		if elapsed > 0 then
			if x == self.PlyrX and y == self.PlyrY then	
				self.PlyrSpeedCalcTime = GetTime()
				self.PlyrSpeed = 0
				self.PlyrSpeedX = x
				self.PlyrSpeedY = y
			else
				local tmDif = GetTime() - self.PlyrSpeedCalcTime
				if tmDif > .5 then
					self.PlyrSpeedCalcTime = GetTime()
					self.PlyrSpeed = ((x - self.PlyrSpeedX) ^ 2 + (y - self.PlyrSpeedY) ^ 2) ^ .5 * 4.575 / tmDif
					self.PlyrSpeedX = x
					self.PlyrSpeedY = y
				end
			end
		end
		self.PlyrX = x
		self.PlyrY = y
		if mapId ~= rid then			
			plZX, plZY = self:GetZonePos (rid, x, y)
		end
		self.PlyrRZX = plZX
		self.PlyrRZY = plZY
		if mapChange then
			self.MoveLastX = x
			self.MoveLastY = y
		end
	end
	self.PlyrDir = 360 - GetPlayerFacing() / 2 / math.pi * 360
	local plX = self.PlyrX
	local plY = self.PlyrY
	local x = plX - self.MoveLastX
	local y = plY - self.MoveLastY
	local ang = self.PlyrDir - self.PlyrLastDir
	local moveDist = (x * x + y * y) ^ .5
	if moveDist >= .01 * self.BaseScale or abs (ang) > .01 then
		Nx.Com.PlyrChange = GetTime()
		if self.MoveLastX ~= -1 then
			self.MoveDir = math.deg (math.atan2 (x, -y / 1.5))
		end
		self.MoveLastX = plX
		self.MoveLastY = plY
		self.PlyrLastDir = self.PlyrDir
		if not self.Scrolling and not self.MouseIsOver and not WorldMapFrame:IsVisible() then
			if self.CurOpts.NXPlyrFollow then
				local scOn = self.LOpts.NXAutoScaleOn		
				if plZX ~= 0 or plZY ~= 0 then
					if #self.Tracking == 0 or not scOn then
						self:Move (plX, plY, nil, 30) 
					end
				end
				if scOn then
					local midX
					local midY
					local dtx
					local dty
					local cX, cY = GetCorpseMapPosition()
					if cX ~= 0 or cY ~= 0 then
						midX, midY = self:GetWorldPos (mapId, cX * 100, cY * 100)
						dtx = 1
						dty = 1
					elseif #self.Tracking > 0 then
						local tr = self.Tracking[1]
						midX = tr.TargetMX
						midY = tr.TargetMY
						dtx = abs (tr.TargetX1 - tr.TargetX2)
						dty = abs (tr.TargetY1 - tr.TargetY2)
					elseif Map.TaxiX then
						midX, midY = self.TaxiX, self.TaxiY
						dtx = 1
						dty = 1
					end
					if midX then
						local mX = (midX + self.PlyrX) * .5
						local mY = (midY + self.PlyrY) * .5
						local dx = abs (midX - self.PlyrX)
						local dy = abs (midY - self.PlyrY)
						
						dx = dx>0 and self.MapW / dx or 1e+10
						dy = dy>0 and self.MapH / dy or 1e+10
						local scale = min (dx, dy) * .5
						
						
						if dtx~=0 and dty~=0 then
							dx = self.MapW / dtx
							dy = self.MapH / dty
							scale = min (min (dx, dy), scale)	
						end
						local scmax = self.InstanceId and 800 or self.LOpts.NXAutoScaleMax
						scale = max (min (scale, scmax), self.LOpts.NXAutoScaleMin)
						self:Move (mX, mY, scale, 30)
					end
				end
				if rid ~= mapId then
					doSetCurZone = true
				end
			end
		end
	end
    
    
    
    
    
    
    
	
	local scaleDiff = abs (self.ScaleDraw - self.Scale)
	local xDiff = self.MapPosXDraw - self.MapPosX
	local yDiff = self.MapPosYDraw - self.MapPosY
	if self.StepTime ~= 0 and (scaleDiff > 0 or xDiff ~= 0 or yDiff ~= 0) then
		if self.StepTime > 0 then
			self.StepTime = -self.StepTime
			self.ScaleDrawW = 1 / self.ScaleDraw
			self.ScaleW = 1 / self.Scale
		end
		local st = -self.StepTime
        local delta = ceil(elapsed*50) 
        if(self.StepTime+delta>0)then delta=0-self.StepTime end
		self.MapPosXDraw = Nx.Util_StepValue (self.MapPosXDraw, self.MapPosX, abs (xDiff) / st * delta)
		self.MapPosYDraw = Nx.Util_StepValue (self.MapPosYDraw, self.MapPosY, abs (yDiff) / st * delta)
		self.ScaleDrawW = Nx.Util_StepValue (self.ScaleDrawW, self.ScaleW, abs (self.ScaleDrawW - self.ScaleW) / st * delta)
		self.ScaleDraw = 1 / self.ScaleDrawW
		self.StepTime = self.StepTime + 1 * delta
	end
	local _, zx, zy, zw = self:GetWorldZoneInfo (self.Cont, self.Zone)
	if zx then
		self.MapScale = self.Scale / 10.02
	end
	
	local plSize = self.GOpts["MapPlyrArrowSize"]
	if IsShiftKeyDown() then
		plSize = 5
	end
	self.PlyrFrm:Show()
	self:ClipFrameW (self.PlyrFrm, self.PlyrX, self.PlyrY, plSize, plSize, self.PlyrDir)
	self.InCombat = UnitAffectingCombat ("player")
	local g = 1
	local b = 1
	local al = 1
	if self.InCombat then
		g = 0
		b = 0
		al = abs (GetTime() % 1 - .5) / .5 * .5 + .4
	end
	self.PlyrFrm.texture:SetVertexColor (1, g, b, al)
	
	self.BackgndAlpha = Nx.Util_StepValue (self.BackgndAlpha, self.BackgndAlphaTarget, .05)
	self.Frm.texture:SetVertexColor (1, 1, 1, self.BackgndAlpha)
    
	self:ResetIcons()
	self:MoveContinents()
	self:UpdateZones(elapsed)
	self:UpdateInstanceMap()
	self:MinimapUpdate()
	self:UpdateWorldMap()
	self:DrawContinentsPOIs()
	if self.GOpts["MapShowTrail"] then
		self:UpdatePlyrHistory()
	end
	if self.GOpts["MapShowPunks"] then
		Nx.Social:UpdateIcons (self)
	end
	
	if self["DebugHotspots"] then
		self:UpdateHotspotsDebug()
	end
	
	
	local vtex = _G["VEHICLE_TEXTURES"]
	for n = 1, GetNumBattlefieldVehicles() do
		local x, y, unitName, possessed, typ, orientation, player = GetBattlefieldVehicleInfo (n)
		if x and x > 0 and not player then
			if vtex[typ] then
				local f2 = self:GetIconNI (1)
				local sc = self.ScaleDraw * .8		
				if typ == "Drive" or typ == "Fly" then
					sc = 1
				end
				if self:ClipFrameZ (f2, x * 100, y * 100, vtex[typ]["width"] * sc, vtex[typ]["height"] * sc, orientation / PI * -180) then
					f2.texture:SetTexture (WorldMap_GetVehicleTexture (typ, possessed))
				end
			end
		end
	end
	
	local oldLev = self.Level
	if IsShiftKeyDown() then
		oldLev = oldLev - 4
		self.Level = self.Level + 16
	end
	local name, description, txIndex, pX, pY
	local txX1, txX2, txY1, txY2
	local poiNum = GetNumMapLandmarks()
	for i = 1, poiNum do
		name, desc, txIndex, pX, pY = GetMapLandmarkInfo (i)
		if txIndex ~= 0 then		
			local tip = name
			if desc then
				tip = format ("%s\n%s", name, desc)
			end
			pX = pX * 100
			pY = pY * 100
			local f = self:GetIcon (3)
			if self.CurMapBG then
				f.NXType = 2000
				local iconType = Nx.MapPOITypes[txIndex]
				local sideStr = ""
				if iconType == 1 then	
					sideStr = L" (Ally)"
				elseif iconType == 2 then	
					sideStr = L" (Horde)"
				end
				if desc == NXlINCONFLICT then
					local state = self.BGTimers[name]
					if state ~= txIndex then
						self.BGTimers[name] = txIndex
						self.BGTimers[name.."#"] = GetTime()
					end
					local dur = GetTime() - self.BGTimers[name.."#"]
					local doneDur = (rid == 9001 or rid == 9009 or rid == 9010) and 64 or 241
					local leftDur = max (doneDur - dur, 0)
					local tmStr
					if leftDur < 60 then
						tmStr = format (":%02d", leftDur)
					else
						tmStr = format ("%d:%02d", floor (leftDur / 60), floor (leftDur % 60))
					end
					f.NXData = format ("1~%f~%f~%s%s %s", pX, pY, name, sideStr, tmStr)
					tip = format ("%s\n%s", tip, tmStr)
					
					local sz = 30 / self.ScaleDraw
					local f2 = self:GetIcon (0)
					self:ClipFrameZTLO (f2, pX, pY, sz, sz, -15, -15)
					f2.texture:SetTexture (0, 0, 0, .35)
					f2.NXType = 2000
					f2.NxTip = tip
					f2.NXData = f.NXData
					local f2 = self:GetIconNI (1)
					if leftDur < 10 then
						if self.BGGrowBars then
							local al = abs (GetTime() % .4 - .2) / .2 * .2 + .8
							local f3 = self:GetIconNI (2)
							self:ClipFrameZTLO (f3, pX, pY, sz * (10 - leftDur) * .1, 3 / self.ScaleDraw, -15, -15)
							f3.texture:SetTexture (.5, 1, .5, al)
							local f3 = self:GetIconNI (2)
							self:ClipFrameZTLO (f3, pX, pY, sz * (10 - leftDur) * .1, 3 / self.ScaleDraw, -15, 12)
							f3.texture:SetTexture (.5, 1, .5, al)
						end
					end
					local red = .3
					local blue = 1
					if iconType == 2 then	
						red = 1
						blue = .3
					end
					f2.texture:SetTexture (red, .3, blue, abs (GetTime() % 2 - 1) * .5 + .5)
					local per = leftDur / doneDur
					local vper = per > .1 and 1 or per * 10
					if self.BGGrowBars then
						per = 1 - per
						vper = 1
					else
						per = max (per, .1)
					end
					self:ClipFrameZTLO (f2, pX, pY, sz * per, sz * vper, -15, -15)
				else	
					f.NXData = format ("0~%f~%f~%s%s", pX, pY, name, sideStr)
					self.BGTimers[name] = nil
					
					local sz = 30 / self.ScaleDraw
					local f2 = self:GetIcon (0)
					self:ClipFrameZTLO (f2, pX, pY, sz, sz, -15, -15)
					if iconType == 1 then	
						f2.texture:SetTexture (0, 0, 1, .3)
					elseif iconType == 2 then	
						f2.texture:SetTexture (1, 0, 0, .3)
					else
						f2.texture:SetTexture (0, 0, 0, .3)
					end
					f2.NXType = 2000
					f2.NxTip = tip
					f2.NXData = f.NXData
				end
			end
			f.NxTip = tip
			self:ClipFrameZ (f, pX, pY, 16, 16, 0)
			f.texture:SetTexture ("Interface\\Minimap\\POIIcons")
			txX1, txX2, txY1, txY2 = GetPOITextureCoords (txIndex)
			f.texture:SetTexCoord (txX1 + .003, txX2 - .003, txY1 + .003, txY2 - .003)
			f.texture:SetVertexColor (1, 1, 1, 1)
		end
	end
	self.Level = oldLev + 4
	
	
	
	
	
	
	
	Nx.HUD:Update (self)
	local comTrackName, comTrackX, comTrackY = Nx.Com:UpdateIcons (self)
	self.Level = self.Level + 2
	self.Guide:UpdateZonePOIIcons()
	Nx.Fav:UpdateIcons()
	self:UpdateIcons (self.KillShow)
	self.Level = self.Level - 2
	if Nx.Quest.Enabled then
		Nx.Quest:UpdateIcons (self)
	end
	self.Level = self.Level + 7
	
	
	local fX, fY, fToken
	local flagNum = GetNumBattlefieldFlagPositions()
	for i = 1, flagNum do
		fX, fY, fToken = GetBattlefieldFlagPosition (i)
		if fX ~= 0 or fY ~= 0 then
			local f = self:GetIconNI()
			f.texture:SetTexture ("Interface\\WorldStateFrame\\"..fToken)
			self:ClipFrameZ (f, fX * 100, fY * 100, 36, 36, 0)
		end
	end
	self.Level = self.Level + 1
	
	local palName, palX, palY = self:UpdateGroup (plX, plY)
	
	if self.PlyrSpeed == 0 then
		self.ArrowScroll = self.ArrowScroll + .01
		if self.ArrowScroll >= 1 then
			self.ArrowScroll = 0
		end
	end
	
	self.TrackDir = false
	self.Guide:OnMapUpdate()	
	if #self.Targets > 0 then
		self:UpdateTargets()
		self:UpdateTracking()
		self.Level = self.Level + 2
	end
	self.TrackETA = false
	local cX, cY = GetCorpseMapPosition()
	if (cX > 0 or cY > 0) and not inBG then	
		if self.GOpts["HUDATCorpse"] then
			self.TrackName = L"Corpse"
			local x, y = self:GetWorldPos (mapId, cX * 100, cY * 100)
			self:DrawTracking (plX, plY, x, y, false, "D")
			local f = self:GetIcon (1)
			f.NxTip = L"Your corpse"
			f.texture:SetTexture ("Interface\\Minimap\\POIIcons")
			self:ClipFrameZ (f, cX * 100, cY * 100, 16, 16, 0)
			
			f.texture:SetTexCoord (.502, .5605, 0, .0605)	
			self.Level = self.Level + 2
		end
	elseif ontaxi and Map.TaxiX then
		if self.GOpts["HUDATTaxi"] then
			self.TrackName = Map.TaxiName
			self.TrackETA = Map.TaxiETA
			local x, y = self.TaxiX, self.TaxiY
			self:DrawTracking (plX, plY, x, y, false, "F")
			local f = self:GetIcon (1)
			f.NxTip = Map.TaxiName
			f.texture:SetTexture ("Interface\\Icons\\Ability_Mount_Wyvern_01")
			self:ClipFrameW (f, x, y, 16, 16, 0)
			self.Level = self.Level + 2
		end
	end
	
	if (palX or comTrackX) and (inBG or next (self.TrackPlyrs)) then
		if palX then
			self.TrackName = palName
			self:DrawTracking (plX, plY, palX, palY, false, "B")
		else
			self.TrackName = comTrackName
			self:DrawTracking (plX, plY, comTrackX, comTrackY, false)
		end
		self.Level = self.Level + 2
	end
	
	self.TextScFrm:SetFrameLevel (self.Level)
	self.PlyrFrm:SetFrameLevel (self.Level + 1)
	self.ToolBar:SetLevels (self.Level + 2)
	self.Level = self.Level + 3
	self:MinimapUpdateEnd()		
	self.LocTipFrm:SetFrameLevel (self.Level + 2)
	
	self:HideExtraIcons()
	
	if self.Tick % self.ScanContinentsMod == 3 then  
		self:ScanContinents()
	end
	if doSetCurZone then
		self:SetToCurrentZone()
	end
	
end
function Nx.Map:SwitchRealMap (id)
	if self:IsInstanceMap (id) then
		self:SetInstanceMap (id)			
	else
		self:SetInstanceMap()				
	end
	if self.GOpts["MapMMInstanceTogFullSize"] then
		self.LOpts.NXMMFull = false
		if self:IsInstanceMap (id) then
			self.LOpts.NXMMFull = true
		end
	end
end
function Nx.Map:SetInstanceMap (mapId)
	self.InstMapId = nil
	if not mapId then
		return
	end
	local Map = Nx.Map
	local info = Map.InstanceInfo[mapId]
    
    if not(info) then
        Nx.Map:GetInstanceMapTextures(mapId)
        info=Map.InstanceInfo[mapId]
    end
	
	local sizex, sizey = 1002, 668
	
	if info then
		self:SetCurrentMap (mapId)
		self.InstMapId = mapId
		self.InstMapInfo = info
		local winfo = Map.MapWorldInfo[mapId]
		local wx = winfo[2]
		local wy = winfo[3]
		self.InstMapWX1 = wx
		self.InstMapWY1 = wy
		self.InstMapWX2 = wx + sizex / 256
		self.InstMapWY2 = wy + sizey / 256 * #info / 3
	end
end
function Nx.Map:GetInstanceMapTextures(mapId)
    local areaId = Nx.IdToAId[mapId]
    if areaId then
        SetMapByID(areaId)
        local mapName = GetMapInfo();
        local levels, first = GetNumDungeonMapLevels() 
        local useTerrainMap = DungeonUsesTerrainMap()
        Nx.Map.InstanceInfo[mapId] = {}
        for i=first,max(first,first+levels-1) do
            SetDungeonMapLevel(i)
            local level = useTerrainMap and i-1 or i
            local fileName = mapName.."\\"..mapName;
            if ( level > 0 ) then
                fileName = fileName..level.."_";
            end
            Nx.Map.InstanceInfo[mapId][(i-first)*3+1] = 0
            Nx.Map.InstanceInfo[mapId][(i-first)*3+2] = -100*(i-first)
            Nx.Map.InstanceInfo[mapId][(i-first)*3+3] = fileName
        end
    end    
end
function Nx.Map:ScanContinents()
	Nx.Map.ScanContinentsMod = 500
	local oldCont = GetCurrentMapContinent()
	if oldCont < 0 then
		return
	end
	local oldZone = GetCurrentMapZone()
	local mapLvl = GetCurrentMapDungeonLevel()
	local isMicroDungeon = select(4, GetMapInfo())
	
	WatchFrame:UnregisterEvent ("WORLD_MAP_UPDATE")
	local hideT = {}
	hideT[0] = true	
	hideT[6] = not self.GOpts["MapShowCCity"]
	hideT[41] = not self.GOpts["MapShowCExtra"]
	hideT[5] = not self.GOpts["MapShowCTown"]
	
	for cont = 1, self.ContCnt do
		local poiT = {}
		self.ContPOIs[cont] = poiT
		SetMapZoom (cont)
		local mapId = cont * 1000
		local name, description, txIndex, pX, pY
		local txX1, txX2, txY1, txY2
		local poiNum = GetNumMapLandmarks()
		for n = 1, poiNum do
			name, desc, txIndex, pX, pY = GetMapLandmarkInfo (n)
			if name and not hideT[txIndex] then
				local poi = {}
				tinsert (poiT, poi)
				poi.Name = name
				poi.Desc = desc
				poi.TxIndex = txIndex
				local x, y = self:GetWorldPos (mapId, pX * 100, pY * 100)
				poi.WX = x
				poi.WY = y
			end
		end
	end
	
	
    if(isMicroDungeon)then
        SetMapToCurrentZone() 
	else
		SetMapZoom (oldCont, oldZone)
		SetDungeonMapLevel (mapLvl)
	end
	WatchFrame:RegisterEvent ("WORLD_MAP_UPDATE")
end
function Nx.Map:DrawContinentsPOIs()
	if self.ScaleDraw > self.LOpts.NXPOIAtScale then
		if not Nx.CharOpts["MapShowGatherA"] then
			
		end
	end
	local getCoords = GetPOITextureCoords
	for cont = 1, self.ContCnt do
		for k, poi in ipairs (self.ContPOIs[cont]) do
			local txi = poi.TxIndex
			local z = txi == 177 and 13 or 3
			local f = self:GetIcon (z)
			if self:ClipFrameW (f, poi.WX, poi.WY, 16, 16, 0) then
				f.NxTip = poi.Name			 
				
				
				local t1x, t1y, t4x, t4y, t2x = f.texture:GetTexCoord()
				f.texture:SetTexture ("Interface\\Minimap\\POIIcons")
				local txX1, txX2, txY1, txY2 = getCoords (txi)
				local x = txX1 + .003
				local y = txY1 + .003
				local w = txX2 - .003 - x
				local h = txY2 - .003 - y
				f.texture:SetTexCoord (x + w * t1x, x + w * t2x,
							y + h * t1y, y + h * t4y)
			end
		end
	end
	self.Level = self.Level + 1
end
function Nx.Map:UpdateGroup (plX, plY)
	local alt = IsAltKeyDown()
	local redGlow = abs (GetTime() * 400 % 200 - 100) / 200 + .5
	local members = MAX_PARTY_MEMBERS
	local unitName = "party"
	local raid
	if Nx.GetNumRaidMembers() > 0 then
		members = MAX_RAID_MEMBERS
		unitName = "raid"
		raid = true
	end
	local pals = Nx.Com.PalNames
	local palName
	local palDist = 99999999
	local palX, palY
	local combatName
	local combatUnit
	local combatHealth
	local combatDist = 99999999
	local combatX, combatY
	local palsInfo = Nx.Com.PalsInfo
    local partyColor = self.GOpts["MapPlayerColored"]
	for i = 1, members do
		local unit = unitName .. i
		local name, unitRealm = UnitName (unit)
		local mapId = self.MapId
		local pX, pY = GetPlayerMapPosition (unit)
		if pX <= 0 and pY <= 0 then
			local info = palsInfo[name]
			if info and info.EntryMId == mapId then
				mapId = info.MId
				pX = info.X + .00001
				pY = info.Y
			end
		else
			pX = pX * 100
			pY = pY * 100
		end
		if (pX ~= 0 or pY ~= 0) and not UnitIsUnit (unit, "player") then
			local fullName = unitRealm and #unitRealm > 0 and (name .. "-" .. unitRealm) or name
			local wx, wy = self:GetWorldPos (mapId, pX, pY)
			
			if IsInInstance() then
				local levels, first = GetNumDungeonMapLevels()
				if levels > 0 then
					wy = wy + (GetCurrentMapDungeonLevel()-first) * 668 / 256
				end
			end
			local sz = 16 * self.DotRaidScale
			if UnitInParty (unit) then
				sz = 18 * self.DotPartyScale
			end
			local cls = UnitClass (unit) or ""
			cls = _TRANS(cls)
			
			local inCombat
			inCombat = UnitAffectingCombat (unit)
			local h = UnitHealth (unit)
			if UnitIsDeadOrGhost (unit) then
				h = 0
			end
			local m = UnitHealthMax (unit)
			local per = min (h / m, 1)			
			if per > 0 then
				if pals[name] ~= nil or self.TrackPlyrs[name] then
					sz = 20 * self.DotPalScale
					if self.TrackPlyrs[name] then
						sz = 25 * self.DotPalScale
					end
					local dist = (plX - wx) ^ 2 + (plY - wy) ^ 2
					if dist < palDist then
						palName = name
						palDist = dist
						palX, palY = wx, wy
					end
				end
				if inCombat then
					local dist = (plX - wx) ^ 2 + (plY - wy) ^ 2
					if dist < combatDist then
						combatName = name
						combatUnit = unit
						combatHealth = per
						combatDist = dist
						combatX, combatY = wx, wy
					end
				end
			end
			local f1 = self:GetIcon (1)
			if self:ClipFrameW (f1, wx, wy, sz, sz, 0) then
				f1.NXType = 1000
				f1.NXData = unit
				f1.NXData2 = fullName
				local inactive
				for n = 1, MAX_TARGET_DEBUFFS do
					if UnitDebuff (unit, n) == "Inactive" then
						inactive = true
						per = 0
						break
					end
				end
				
				local pcolor
				
				local txName = "IconPlyrP"
				if pals[name] == false then
					txName = "IconPlyrF"
				elseif pals[name] == true then
					txName = "IconPlyrG"
				elseif partyColor then
                    local _, cls = UnitClass(unit or "")
                    pcolor = cls and RAID_CLASS_COLORS[cls]
                    if pcolor then txName = "IconPlyrPColor" end					
				end
				if inCombat then
					txName = txName.."C"
				end
				f1.texture:SetTexture ("Interface\\AddOns\\Carbonite\\Gfx\\Map\\"..txName)
				if pcolor then f1.texture:SetVertexColor(pcolor.r, pcolor.g, pcolor.b) end
				
				local tStr = ""
				f = self:GetIconNI (2)
				if per > .33 then
					
					local sc = self.ScaleDraw
					self:ClipFrameTL (f, wx - 9 / sc, wy - 10 / sc, 16 * per / sc, 1 / sc)
					f.texture:SetTexture (1, 1, 1, 1)
				else
					self:ClipFrameW (f, wx, wy, 7, 7, 0)
					if per > 0 then
						f.texture:SetTexture (1, .1, .1, 1 - per * 2)
					else
						if inactive then
							f.texture:SetTexture (1, 0, 1, .7)	
						else
							f.texture:SetTexture (0, 0, 0, .5)	
						end
					end
				end
				
				local unitTarget = unit.."target"
				local tName = UnitName (unitTarget)
				local tEnPlayer
				if tName then
					local tLvl = UnitLevel (unitTarget)
					local tCls = UnitClass (unitTarget) or ""
					if tName == tCls then
						tCls = ""
					end
					local th = UnitHealth (unitTarget)
					if UnitIsDeadOrGhost (unitTarget) then
						th = 0
					end
					local tm = max (UnitHealthMax (unitTarget), 1)
					local per = min (th / tm, 1)
					local f = self:GetIconNI (2)
					local sc = self.ScaleDraw
					if UnitIsFriend ("player", unitTarget) then
						
						self:ClipFrameTL (f, wx - 9 / sc, wy - 2 / sc, 16 * per / sc, 1 / sc)
						f.texture:SetTexture (0, 1, 0, 1)
						tStr = format ("\n|cff80ff80%s %d %s %d", tName, tLvl, tCls, th)
						if not UnitIsPlayer (unitTarget) then	
							tStr = tStr .. "%"
						end
					else
						self:ClipFrameTL (f, wx - 9 / sc, wy - 9 / sc, 1 / sc, 15 * per / sc)
						if UnitIsPlayer (unitTarget) then
							tEnPlayer = true
							tStr = format ("\n|cffff4040%s %d %s %d%%", tName, tLvl, tCls, th)
							f.texture:SetTexture (redGlow, .1, 0, 1)
						elseif UnitIsEnemy ("player", unitTarget) then
							tStr = format ("\n|cffffff40%s %d %s %d%%", tName, tLvl, tCls, th)
							if Nx:UnitIsPlusMob (unitTarget) then
								f.texture:SetTexture (1, .4, 1, 1)
							else
								f.texture:SetTexture (1, 1, 0, 1)
							end
						else
							tStr = format ("\n|cffc0c0ff%s %d %s %d%%", tName, tLvl, tCls, th)
							f.texture:SetTexture (.7, .7, 1, 1)
						end
					end
				end
				local lvl = UnitLevel (unit)
				local qStr = Nx.Com:GetPlyrQStr (name)
				if raid then
					local name, rank, grp = GetRaidRosterInfo (i)
					cls = cls .. grp .. L" G"  
				end
				f1.NxTip = format ("%s %d %s %d%%\n(%d,%d) %s %s%s", fullName, lvl, cls, per * 100, pX, pY, inactive and "Inactive" or "", tStr, qStr or "")
				if alt then
					
					local s = tEnPlayer and (name .. tStr) or name
					local txt = self:GetText (s)
					self:MoveTextToIcon (txt, f1, 15, 1)
				end
			end
		end
	end
	self.Level = self.Level + 3
	if palName and self.GOpts["HUDATBGPal"] then
		if not combatName or combatDist > palDist then
			self.TrackPlayer = palName
			return palName, palX, palY
		end
	end
	if combatName then
		if not self.InCombat or combatDist > 35 then
			self.TrackPlayer = combatName
			return format (L"Combat, %s %d%%", combatName, combatHealth * 100), combatX, combatY
		end
	end
end
function Nx.Map:UpdatePlyrHistory()
	local Map = Nx.Map			
	local hist = Map.PlyrHist
	local tm = GetTime()
	local scale = self.BaseScale
	local x = hist.LastX - self.MoveLastX
	local y = hist.LastY - self.MoveLastY
	local moveDist = (x * x + y * y) ^ .5
	if moveDist > self.GOpts["MapTrailDist"] * scale then
		hist.LastX = self.MoveLastX
		hist.LastY = self.MoveLastY
		hist.Time = tm
		local next = hist.Next
		local o = next * 4 - 3
		hist[o] = GetTime()
		hist[o + 1] = self.PlyrX
		hist[o + 2] = self.PlyrY
		hist[o + 3] = self.PlyrDir
		if next >= hist.Cnt then
			next = 0
		end
		hist.Next = next + 1
	end
	local size = min (max (4 * self.ScaleDraw * self.BaseScale, 3), 25)
	local fadeTime = self.GOpts["MapTrailTime"]
	for n = 1, hist.Cnt * 4, 4 do
		local secs = hist[n]
		local tmdif = tm - secs
		if tmdif < fadeTime then
			local x = hist[n + 1]
			local y = hist[n + 2]
			local dir = hist[n + 3]
			local f = self:GetIconNI()
			if self:ClipFrameW (f, x, y, size, size, dir) then
				f.texture:SetTexture ("Interface\\AddOns\\Carbonite\\Gfx\\Map\\IconCircleFade")
				local a = (fadeTime - tmdif) / fadeTime * .9
				f.texture:SetVertexColor (1, 0, 0, a)
			end
		end
	end
end
function Nx.Map:UpdateTargets()
	local delay = self.UpdateTargetDelay
	if delay > 0 then
		self.UpdateTargetDelay = delay - 1
		return
	end
	local tar = self.Targets[1]
	local x = tar.TargetMX - self.PlyrX
	local y = tar.TargetMY - self.PlyrY
	local distYd = (x * x + y * y) ^ .5 * 4.575
	if distYd < (tar.Radius or 7) * self.BaseScale then
		if tar.TargetType ~= "Q" then	
			self.UpdateTargetDelay = 20
			self.UpdateTrackingDelay = 0
			tremove (self.Targets, 1)
			if #self.Targets > 0 and self.GOpts["RouteRecycle"] then
				tinsert (self.Targets, tar)
			end
			if self.GOpts["HUDTSoundOn"] then
				Nx:PlaySoundFile ("sound\\interface\\magicclick.wav")
			end
			UIErrorsFrame:AddMessage (L"Target " .. _TRANS(tar.TargetName) .. L" reached", 1, 1, 1, 1)
			self.Guide:ClearAll()
			if tar.RadiusFunc then
				tar.RadiusFunc ("distance", tar.UniqueId, tar.Radius, distYd, distYd)
				tar.RadiusFunc = nil
			end
		end
	end
end
function Nx.Map:UpdateTracking()
	local delay = self.UpdateTrackingDelay - 1
	if delay <= 0 then
		self:CalcTracking()
		delay = 45
	end
	self.UpdateTrackingDelay = delay
	
	self.Level = self.Level + 2
	local dist1
	local dir1
	local srcX = self.PlyrX
	local srcY = self.PlyrY
	for n = 1, #self.Tracking do
		local tr = self.Tracking[n]
		self:DrawTracking (srcX, srcY, tr.TargetMX, tr.TargetMY, tr.TargetTex, tr.Mode, tr.TargetName)
		if n == 1 then
			self.TrackName = tr.TargetName
			dist1 = self.TrackDistYd
			dir1 = self.TrackDir
		end
		srcX = tr.TargetMX
		srcY = tr.TargetMY
	end
	self.TrackDistYd = dist1
	self.TrackDir = dir1
end
function Nx.Map:CalcTracking()
	Nx.Timer:ProfilerStart ("Map Tracking")
	local Travel = Nx.Travel
	local tr = {}
	self.Tracking = tr
	local srcX = self.PlyrX
	local srcY = self.PlyrY
	local srcMapId = self.RMapId
	for n, tar in ipairs (self.Targets) do
		Travel:MakePath (tr, srcMapId, srcX, srcY, tar.MapId, tar.TargetMX, tar.TargetMY, tar.TargetType)
		tinsert (tr, tar)
		srcX = tar.TargetMX
		srcY = tar.TargetMY
		srcMapId = tar.MapId
	end
	Nx.Timer:ProfilerEnd ("Map Tracking")
end
function Nx.Map:DrawTracking (srcX, srcY, dstX, dstY, tex, mode, name)
	local x = dstX - srcX
	local y = dstY - srcY
	local dist = (x * x + y * y) ^ .5
	self.TrackDistYd = dist * 4.575
	if tex ~= false then
		local f = self:GetIcon (1)
		local size = 16 * self.IconNavScale
		self:ClipFrameW (f, dstX, dstY, size, size, 0)
		local s = name or self.TrackName
		f.NxTip = format (L"%s\n%d yds", s, dist * 4.575)
		f.texture:SetTexture (tex or "Interface\\AddOns\\Carbonite\\Gfx\\Map\\IconWayTarget")
	end
	self.TrackDir = false
	if 1 then
		local dir = math.deg (math.atan2 (y, x)) + 90
		self.TrackDir = dir
		local sx = self.ScaleDraw
		local sy = self.ScaleDraw / 1.5
		x = x * sx
		y = y * sy
		
		local cnt = (x * x + y * y) ^ .5 / 15 / self.IconNavScale
		if cnt < 5 then
			cnt = cnt + .5
		end
		cnt = min (floor (cnt), 40)
		if cnt >= 1 then
			local dx = x / cnt
			local dy = y / cnt
			local offset = self.ArrowScroll
			x = dx * offset
			y = dy * offset
			local size = 16 * self.IconNavScale
			local usedIcon = true
			local f
			for n = 1, cnt do
				local wx = srcX + x / sx
				local wy = srcY + y / sy
				if usedIcon then
					usedIcon = false
					f = self:GetIconNI()
				end
				if self:ClipFrameW (f, wx, wy, size, size, dir) then
					f.texture:SetTexture ("Interface\\AddOns\\Carbonite\\Gfx\\Map\\IconArrowGrad")
					if mode == "B" then
						f.texture:SetVertexColor (.7, .7, 1, .5)
					elseif mode == "F" then
						f.texture:SetVertexColor (1, 1, 0, .9)
					elseif mode == "D" then
						f.texture:SetVertexColor (1, 0, 0, 1)
					end
					usedIcon = true
				end
				x = x + dx
				y = y + dy
			end
		end
	end
end
function Nx.Map:MoveContinents()
	if self.CurOpts.NXWorldShow then
		for contN = 1, Nx.Map.ContCnt do
			local lvl = contN <= 2 and self.Level or self.Level + 1
			self:MoveZoneTiles (contN, 0, self.ContFrms[contN], self.BackgndAlpha, lvl) 
		end
		
		self.Level = self.Level + 2
	else
		local frms, frm
		for contN = 1, Nx.Map.ContCnt do
			frms = self.ContFrms[contN]
			for i = 1, 12 do
				frm = frms[i]
				if frm then
					frm:Hide()
				end
			end
		end
		
	end
end
function Nx.Map:CheckWorldHotspots (wx, wy)
	if self.InstMapId then
		if wx >= self.InstMapWX1 and wx <= self.InstMapWX2 and wy >= self.InstMapWY1 and wy <= self.InstMapWY2 then
			local lvl = floor ((wy - self.InstMapWY1) / 668 * 256) + 1
			if self.InstMapId ~= self.MapId then
				self:SetCurrentMap (self.InstMapId)
			end
			SetDungeonMapLevel (lvl)
			self.InstLevelSet = -1
			self.WorldHotspotTipStr = Nx.MapIdToName[self.InstMapId] .. "\n"
			return
		end
	end
	local quad1 = self.WorldHotspotsCity
	local quad2 = self.WorldHotspots
	if self.NXCitiesUnder then
		quad1, quad2 = quad2, quad1
	end
	if self:CheckWorldHotspotsType (wx, wy, quad1) then
		return
	end
	if self:CheckWorldHotspotsType (wx, wy, quad2) then
		return
	end
	self.WorldHotspotTipStr = false
end
function Nx.Map:CheckWorldHotspotsType (wx, wy, quad)
	for n, spot in ipairs (quad) do
		if wx >= spot.WX1 and wx <= spot.WX2 and wy >= spot.WY1 and wy <= spot.WY2 then
			local curId = self:GetCurrentMapId()
			curId = self.MapWorldInfo[curId].Level1Id or curId
			if spot.MapId ~= curId then
				self:SetCurrentMap (spot.MapId)
			end
			self.WorldHotspotTipStr = spot.NxTipBase .. "\n"
			return true
		end
	end
end
function Nx.Map:SetLevelWorldHotspots()
end
function Nx.Map:MoveCurZoneTiles (clear)
	local mapId = self.MapId
	local wzone = self:GetWorldZone (mapId)
	if not clear and
			(not wzone or wzone.City or (wzone.StartZone and self.RMapId == mapId) or
			self:IsBattleGroundMap (mapId) or self:IsMicroDungeon(mapId)) then
		local alpha = self.BackgndAlpha * (wzone.Alpha or 1)
		self:MoveZoneTiles (self.Cont, self.Zone, self.TileFrms, alpha, self.Level)
		self.Level = self.Level + 1
	else
		local frms, frm
		frms = self.TileFrms
		for i = 1, 12 do
			frm = frms[i]
			if frm then
				frm:Hide()
			end
		end
	end
end
function Nx.Map:IsMicroDungeon(mapId)
    return Nx.CurrIsMicroDungeon and Nx.CurrMapID==mapId and Nx.IdToAId[mapId] and not Nx.Map.MapLevels[Nx.IdToAId[mapId]] 
end
function Nx.Map:HideExtraZoneTiles()
	local frms = self.TileFrms
	frms[4]:Hide()
	frms[8]:Hide()
	frms[9]:Hide()
	frms[12]:Hide()
end
function Nx.Map:MoveZoneTiles (cont, zone, frms, alpha, level)
	local zname, zx, zy, zw, zh = self:GetWorldZoneInfo (cont, zone)
	if not zx then
		return
	end
	local scale = self.ScaleDraw
	local clipW = self.MapW
	local clipH = self.MapH
	local x = (zx - self.MapPosXDraw) * scale + clipW / 2
	local y = (zy - self.MapPosYDraw) * scale + clipH / 2
	local bx = 0
	local by = 0
	local bw = zw * 1024 / 1002 / 4 * scale
	local bh = zh * 768 / 668 / 3 * scale
	local w, h
	local texX1, texX2
	local texY1, texY2
	for i = 1, 12 do
		local frm = frms[i]
		if frm then
			texX1 = 0
			texX2 = 1
			texY1 = 0
			texY2 = 1
			local vx0 = bx * bw + x
			local vx1 = vx0
			local vx2 = vx0 + bw
			if vx1 < 0 then
				vx1 = 0
				texX1 = (vx1 - vx0) / bw
			end
			if vx2 > clipW then
				vx2 = clipW
				texX2 = (vx2 - vx0) / bw
			end
			local vy0 = by * bh + y
			local vy1 = vy0
			local vy2 = vy0 + bh
			if vy1 < 0 then
				vy1 = 0
				texY1 = (vy1 - vy0) / bh
			end
			if vy2 > clipH then
				vy2 = clipH
				texY2 = (vy2 - vy0) / bh
			end
			w = vx2 - vx1
			h = vy2 - vy1
			if w <= 0 or h <= 0 then
				frm:Hide()
			else
				frm:SetPoint ("TOPLEFT", vx1, -vy1 - self.TitleH)
				frm:SetWidth (w)
				frm:SetHeight (h)
				frm:SetFrameLevel (level)
				frm.texture:SetTexCoord (texX1, texX2, texY1, texY2)
				frm.texture:SetVertexColor (1, 1, 1, alpha)
				frm:Show()
			end
		end
		bx = bx + 1
		if bx >= 4 then
			bx = 0
			by = by + 1
		end
	end
end
function Nx.Map:AddOldMap (newMapId)
	if self.MapId == 0 then		
		return
	end
	
	local off = 1
	local dup
	for n = 1, #self.MapsDrawnOrder do
		if self.MapsDrawnOrder[off] == newMapId then
			tremove (self.MapsDrawnOrder, off)
			dup = true
		else
			off = off + 1
		end
	end
	local drawCnt = self.GOpts["MapZoneDrawCnt"]
	if not dup then
		local extra = #self.MapsDrawnOrder - drawCnt + 2
		for n = 1, extra do
			tremove (self.MapsDrawnOrder, 1)
		end
	end
	if drawCnt > 1 then
		self.MapsDrawnFade[self.MapId] = -1
		tinsert (self.MapsDrawnOrder, self.MapId)		
	end
end
function Nx.Map:UpdateZones()
	local mapId = self.MapId
	local winfo = self.MapWorldInfo[mapId]
	local s = self.LOpts.NXDetailScale
	local freeOrScale = self.ScaleDraw <= s
	if freeOrScale or
		winfo.City or
		(winfo.StartZone and self.RMapId == mapId) or
		self:IsBattleGroundMap (mapId) or
		self:IsMicroDungeon(mapId) then
		for n, id in ipairs (self.MapsDrawnOrder) do
			self:UpdateOverlay (id, .8, true)
		end
		if winfo.City then
			self:UpdateMiniFrames()
			self:MoveCurZoneTiles()
		else
			self:MoveCurZoneTiles()
			self:UpdateOverlay (mapId, 1)
			self:UpdateMiniFrames()
		end
	else
		self:MoveCurZoneTiles (true)		
		self:UpdateMiniFrames()
	end
end
function Nx.Map:GetExploredOverlayNum()
	for i = 1, 999 do
		local txName = GetMapOverlayInfo (i)
		if not txName then
			return i
		end
	end
end
function Nx.Map:UpdateOverlayUnexplored()
	self.CurOverlays = false
	local txFolder
	local mapId = self:GetCurrentMapId()
	local wzone = self:GetWorldZone (mapId)
	if wzone then
		if wzone.City then
			return
		end
		txFolder = wzone.Overlay
	end
	local overlays
	if txFolder then
		overlays = Nx.Map.ZoneOverlays[txFolder]
	end
	if not overlays or not self.ShowUnexplored then
		local s1, s2, file
		local ol = {}
		if overlays then
			for txName, whxyStr in pairs (overlays) do	
				ol[txName] = whxyStr
			end
		end
		overlays = ol
		for i = 1, 99 do
			
			local txName, txW, txH, oX, oY = GetMapOverlayInfo (i)
			if not txName then
				break
			end
			local s1, s2, folder, file = strfind (txName, ".+\\.+\\(.+)\\(.+)")
			if s1 then
				txFolder = folder
				file = strlower (file)
				overlays[file] = format ("%d,%d,%d,%d", oX - 10000, oY, txW, txH)
			end
		end
		if not txFolder then		
			overlays = false
		end
	end
	self.CurOverlays = overlays
	self.CurOverlaysTexFolder = txFolder
end
function Nx.Map:TargetOverlayUnexplored()
	local mapId = self:GetCurrentMapId()
	self:ClearTargets()		
	local wzone = self:GetWorldZone (mapId)
	if wzone and wzone.City then
		return
	end
	local overlays = self.CurOverlays
	if not overlays then	
		return
	end
	for txName, whxyStr in pairs (overlays) do
		local oX, oY, txW, txH = strsplit (",", whxyStr)
		oX = tonumber (oX)
		oY = tonumber (oY)
		if oX >= 0 then
			txW = tonumber (txW)
			txH = tonumber (txH)
			if txW == 512 then
				txW = txW * .75
			end
			if txH == 512 then
				txH = txH * .75
			end
			local x, y = (oX + txW / 2) / 1002 * 100, (oY + txH / 2) / 668 * 100
			self:SetTargetXY (mapId, x, y, "Explore", true)
		end
	end
end
function Nx.Map:UpdateOverlay (mapId, bright, noUnexplored)
	local wzone = self:GetWorldZone (mapId)
	if wzone and (wzone.City or self:IsMicroDungeon(mapId)) then 
		return
	end
	local txFolder = wzone and wzone.Overlay or ""
	local overlays = Nx.Map.ZoneOverlays[txFolder]
	local unex
	if not noUnexplored and (not overlays or not self.ShowUnexplored) then
		if not (wzone and wzone.Explored) then
			unex = true
		end
		overlays = self.CurOverlays
		txFolder = self.CurOverlaysTexFolder
	end
	if not overlays then	
		return
	end
	local bW, bH
	local txIndex
	local txPixelW, txFileW, txPixelH, txFileH
	local path = "Interface\\Worldmap\\" .. txFolder .. "\\"
	local alpha = self.BackgndAlpha
	local unExAl = self.LOpts.NXUnexploredAlpha
	local zscale = self:GetWorldZoneScale (mapId) / 10
	for txName, whxyStr in pairs (overlays) do
		local lev = 0
		local brt = bright
		txName = path .. txName
		local oX, oY, txW, txH, mode = strsplit (",", whxyStr)
		txW = tonumber (txW)
		txH = tonumber (txH)
		oX = tonumber (oX)
		oY = tonumber (oY)
		if unex then		
			if oX < 0 then
				oX = oX + 10000	
			else
				brt = unExAl		
				lev = 1
			end
		end
		bW = ceil (txW / 256)
		bH = ceil (txH / 256)
		txIndex = 1
		for bY = 0, bH - 1 do
			if bY < bH - 1 then
				txPixelH = 256
				txFileH = 256
			else
				txPixelH = mod (txH, 256)
				if txPixelH == 0 then
					txPixelH = 256
				end
				txFileH = 16
				while txFileH < txPixelH do
					txFileH = txFileH * 2
				end
			end
			for bX = 0, bW - 1 do
				if bX < bW - 1 then
					txPixelW = 256
					txFileW = 256
				else
					txPixelW = mod (txW, 256)
					if txPixelW == 0 then
						txPixelW = 256
					end
					txFileW = 16
					while txFileW < txPixelW do
						txFileW = txFileW * 2
					end
				end
				local f = self:GetIconNI (lev)
				local wx, wy = self:GetWorldPos (mapId, (oX + bX * 256) / 1002 * 100, (oY + bY * 256) / 668 * 100)
				if self:ClipFrameTL (f, wx, wy, txFileW * zscale, txFileH * zscale) then
					f.texture:SetTexture (mode and txName or txName .. txIndex)
					f.texture:SetVertexColor (brt, brt, brt, alpha)
				end
				txIndex = txIndex + 1
			end
		end
	end
	self.Level = self.Level + 2
end
function Nx.Map:UpdateMiniFrames()
	local Map = Nx.Map
	local mapId = self.MapId
	local winfo = self.MapWorldInfo[mapId]
	local opts = self.LOpts
	local alphaRange = opts.NXDetailScale * .35
	local s = opts.NXDetailScale - alphaRange
	if self.ScaleDraw <= s or opts.NXDetailAlpha <= 0 or self:IsBattleGroundMap (mapId) or self:IsMicroDungeon(mapId) then
		self:HideMiniFrames()
		return
	end
	local alphaPer = min ((self.ScaleDraw - s) / alphaRange, 1)
    
	local miniT, basex, basey = self:GetMiniInfo (mapId)
	if not miniT then
		self:HideMiniFrames()
		return
	end
	local level = self.Level
	self.Level = self.Level + 1
	local f
	local frmNum = 1
	local scale = 256 * 0.416767770014
	if CARB_ADJ then
	    basex = basex + (CARB_ADJ[1] or 0)
    	basey = basey + (CARB_ADJ[2] or 0)
	end
	local size = scale
	local miniX = floor ((self.MapPosXDraw - basex) / scale - self.MiniBlks / 2 + .5)
	local miniY = floor ((self.MapPosYDraw - basey) / scale - self.MiniBlks / 2 + .5)
	basex = basex + miniX * scale
	basey = basey + miniY * scale
	local wx
	local wy = basey
	local al = self.BackgndAlpha * opts.NXDetailAlpha * alphaPer
    
	for y = miniY, miniY + self.MiniBlks - 1 do
		wx = basex
		for x = miniX, miniX + self.MiniBlks - 1 do
			f = self.MiniFrms[frmNum]
			local txname = Map:GetMiniBlkName (miniT, x, y)
			if txname then
				if self:ClipFrameTL (f, wx, wy, size, size) then
					f:SetFrameLevel (level)
					f.texture:SetVertexColor (1, 1, 1, al)
					f.texture:SetTexture (txname)
					if CARB_ADJ then f:SetScale(CARB_ADJ[3] or 1) end
				end
			else
				f:Hide()
			end
			wx = wx + scale
			frmNum = frmNum + 1
		end
		wy = wy + scale
	end
end
function Nx.Map:HideMiniFrames()
	for n = 1, self.MiniBlks ^ 2 do
		self.MiniFrms[n]:Hide()
	end
end
function Nx.Map:ClipFrameZ (frm, x, y, w, h, dir)
	x, y = self:GetWorldPos (self.MapId, x, y)
	return self:ClipFrameW (frm, x, y, w, h, dir)
end
function Nx.Map:ClipFrameZTL (frm, x, y, w, h)
	x, y = self:GetWorldPos (self.MapId, x, y)
	return self:ClipFrameTL (frm, x, y, w, h)
end
function Nx.Map:ClipFrameZTLO (frm, x, y, w, h, xo, yo)
	x, y = self:GetWorldPos (self.MapId, x, y)
	return self:ClipFrameTL (frm, x + xo / self.ScaleDraw, y + yo / self.ScaleDraw, w, h)
end
function Nx.Map:ClipFrameW (frm, bx, by, w, h, dir)
	local scale = self.ScaleDraw
	
	local bw = w
	local clipW = self.MapW
	local x = (bx - self.MapPosXDraw) * scale + clipW * .5
	local texX1 = 0
	local texX2 = 1
	local vx0 = x - bw * .5		
	local vx1 = vx0
	local vx2 = vx0 + bw
	if vx1 < 0 then
		vx1 = 0
		texX1 = (vx1 - vx0) / bw
	end
	if vx2 > clipW then
		vx2 = clipW
		texX2 = (vx2 - vx0) / bw
	end
	w = vx2 - vx1
	if w < .3 then
		if self.ScrollingFrm ~= frm then
			frm:Hide()
		else
			frm:SetWidth (.001)
		end
		return false
	end
	
	local bh = h
	local clipH = self.MapH
	local y = (by - self.MapPosYDraw) * scale + clipH * .5
	local texY1 = 0
	local texY2 = 1
	local vy0 = y - bh * .5		
	local vy1 = vy0
	local vy2 = vy0 + bh
	if vy1 < 0 then
		vy1 = 0
		texY1 = (vy1 - vy0) / bh
	end
	if vy2 > clipH then
		vy2 = clipH
		texY2 = (vy2 - vy0) / bh
	end
	h = vy2 - vy1
	if h < .3 then
		if self.ScrollingFrm ~= frm then
			frm:Hide()
		else
			frm:SetWidth (.001)
		end
		return false
	end
	
	frm:SetPoint ("TOPLEFT", vx1, -vy1 - self.TitleH)
	frm:SetWidth (w)
	frm:SetHeight (h)
	if dir == 0 then
		frm.texture:SetTexCoord (texX1, texX2, texY1, texY2)
	else
		
		
		local t1x, t1y, t2x, t2y, t3x, t3y, t4x, t4y
		
		texX1 = texX1 - .5
		texX2 = texX2 - .5
		texY1 = texY1 - .5
		texY2 = texY2 - .5
		local co = cos (dir)
		local si = sin (dir)
		t1x = texX1 * co + texY1 * si + .5
		t1y = texX1 * -si + texY1 * co + .5
		t2x = texX1 * co + texY2 * si + .5
		t2y = texX1 * -si + texY2 * co + .5
		t3x = texX2 * co + texY1 * si + .5
		t3y = texX2 * -si + texY1 * co + .5
		t4x = texX2 * co + texY2 * si + .5
		t4y = texX2 * -si + texY2 * co + .5
		frm.texture:SetTexCoord (t1x, t1y, t2x, t2y, t3x, t3y, t4x, t4y)
	end
	frm:Show()
	return true
end
function Nx.Map:ClipFrameWChop (frm, bx, by, w, h)
	local bw = w
	local bh = h
	local clipW = self.MapW
	local clipH = self.MapH
	local scale = self.ScaleDraw
	local x = (bx - self.MapPosXDraw) * scale + clipW / 2
	local y = (by - self.MapPosYDraw) * scale + clipH / 2
	local texX1 = 0
	local texX2 = 1
	
	local vx0 = x - bw * .5
	local vx1 = vx0
	local vx2 = vx0 + bw
	if vx1 < 0 then
		vx1 = 0
		texX1 = (vx1 - vx0) / bw
	end
	if vx2 > clipW then
		vx2 = clipW
		texX2 = (vx2 - vx0) / bw
	end
	w = vx2 - vx1
	if w < .3 then
		if self.ScrollingFrm ~= frm then
			frm:Hide()
		else
			frm:SetWidth (.001)
		end
		return false
	end
	local texY1 = 0
	local texY2 = 1
	local vy0 = y - bh * .5
	local vy1 = vy0
	local vy2 = vy0 + bh
	if vy1 < 0 then
		vy1 = 0
		texY1 = (vy1 - vy0) / bh
	end
	if vy2 > clipH then
		vy2 = clipH
		texY2 = (vy2 - vy0) / bh
	end
	h = vy2 - vy1
	if h < .3 then
		if self.ScrollingFrm ~= frm then
			frm:Hide()
		else
			frm:SetWidth (.001)
		end
		return false
	end
	frm:SetPoint ("TOPLEFT", vx1, -vy1 - self.TitleH)
	frm:SetWidth (w)
	frm:SetHeight (h)
	frm.texture:SetTexCoord (texX1 * .9 + .05, texX2 * .9 + .05, texY1 * .9 + .05, texY2 * .9 + .05)
	frm:Show()
	return true
end
function Nx.Map:ClipMMW (frm, bx, by, w, h)
	local scale = self.ScaleDraw
	
	local bw = w * scale
	local bh = h * scale
	local clipW = self.MapW
	local clipH = self.MapH
	local x = (bx - self.MapPosXDraw) * scale + clipW * .5
	local y = (by - self.MapPosYDraw) * scale + clipH * .5
	local vx0 = x - bw * .5
	local vx1 = vx0
	local vx2 = vx0 + bw
    local tolerance = 0 
	if vx1 < 0-tolerance or vx2 > clipW+tolerance then
		return false
	end
	w = vx2 - vx1
	if w <= 0-tolerance then
		return false
	end
	local vy0 = y - bh * .5
	local vy1 = vy0
	local vy2 = vy0 + bh
	if vy1 < 0-tolerance or vy2 > clipH+tolerance then
		return false
	end
	h = vy2 - vy1
	if h <= 0-tolerance then
		return false
	end
    
	local sc = w / 140
	self.MMFScale = sc
	local isc = self.GOpts["MapMMIScale"]
	self:MinimapSetScale (sc, isc)
	frm:SetPoint ("TOPLEFT", self.Frm, "TOPLEFT", vx1 / isc, (-vy1 - self.TitleH) / isc)
	frm:Show()
	return true
end
function Nx.Map:ClipFrameTL (frm, bx, by, w, h)
	
	local scale = self.ScaleDraw
	
	local bw = w * scale
	local clipW = self.MapW
	local x = (bx - self.MapPosXDraw) * scale + clipW * .5
	local texX1 = 0
	local texX2 = 1
	local vx1 = x
	local vx2 = x + bw
	if vx1 < 0 then
		vx1 = 0
		texX1 = (vx1 - x) / bw
	end
	if vx2 > clipW then
		vx2 = clipW
		texX2 = (vx2 - x) / bw
	end
	w = vx2 - vx1
	if w < .3 then
		if self.ScrollingFrm ~= frm then
			frm:Hide()
		else
			frm:SetWidth (.001)
		end
		return false
	end
	
	local bh = h * scale
	local clipH = self.MapH
	local y = (by - self.MapPosYDraw) * scale + clipH * .5
	local texY1 = 0
	local texY2 = 1
	local vy1 = y
	local vy2 = y + bh
	if vy1 < 0 then
		vy1 = 0
		texY1 = (vy1 - y) / bh
	end
	if vy2 > clipH then
		vy2 = clipH
		texY2 = (vy2 - y) / bh
	end
	h = vy2 - vy1
	if h < .3 then
		if self.ScrollingFrm ~= frm then
			frm:Hide()
		else
			frm:SetWidth (.001)
		end
		return false
	end
	frm:SetPoint ("TOPLEFT", vx1, -vy1 - self.TitleH)
	if w <= 1.2 then		
		w = self.Size1
		if w <= 0 then
			frm:SetWidth (.001)
			return
		end
	end
	if h <= 1.2 then
		h = self.Size1
		if h <= 0 then
			frm:SetWidth (.001)
			return
		end
	end
	frm:SetWidth (w)
	frm:SetHeight (h)
	frm.texture:SetTexCoord (texX1, texX2, texY1, texY2)
	frm:Show()
	return true
end
function Nx.Map:ClipFrameTLSolid (frm, bx, by, w, h)
	
	local scale = self.ScaleDraw
	
	local clipW = self.MapW
	local vx1 = (bx - self.MapPosXDraw) * scale + clipW * .5
	local vx2 = vx1 + w * scale
	if vx1 < 0 then
		vx1 = 0
	end
	if vx2 > clipW then
		vx2 = clipW
	end
	w = vx2 - vx1
	if w < .3 then
		if self.ScrollingFrm ~= frm then
			frm:Hide()
		else
			frm:SetWidth (.001)
		end
		return false
	end
	
	local clipH = self.MapH
	local vy1 = (by - self.MapPosYDraw) * scale + clipH * .5
	local vy2 = vy1 + h * scale
	if vy1 < 0 then
		vy1 = 0
	end
	if vy2 > clipH then
		vy2 = clipH
	end
	h = vy2 - vy1
	if h < .3 then
		if self.ScrollingFrm ~= frm then
			frm:Hide()
		else
			frm:SetWidth (.001)
		end
		return false
	end
	frm:SetPoint ("TOPLEFT", vx1, -vy1 - self.TitleH)
	frm:SetWidth (w)
	frm:SetHeight (h)
	frm:Show()
	return true
end
function Nx.Map:ClipZoneFrm (cont, zone, frm, alpha)
	local zname, zx, zy, zw, zh
	zname, zx, zy, zw, zh = self:GetWorldZoneInfo (cont, zone)
	if not zx then
		return
	end
	local scale = self.ScaleDraw
	local clipW = self.MapW
	local clipH = self.MapH
	local x = (zx - self.MapPosXDraw) * scale + clipW / 2
	local y = (zy - self.MapPosYDraw) * scale + clipH / 2
	local bx = 0
	local by = 0
	local bw = zw * scale
	local bh = zh * scale
	local w, h
	local level = self.Level
	if frm then
		local vx0 = bx * bw + x
		local vx1 = vx0
		local vx2 = vx0 + bw
		local vy0 = by * bh + y
		local vy1 = vy0
		local vy2 = vy0 + bh
		w = vx2 - vx1
		h = vy2 - vy1
		if w <= 0 or h <= 0 then
			frm:Hide()
		else
			local sc = w / 1002
			vx1 = vx1 / sc
			vy1 = vy1 / sc
			frm:SetPoint ("TOPLEFT", vx1, -vy1 - self.TitleH)
			frm:SetScale (sc)
			frm:SetFrameLevel (level)
			frm:Show()
		end
	end
end
function Nx.Map:InitIconType (iconType, drawMode, texture, w, h)
	local d = self.Data
	local t = wipe (d[iconType] or {})
	d[iconType] = t
	t.Num = 0
	t.Enabled = true
	t.DrawMode = drawMode or "ZP"	
	t.Tex = texture
	t.W = w
	t.H = h
	t.Scale = 1	
	t.ClipFunc = self.ClipFrameW		
end
function Nx.Map:ClearIconType (iconType)
	local d = self.Data
	d[iconType] = nil
end
function Nx.Map:SetIconTypeAlpha (iconType, alpha, alphaNear)
	local d = self.Data
	assert (d[iconType])
	d[iconType].Alpha = alpha
	d[iconType].AlphaNear = alphaNear
end
function Nx.Map:SetIconTypeAtScale (iconType, scale)
	local d = self.Data
	assert (d[iconType])
	d[iconType].AtScale = scale
end
function Nx.Map:SetIconTypeLevel (iconType, level)
	local d = self.Data
	assert (d[iconType])
	d[iconType].Lvl = level
end
function Nx.Map:SetIconTypeChop (iconType, on)
	local d = self.Data
	assert (d[iconType])
	d[iconType].ClipFunc = on and self.ClipFrameWChop or self.ClipFrameW
end
function Nx.Map:AddIconPt (iconType, x, y, color, texture)
	local d = self.Data
	assert (d[iconType])
	local tdata = d[iconType]
	tdata.Num = tdata.Num + 1		
	local icon = {}
	tdata[tdata.Num] = icon
	icon.X = x
	icon.Y = y
	icon.Color = color
	icon.Tex = texture
	assert (tdata.Tex or texture or color)
	return icon
end
function Nx.Map:GetIconCnt (iconType)
	return #self.Data[iconType]
end
function Nx.Map:GetIconPt (iconType, index)
	local icon = self.Data[iconType][index]
	return icon.X, icon.Y
end
function Nx.Map:AddIconRect (iconType, mapId, x, y, x2, y2, color)
	local d = self.Data
	assert (d[iconType])
	local tdata = d[iconType]
	tdata.Num = tdata.Num + 1
	local icon = {}
	tdata[tdata.Num] = icon
	icon.MapId = mapId
	icon.X = x
	icon.Y = y
	icon.X2 = x2
	icon.Y2 = y2
	icon.Color = color
	return icon
end
function Nx.Map:SetIconTip (icon, tip)
	icon.Tip = tip
end
function Nx.Map:SetIconUserData (icon, data)
	icon.UData = data
end
function Nx.Map:SetIconFavData (icon, data1, data2)
	icon.FavData1 = data1
	icon.FavData2 = data2
end
function Nx.Map:GetIconFavData (icon)
	return icon.FavData1, icon.FavData2
end
function Nx.Map:UpdateIcons (drawNonGuide)
	local c2rgb = Nx.Util_c2rgb
	local c2rgba = Nx.Util_c2rgba
	local d = self.Data
	local wpScale = 1
	local wpMin = self.GOpts["MapIconScaleMin"]
	if wpMin >= 0 then
		wpScale = self.ScaleDraw * .08
	end
	for type, v in pairs (d) do
		v.Enabled = drawNonGuide or strbyte (type) == 33	
		if v.AtScale then
			if self.ScaleDraw < v.AtScale then
				v.Enabled = false
			end
		end
	end
	for k, v in pairs (d) do
		if v.Enabled then
			if v.DrawMode == "ZP" then		
				local scale = self.IconScale
				local w = v.W * scale
				local h = v.H * scale
				for n = 1, v.Num do
					local icon = v[n]
					local f = self:GetIconStatic (v.Lvl)
					if self:ClipFrameZ (f, icon.X, icon.Y, w, h, 0) then
						f.NxTip = icon.Tip
						if icon.Tex then
							f.texture:SetTexture (icon.Tex)
						elseif v.Tex then
							f.texture:SetTexture (v.Tex)
						else
							f.texture:SetTexture (c2rgb (icon.Color))
						end
					end
				end
			elseif v.DrawMode == "WP" then		
				local scale = self.IconScale * v.Scale * wpScale
				local w = max (v.W * scale, wpMin)
				local h = max (v.H * scale, wpMin)
				if v.AlphaNear then
					local aNear = v.AlphaNear * (abs (GetTime() % .7 - .35) / .7 + .5)	
					for n = 1, v.Num do
						local icon = v[n]
						local f = self:GetIconStatic (v.Lvl)
						if v.ClipFunc (self, f, icon.X, icon.Y, w, h, 0) then
							f.NxTip = icon.Tip
							f.NXType = 3000
							f.NXData = icon
							if icon.Tex then
								f.texture:SetTexture (icon.Tex)
							elseif v.Tex then
								f.texture:SetTexture (v.Tex)
							else
								f.texture:SetTexture (c2rgb (icon.Color))
							end
							local a = v.Alpha
							local dist = (icon.X - self.PlyrX) ^ 2 + (icon.Y - self.PlyrY) ^ 2
							if dist < 306 then	
								a = aNear
							end
							f.texture:SetVertexColor (1, 1, 1, a)
						end
					end
				else
					for n = 1, v.Num do
						local icon = v[n]
						local f = self:GetIconStatic (v.Lvl)
						if v.ClipFunc (self, f, icon.X, icon.Y, w, h, 0) then
							f.NxTip = icon.Tip
							f.NXType = 3000
							f.NXData = icon
							if icon.Tex then
								f.texture:SetTexture (icon.Tex)
							elseif v.Tex then
								f.texture:SetTexture (v.Tex)
							else
								f.texture:SetTexture (c2rgb (icon.Color))
							end
							if v.Alpha then
								f.texture:SetVertexColor (1, 1, 1, v.Alpha)
							end
						end
					end
				end
			elseif v.DrawMode == "ZR" then	
				local x, y, x2, y2
				for n = 1, v.Num do
					local icon = v[n]
					local f = self:GetIconStatic (v.Lvl)
					f.NxTip = icon.Tip
					x, y = self:GetWorldPos (icon.MapId, icon.X, icon.Y)
					x2, y2 = self:GetWorldPos (icon.MapId, icon.X2, icon.Y2)
					if self:ClipFrameTL (f, x, y, x2-x, y2-y) then
						if v.Texture then
							f.texture:SetTexture (v.Tex)
						else
							f.texture:SetTexture (c2rgba (icon.Color))
						end
					end
				end
			end
		end
	end
end
function Nx.Map:ResetIcons()
	local frms = self.IconFrms
	frms.Used = frms.Next - 1		
	frms.Next = 1
	local frms = self.IconNIFrms
	frms.Used = frms.Next - 1		
	frms.Next = 1
	local frms = self.IconStaticFrms
	frms.Used = frms.Next - 1		
	frms.Next = 1
	local data = self.TextFStrs
	data.Used = data.Next - 1		
	data.Next = 1
end
function Nx.Map:HideExtraIcons()
	local frms = self.IconFrms
	for n = frms.Next, frms.Used do		
		frms[n]:Hide()
	end
	local frms = self.IconNIFrms
	for n = frms.Next, frms.Used do		
		frms[n]:Hide()
	end
	local frms = self.IconStaticFrms
	for n = frms.Next, frms.Used do		
		frms[n]:Hide()
	end
	local data = self.TextFStrs
	for n = data.Next, data.Used do		
		data[n]:Hide()
	end
end
function Nx.Map:GetIcon (levelAdd)
	local frms = self.IconFrms
	local pos = frms.Next
	if pos > 1500 then
		pos = 1500	
	end
	local f = frms[pos]
	if not f then
		f = CreateFrame ("Frame", "NxIcon"..pos, self.Frm)
		frms[pos] = f
		f.NxMap = self
		f:SetScript ("OnMouseDown", self.IconOnMouseDown)
		f:SetScript ("OnMouseUp", self.IconOnMouseUp)
		f:SetScript ("OnEnter", self.IconOnEnter)
		f:SetScript ("OnLeave", self.IconOnLeave)
		f:SetScript ("OnHide", self.IconOnLeave)
		f:EnableMouse (true)
		local t = f:CreateTexture()
		f.texture = t
		t:SetAllPoints (f)
	end
	f:SetFrameLevel (self.Level + (levelAdd or 0))
	f.texture:SetVertexColor (1, 1, 1, 1)
	f.NxTip = nil
	f.NXType = nil			
	f.NXData = nil
	f.NXData2 = nil
	frms.Next = pos + 1
	return f
end
function Nx.Map:GetIconNI (levelAdd)
	local frms = self.IconNIFrms
	local pos = frms.Next
	if pos > 1500 then
		pos = 1500	
	end
	local f = frms[pos]
	if not f then
		f = CreateFrame ("Frame", "NxIconNI"..pos, self.Frm)
		frms[pos] = f
		f.NxMap = self
		local t = f:CreateTexture()
		f.texture = t
		t:SetAllPoints (f)
	end
	local add = levelAdd or 0
	f:SetFrameLevel (self.Level + add)
	f.texture:SetVertexColor (1, 1, 1, 1)
	f.texture:SetBlendMode ("BLEND")
	frms.Next = pos + 1
	return f
end
function Nx.Map:GetIconStatic (levelAdd)
	local frms = self.IconStaticFrms
	local pos = frms.Next
	if pos > 1500 then
		pos = 1500	
	end
	local f = frms[pos]
	if not f then
		f = CreateFrame ("Frame", "NxIconS"..pos, self.Frm)
		frms[pos] = f
		f.NxMap = self
		f:SetScript ("OnMouseDown", self.IconOnMouseDown)
		f:SetScript ("OnMouseUp", self.IconOnMouseUp)
		f:SetScript ("OnEnter", self.IconOnEnter)
		f:SetScript ("OnLeave", self.IconOnLeave)
		f:SetScript ("OnHide", self.IconOnLeave)
		f:EnableMouse (true)
		local t = f:CreateTexture()
		f.texture = t
		t:SetAllPoints (f)
	end
	local add = levelAdd or 0
	f:SetFrameLevel (self.Level + add)
	f.texture:SetVertexColor (1, 1, 1, 1)
	f.NxTip = nil
	f.NXType = nil			
	f.NXData = nil
	f.NXData2 = nil
	frms.Next = pos + 1
	return f
end
function Nx.Map:IconOnMouseDown (button)
	local this = self			
	local map = this.NxMap
	map:CalcClick()
	map.ClickFrm = this
	map.ClickType = this.NXType
	map.ClickIcon = this.NXData
	local shift = IsShiftKeyDown()
	if button == "LeftButton" then
		local cat = floor ((this.NXType or 0) / 1000)
		if cat == 2 and shift then		
			if map.BGIncNum > 0 then
				local _, _, _, str = strsplit ("~", map.BGMsg)
				local _, _, _, str2 = strsplit ("~", this.NXData)
				if str ~= str2 then				
					Nx.Timer:Fire ("BGInc")		
				end
			end
			map.BGMsg = this.NXData
			map.BGIncNum = map.BGIncNum + 1
			UIErrorsFrame:AddMessage ("Inc " .. map.BGIncNum, 1, 1, 1, 1)
			Nx.Timer:Start ("BGInc", 1.5, map, map.BGIncSendTimer)
		elseif cat == 8 then
			map:HotspotDebugClick (button)
		else
			if map:IsDoubleClick() then
				if cat == 3 then
					map:GMenu_OnGoto()
				end
			else
				map.OnMouseDown (map.Frm, button)
			end
		end
	else		
		if button == "RightButton" then
			local typ = this.NXType
			if typ then
				local i = floor (typ / 1000)
				if i == 1 then
					map:BuildPlyrLists()
					map.PIconMenu:Open()
				elseif i == 2 then				
					Nx.Timer:Fire ("BGInc")		
					map.BGMsg = this.NXData
					map.BGIconMenu:Open()
				elseif i == 3 then
					map:GMenuOpen (this.NXData, typ)
				elseif i == 9 then				
					Nx.Quest:IconOnMouseDown (this)
				end
			end
		else
			map.OnMouseDown (map.Frm, button)
		end
	end
end
function Nx.Map:BuildPlyrLists()
	local Map = Nx.Map
	Map.PlyrNames = {}
	Map.AFKers = {}
	local tipStr = ""
	local frms = self.IconFrms
	local f
	local cnt = 0
	for n = 1, frms.Next-1 do
		f = frms[n]
		local plyr = f.NXType == 1000 and f.NXData2
		if plyr then
			local x, y = Nx.Util_IsMouseOver (f)
			if x then
				tinsert (Map.PlyrNames, plyr)
				if f.NXData then
					tinsert (Map.AFKers, f.NXData)
				end
			end
		end
	end
	if #Map.PlyrNames >= 2 then
		tipStr = format (L"\n\n|cff00cf00%s players:", #Map.PlyrNames)
		sort (Map.PlyrNames)
		for _, name in ipairs (Map.PlyrNames) do
			tipStr = tipStr .. "\n" .. name
		end
	end
	Map.PlyrNamesTipStr = tipStr
end
function Nx.Map:IconOnMouseUp (button)
	
	local this = self			
	this.NxMap.OnMouseUp (this.NxMap.Frm, button)
    if self.NXData and type(self.NXData)=="table" and self.NXData.QId and self.NXData.QId>0 and GetQuestLogIndexByID(self.NXData.QId)>0 and button=="LeftButton" then
        Nx_WorldMap_OpenToQuest(self.NXData.QId) 
    end
end
function Nx.Map:IconOnEnter (motion)
	local this = self			
	local map = this.NxMap
	map:BuildPlyrLists()
	if this.NxTip then
		local tt = GameTooltip
		local str = strsplit ("~", this.NxTip)
		local owner = this
		local tippos = "ANCHOR_CURSOR"
		local opts = Nx:GetGlobalOpts()
		if opts["MapTopTooltip"] then
			owner = map.Win.Frm
			tippos = "ANCHOR_TOPLEFT"
		end
		owner.NXIconFrm = this
		tt:SetOwner (owner, tippos, 0, 0)
		Nx:SetTooltipText (str .. Nx.Map.PlyrNamesTipStr)
		owner["UpdateTooltip"] = Nx.Map.IconOnUpdateTooltip
	end
	local t = this.NXType or -1
	if t >= 9000 then					
		Nx.Quest:IconOnEnter (this)
	end
end
function Nx.Map:IconOnUpdateTooltip()
	local f = self.NXIconFrm
	if f and f.NxTip then
		local map = f.NxMap
		map:BuildPlyrLists()
		local str = strsplit ("~", f.NxTip)
		Nx:SetTooltipText (str .. Nx.Map.PlyrNamesTipStr)
		if Nx.Quest.Enabled then
			Nx.Quest:TooltipProcess()
		end
	end
end
function Nx.Map:IconOnLeave (motion)
	local this = self			
	local t = this.NXType or -1
	if t >= 9000 then					
		Nx.Quest:IconOnLeave (this)
	end
	if GameTooltip:IsOwned (this) or GameTooltip:IsOwned (this.NxMap.Win.Frm) then
		GameTooltip:Hide()
	end
end
function Nx.Map:GetText (text, levelAdd)
	local data = self.TextFStrs
	local pos = data.Next
	if pos > 100 then
		pos = 1	
	end
	local fstr = data[pos]
	if not fstr then
		fstr = self.TextFrm:CreateFontString()
		data[pos] = fstr
		fstr:SetFontObject ("NxFontMap")
		fstr:SetJustifyH ("LEFT")
		fstr:SetJustifyV ("TOP")
		fstr:SetHeight (100)
		fstr:SetTextColor (1, 1, 1, 1)
	end
	fstr:SetText (text)
	data.Next = pos + 1
	return fstr
end
function Nx.Map:MoveTextToIcon (fstr, icon, ox, oy)
	local f = icon
	local atPt, relTo, relPt, x, y = f:GetPoint()
	fstr:SetPoint ("TOPLEFT", x + ox, y - oy)
	fstr:Show()
end
function Nx.Map:UpdateInstanceMap()
	local mapId = self.InstMapId
	if not mapId then
		return
	end
	local Map = Nx.Map
	local winfo = Map.MapWorldInfo[mapId]
	local info = self.InstMapInfo				
    
	
		local wx = winfo[2]
		local wy = winfo[3]
		for n = 1, #info, 3 do
			local imgI = 1
			local offx = 0		
			local offy = info[n + 1] * .03 * 668 / 768  
			for by = 0, 2 do
				for bx = 0, 3 do
					local sc = 1
					local f = self:GetIconNI()
					if self:ClipFrameTL (f, wx + bx - offx, wy + by - offy, sc, sc) then
						local tex = info[n + 2]
						tex = "Interface\\WorldMap\\" .. tex .. imgI
						f.texture:SetTexture (tex)
					end
					imgI = imgI + 1
				end
			end
		end
		self.Level = self.Level + 1
	
end
function Nx.Map:GetMap (mapIndex)
	return self.Maps[mapIndex]
end
function Nx.Map:SetTargetName (name)
	local tar = self.Maps[1].Targets[1]
	if tar then
		tar.TargetName = name
	end
end
function Nx.Map:GetTargetInfo()
	local tar = self.Maps[1].Targets[1]
	if tar then
		return tar.TargetType, tar.TargetId
	end
end
function Nx.Map:GetTargetPos()
	local tar = self.Maps[1].Targets[1]
	if tar then
		return tar.TargetX1, tar.TargetY1, tar.TargetX2, tar.TargetY2
	end
end
function Nx.Map:CurrentCenterMap (mapId)
	local map = self.Maps[1]
	map:CenterMap (mapId)
end
function Nx.Map:InitTables()
	local Nx = Nx
	local worldInfo = self.MapWorldInfo
	Nx.MapNameToId = {}
	Nx.MapIdToName = {}
	Nx.MapIdToNxzone = {}
	self.NxzoneToMapId = {}
	Nx.NxzoneToMapId = self.NxzoneToMapId
	Nx.MapOverlayToMapId = {}
	
	
	
	self.MapNames = {
		{ GetMapZones (1) },
		{ GetMapZones (2) },
		{ GetMapZones (3) },
		{ GetMapZones (4) },
		{ GetMapZones (5) },
		{ GetMapZones (6) },
	}
	
	for mi, mapName in pairs (self.MapNames[2]) do
		for mi2, mapName2 in pairs (self.MapNames[2]) do
			if mapName == mapName2 and mi ~= mi2 then			
				self.MapNames[2][mi2] = mapName .. "2"			
				break
			end
		end
	end
	
	local BGNames = {}
	self.MapNames[9] = BGNames
	for n = 1, 999 do
		local winfo = worldInfo[9000 + n]
		if not winfo then
			break
		end
		BGNames[n] = NXlMapNames[winfo.Name] or winfo.Name
	end
    
    for k,v in pairs(Nx.Zones) do
        local name, _, _, _, c = strsplit("!", v)
        local found
        if(c~="" and c~="4" and c~="5" and c~="10") then
            c = tonumber(c)
            if c>=7 then c=c-3 end
            for _, nn in pairs(self.MapNames[c]) do
                if nn==name then
                    found = true
                    break
                end
            end
            if not found then
                tinsert(self.MapNames[c],NXlMapNames[name] or name)
                
            end
        end
    end	
	
	
	self.ContCnt = 6
	local continentNums = { 1, 2, 3, 4, 5, 6, 9 }
    if Nx.GuideData then
        for _, tbl in pairs(Nx.GuideData) do
            for i=1,self.ContCnt do
                if not tbl[i] then tbl[i] = "" end
            end
        end
    end
	local CZ2Id = {}
	self.CZ2Id = CZ2Id
	for _, ci in pairs (continentNums) do
		local z2id = {}
		CZ2Id[ci] = z2id
		
		for n = 1, 999 do
			local mapId = ci * 1000 + n
			local winfo = worldInfo[mapId]
			if not winfo then
				break
			end
			if Nx.PlFactionNum == 0 and winfo.QAchievementIdA then
				winfo.QAchievementId = winfo.QAchievementIdA				
			end
			if Nx.PlFactionNum == 1 and winfo.QAchievementIdH then
				winfo.QAchievementId = winfo.QAchievementIdH				
			end
			
			local locName = NXlMapNames[winfo.Name] or winfo.Name
			for i, name in pairs (self.MapNames[ci]) do
				if name == locName then
					if DEBUG_MODE and z2id[i] then Nx.prt(format('MapId %d and %d has same name %s', z2id[i], mapId, name)) end
					z2id[i] = mapId
					if not DEBUG_MODE then break end
				end
			end
		end
		for k, v in pairs (CZ2Id[ci]) do
			worldInfo[v].Cont = ci
			worldInfo[v].Zone = k
			local ov = worldInfo[v].Overlay
			if ov then
				Nx.MapOverlayToMapId[ov] = v
			end
		end
	end
	for n = 1, self.ContCnt do
		CZ2Id[n][0] = n * 1000
	end
	
	for _, ci in pairs (continentNums) do
		for mi, mapName in pairs (self.MapNames[ci]) do
			local mid = self.CZ2Id[ci][mi]
			if Nx.MapNameToId[mapName] then
				Nx.prt ("Dup map name: %s (%s %s)", mapName, ci, mi)
				Nx.MapNameToId[mapName .. "2"] = mid
			else
				Nx.MapNameToId[mapName] = mid
			end
			if not mid then
				
				Nx.prt ("Unknown map name: %s (%s %s)", mapName, ci, mi)
			else
				Nx.MapIdToName[mid] = mapName
			end
		end
	end
	
	
    
	if DEBUG_MODE then
		for k, v in pairs(Nx.Map.MapWorldInfo) do
			local name = v.Name and NXlMapNames[v.Name] or v.Name
			if k%1000>0 and k<9000 and name and not Nx.MapNameToId[name] then
				Nx.prt(format("MapWorldInfo that not matched by name id='%d', name='%s'", k, tostring(name)))
				
				
			end
		end
	end
	
	for id, area in pairs (Nx.Map.MapGenAreas) do
		local s = Nx.Zones[id]
		local name = s and strsplit ("!", s)
		local mapId = name and Nx.MapNameToId[name]
		if not mapId then
			Nx.prt ("Err MapGenAreas %d %s", id, tostring(name))
		else
			local cont = floor (mapId / 1000)
			if cont <= 2 or cont == 5 then
				local wi = worldInfo[mapId]
				wi[1] = area[1]				
				wi[2] = area[2]				
				wi[3] = area[3]				
				if wi.XOff then	
					wi[2] = wi[2] + wi.XOff	
					wi[3] = wi[3] + wi.YOff	
					wi.XOff = nil
					wi.YOff = nil
				end
				wi.Overlay = area[4]
			end
		end
	end
	Nx.Map.MapGenAreas = nil
	
    
	for _, ci in pairs (continentNums) do
		local info = self.MapInfo[ci]
		local cx = info.X
		local cy = info.Y
		for n = 0, 999 do
			local winfo = worldInfo[ci * 1000 + n]
			if not winfo then
				break
			end
			winfo[4] = cx + winfo[2]
			winfo[5] = cy + winfo[3]
		end
	end
	
	for id, v in pairs (Nx.Zones) do
		local name, minLvl, maxLvl, faction, cont, entryId, entryPos = strsplit ("!", v)
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		if faction == "3" and cont == "5" then		
			assert (entryId and entryPos)
			if entryId == "0" then
				if(entryPos~="####") then Nx.prt("Instance entrance zone num is 0 : "..id..", "..v) end
				
			end
			local entryZone = Nx.Zones[tonumber (entryId)]
			local ename, _, _, _, cont = strsplit ("!", entryZone)
			if cont == "7" then
				cont = 4
			end
			if cont == "8" then
				cont = 5
			end
			local mid = cont * 1000 + 10000 + id  
			Nx.MapNameToId[name] = mid
			Nx.MapIdToName[mid] = name
			local emid = Nx.MapNameToId[ename]
			local ex, ey = Nx.Quest:UnpackLocPt (entryPos)
			if self.MapWorldInfo[mid] then			
				ex = ex + self.MapWorldInfo[mid][2]
				ey = ey + self.MapWorldInfo[mid][3]
			end
			local x, y = self:GetWorldPos (emid, ex, ey)
			local ewinfo = self.MapWorldInfo[emid]
			if not ewinfo then
			end
			local winfo = {}
			winfo.EntryMId = emid  
			winfo[1] = 1002 / 25600 
			winfo[2] = x				
			winfo[3] = y				
			winfo[4] = x				
			winfo[5] = y				
			self.MapWorldInfo[mid] = winfo
		end
	end
	
	for id, v in pairs (Nx.Zones) do
		local name, minLvl, maxLvl, faction = strsplit ("!", v)
		local mapId = Nx.MapNameToId[name]
		if mapId then
			if not Nx.MapIdToNxzone[mapId] then
				Nx.MapIdToNxzone[mapId] = id
			else
				Nx.prt ("Map Init %s %s dup %s", name, id, Nx.MapIdToNxzone[mapId])
			end
			self.NxzoneToMapId[id] = mapId
		else
			
            if id>0 and DEBUG_MODE then Nx.prt("No mapId for id=%d, nam=%s", id, name) end
            
		end
	end
	
	Nx.AIdToId = {}
	Nx.IdToAId = {}
	for aid, zid in pairs (Nx.ID2Zone) do
		if zid ~= 0 then
			local id = self.NxzoneToMapId[zid]
			Nx.AIdToId[aid] = id
			if id then
				Nx.IdToAId[id] = aid
			end
		end
	end
    for k,v in next, Nx.Map.MapLevels do 
        for _, mapId in next, v do Nx.Map.MapWorldInfo[mapId].Level1Id = Nx.Map.MapWorldInfo[mapId].Level1Id or Nx.AIdToId[k] end
    end
	
	
	
	for k, v in pairs (Nx.Zones) do
		local name, minLvl, maxLvl, faction, cont, entryId = strsplit ("!", v)
		if faction ~= "3" then		
			if entryId and entryId ~= "" then
				self.NxzoneToMapId[k] = self.NxzoneToMapId[tonumber (entryId)]
			end
		end
	end
	
	Nx.ZoneConnections = Nx["ZoneConnections"] or Nx.ZoneConnections	
	
	for ci = 1, self.ContCnt do
		for n = 0, 999 do
			local mapId = ci * 1000 + n
			local winfo = worldInfo[mapId]
			if not winfo then
				break
			end
			local cons = {}
			winfo.Connections = cons
			for _, str in pairs (Nx.ZoneConnections) do
				local flags, ta, tb, z1, x1a, x1b, y1a, y1b, z2, x2a, x2b, y2a, y2b, name1len = strbyte (str, 1, 14)
				flags = flags - 35
				local conTime = (ta - 35) * 221 + tb - 35
				local mapId1 = self.NxzoneToMapId[z1 - 35]
				local mapId2 = self.NxzoneToMapId[z2 - 35]
				if not (mapId1 and mapId2) then
					conTime = 0
				end
				if conTime == 1 and (mapId == mapId1 or (mapId == mapId2 and bit.band (flags, 1) == 1)) then
					local cont1 = self:IdToContZone (mapId1)
					local cont2 = self:IdToContZone (mapId2)
					if cont1 == cont2 then
						name1len = name1len - 35
						local name1 = name1len == 0 and "" or strsub (str, 15, 14 + name1len)
						local i = 15 + name1len
						local name2len = strbyte (str, i)
						local name2 = name2len == 0 and "" or strsub (str, i + 1, i + name2len)
						local x1 = ((x1a - 35) * 221 + x1b - 35) / 100
						local y1 = ((y1a - 35) * 221 + y1b - 35) / 100
						local x2 = ((x2a - 35) * 221 + x2b - 35) / 100
						local y2 = ((y2a - 35) * 221 + y2b - 35) / 100
						if mapId == mapId2 then		
							mapId1, mapId2 = mapId2, mapId1
							x1, y1, x2, y2 = x2, y2, x1, y1
						end
						local zcons = cons[mapId2] or {}
						cons[mapId2] = zcons
						if x1 ~= 0 and y1 ~= 0 then	
							local con = {}
							tinsert (zcons, con)
							x1, y1 = self:GetWorldPos (mapId1, x1, y1)
							x2, y2 = self:GetWorldPos (mapId2, x2, y2)
							con.StartMapId = mapId1
							con.StartX = x1
							con.StartY = y1
							con.EndMapId = mapId2
							con.EndX = x2
							con.EndY = y2
							con.Dist = ((x1 - x2) ^ 2 + (y1 - y2) ^ 2) ^ .5
						end
					end
				end
			end
		end
	end
end
function Nx.Map:ConnectionUnpack (str)
	local flags, ta, tb, z1, x1a, x1b, y1a, y1b, z2, x2a, x2b, y2a, y2b, name1len = strbyte (str, 1, 14)
	flags = flags - 35
	local conTime = (ta - 35) * 221 + tb - 35
	local mapId1 = self.NxzoneToMapId[z1 - 35]
	local mapId2 = self.NxzoneToMapId[z2 - 35]
	name1len = name1len - 35
	local name1 = name1len == 0 and "" or strsub (str, 15, 14 + name1len)
	local i = 15 + name1len
	local name2len = strbyte (str, i)
	local name2 = name2len == 0 and "" or strsub (str, i + 1, i + name2len)
	local x1 = ((x1a - 35) * 221 + x1b - 35) / 100
	local y1 = ((y1a - 35) * 221 + y1b - 35) / 100
	local x2 = ((x2a - 35) * 221 + x2b - 35) / 100
	local y2 = ((y2a - 35) * 221 + y2b - 35) / 100
	return flags, conTime, mapId1, x1, y1, mapId2, x2, y2, name1, name2
end
function Nx.Map:CZ2MapId (cont, zone)
	if cont <= 0 then
		return 9000
	end
	return self.CZ2Id[cont][zone]
end
function Nx.Map:GetRealBaseMapId()
    return Nx.CurrMapID and Nx.Map.MapWorldInfo[Nx.CurrMapID].Level1Id or Nx.CurrMapID or Nx.MapNameToId[GetRealZoneText()] or 9000
	
end
function Nx.Map:GetRealMapId()
	local zName = GetRealZoneText()
	
	if Nx.CurrMapID then
        if Nx.CurrDungeonLevel and Nx.Map.MapLevels[Nx.CurrAreaID] and Nx.Map.MapLevels[Nx.CurrAreaID][Nx.CurrDungeonLevel] then
            return Nx.Map.MapLevels[Nx.CurrAreaID][Nx.CurrDungeonLevel]
        elseif IsInInstance() or (NXlConflictMapName and NXlConflictMapName[zName]) then
            return Nx.CurrMapID
        else
            return Nx.CurrMapID
            
        end
	else	
		local mapId = Nx.MapNameToId[zName] or 9000
		
		
		
		
		return mapId
	end
end
function Nx.Map:GetCurrentMapId()
	
	local cont = GetCurrentMapContinent()
	local zone = GetCurrentMapZone()
    local aid=GetCurrentMapAreaID()
    if Nx.Map.MapLevels[aid] then
        local mapId = Nx.Map.MapLevels[aid][GetCurrentMapDungeonLevel()]
        if mapId then return mapId end
    end
	if cont <= 0 or cont > 6 then
		local aid = GetCurrentMapAreaID()
        
        
        
        
		local id = Nx.AIdToId[aid]
		if id then
        
			return id
		end
		return self:GetRealMapId()
	end
	local mapId = self.CZ2Id[cont][zone] or 9000
	if mapId == Nx.MapNameToId[GetRealZoneText()] then		
		return self:GetRealMapId()
	else
		return mapId
	end
end
function Nx.Map:GCMI_OVERRIDE(mapId)
    return mapId and Nx.Map:GetWorldZone(mapId) and Nx.Map:GetWorldZone(mapId).overrideMapWorldId or mapId
end
function Nx.Map:SetCurrentMap (mapId)
	if mapId then
        
		self.BaseScale = 1
		if mapId > 1000 and mapId < 7000 then
			local cont = self.MapWorldInfo[mapId].Cont
			local zone = self.MapWorldInfo[mapId].Zone
			if not cont or not zone or mapId == self:GetRealBaseMapId() or mapId == self:GetRealMapId() then 
				SetMapToCurrentZone()		
				
			else
				if self.MapWorldInfo[mapId].UseAId then
					SetMapByID (Nx.IdToAId[mapId])
				else
					SetMapZoom (cont, zone)
				end
			end
		elseif mapId > 11000 then	
			self.BaseScale = .025
			local aid = Nx.IdToAId[mapId]
			
			if aid then
				self.MapId = 0				
				if mapId == self:GetRealBaseMapId() then
					SetMapToCurrentZone()
				else
					local caid = GetCurrentMapAreaID()
					if caid ~= aid then
						
						
						SetMapByID (aid)
						SetDungeonMapLevel (GetCurrentMapDungeonLevel())
					end
				end
			else
				if mapId == self:GetRealBaseMapId() then
					self.MapId = 0				
					SetMapToCurrentZone()
				else
					self.MapId = mapId
					SetMapZoom (-1)			
				end
			end
		end
		self.InstLevelSet = GetCurrentMapDungeonLevel()
	end
end
function Nx.Map:SetToCurrentZone()
	SetMapToCurrentZone()
	
	
end
function Nx.Map:SaveView (name)
	local str = format ("%s%s", Nx.InBG or "", name)
	local v = self.ViewSavedData[str]
	if not v then
		v = {}
		self.ViewSavedData[str] = v
	end
	v.Scale = self.Scale
	v.X = self.MapPosX
	v.Y = self.MapPosY
end
function Nx.Map:RestoreView (name)
	local str = format ("%s%s", Nx.InBG or "", name)
	local v = self.ViewSavedData[str]
	if v then
		self.Scale = v.Scale
		self.MapPosX = v.X
		self.MapPosY = v.Y
		self.StepTime = 5
	end
end
function Nx.Map:Move (x, y, scale, stepTime)
	self.MapPosX = x
	self.MapPosY = y
	if scale then
		self.Scale = scale
	end
	local dist = ((self.MapPosXDraw - self.MapPosX) ^ 2 + (self.MapPosYDraw - self.MapPosY) ^ 2) ^ .5
	local sz = max (self.MapW, self.MapH)
	if dist * self.Scale / sz > 10 then	
		stepTime = 1	
	end
    
    local curr = GetTime()
    local last = self.MoveLastTime or curr-1
    if curr - last < 0.3 then stepTime = 1 end
    self.MoveLastTime = curr
	local st = abs (self.StepTime)	
	if st > 0 and st < stepTime then		
		stepTime = st
	end
	self.StepTime = stepTime
	if dist < .25 then
		self.MapPosXDraw = self.MapPosX
		self.MapPosYDraw = self.MapPosY
	end
	if abs (1 / self.ScaleDraw - 1 / self.Scale) < .01 then
		self.ScaleDraw = self.Scale
		if dist < .25 then
			self.StepTime = 0
		end
	end
end
function Nx.Map:GotoCurrentZone()
	if self.InstanceId then
		self:Move (self.PlyrX, self.PlyrY, 20, 30)
	else
		self:SetToCurrentZone()
		local mapId = self:GetCurrentMapId()
		self:CenterMap (mapId)
	end
end
function Nx.Map:GotoPlayer()
	self:CalcTracking()
	self:SetToCurrentZone()
	self.MoveLastX = -1
	self.MoveLastY = -1
end
function Nx.Map:CenterMap (mapId, scale)
	mapId = mapId or self.MapId
	if self:GetWorldZone (mapId).City then
		scale = 1
	end
	self.MapW = self.Frm:GetWidth() - self.PadX * 2
	self.MapH = self.Frm:GetHeight() - self.TitleH
	local x, y = self:GetWorldPos (mapId, 50, 50)
	local size = min (self.MapW / 1002, self.MapH / 668)
	if self.MapW < GetScreenWidth() / 2 then
		size = size * (scale or 1.5)
	end
	local scale = size / self:GetWorldZoneScale (mapId) * 10.02
	self:Move (x, y, scale, 30)
end
function Nx.Map:CenterMap1To1 (mapId)
	self.MapPosX, self.MapPosY = self:GetWorldPos (mapId, 50, 50)
	self.Scale = 1002 / 100 / self:GetWorldZoneScale (mapId) * GetScreenWidth() / 1680 * 2
	self.ScaleDraw = self.Scale
	self.StepTime = 10
end
function Nx.Map:IdToContZone (mapId)
	if mapId >= 10000 then
		return floor (mapId / 1000) - 10, 0
	end
	local info = self.MapWorldInfo[mapId]
	return info.Cont or 9, info.Zone or 0
end
function Nx.Map:IdToName (mapId)
	
	return Nx.MapIdToName[mapId] or (self.MapWorldInfo[mapId] and self.MapWorldInfo[mapId].Name) or "?"
end
function Nx.Map:NameToId (mapName)
	return Nx.MapNameToId[mapName]
end
function Nx.Map:IsNormalMap (mapId)
	return mapId > 1000 and mapId % 1000 > 0 and mapId < 7000 
end
function Nx.Map:IsOutlandMap (mapId)
	return mapId >= 3000 and mapId <= 3999
end
function Nx.Map:IsInstanceMap (mapId)
	return mapId >= 10000
end
function Nx.Map:IsBattleGroundMap (mapId)
	return mapId >= 9001 and mapId <= 9099
end
function Nx.Map:GetShortName (mapId)
	return Nx.Map.MapWorldInfo[mapId].Short
end
function Nx.Map:GetWorldContinentInfo (cont)
	local info = self.MapInfo[cont]
	if not info then
		return
	end
	return info.Name, info.X, info.Y
end
function Nx.Map:GetWorldZoneInfo (cont, zone)
	local nt = self.MapNames[cont] or self.MapNames[5]
	local name = nt[zone] or "?"
	local info = self.MapInfo[cont]
	if not info then
		return name, 0, 0, 1002, 668
	end
	local id = self.CZ2Id[cont][zone]
	local winfo = self.MapWorldInfo[id]
	if not winfo then
		return
	end
	local x = info.X + winfo[2]
	local y = info.Y + winfo[3]
	local scale = winfo[1] * 100
	return name, x, y, scale, scale / 1.5		
end
function Nx.Map:GetWorldZone (mapId)
	return self.MapWorldInfo[mapId]
end
function Nx.Map:GetWorldZoneScale (mapId)
	return self.MapWorldInfo[mapId][1]
end
function Nx.Map:GetWorldPos (mapId, mapX, mapY)
	local winfo = self.MapWorldInfo[mapId]
	if winfo then
		local scale = winfo[1]
		return	winfo[4] + mapX * scale,
					winfo[5] + mapY * scale / 1.5
	end
	return 0, 0
end
function Nx.Map:GetWorldRect (mapId, mapX, mapY, mapX2, mapY2)
	local x, y = self:GetWorldPos (mapId, mapX, mapY)
	local x2, y2 = self:GetWorldPos (mapId, mapX2, mapY2)
	return x, y, x2, y2
end
function Nx.Map:GetZonePos (mapId, worldX, worldY)
	local winfo = self.MapWorldInfo[mapId]
	if winfo then
		local scale = winfo[1]
		return	(worldX - winfo[4]) / scale,
					(worldY - winfo[5]) / scale * 1.5
	end
	return 0, 0
end
function Nx.Map:FramePosToWorldPos (x, y)
	x = self.MapPosX + (x - self.PadX - self.MapW / 2) / 10.02 / self.MapScale
	y = self.MapPosY + (y - self.TitleH - self.MapH / 2) / 10.02 / self.MapScale
	return x, y
end
function Nx.Map:SetTarget (typ, x1, y1, x2, y2, tex, id, name, keep, mapId)
	self.UpdateTrackingDelay = 0
	local sbt = self.ScaleBeforeTarget
		self.ScaleBeforeTarget = false
	if not keep then
		self:ClearTargets()
	end
	self.ScaleBeforeTarget = sbt or not next (self.Targets) and self.GOpts["MapRestoreScaleAfterTrack"] and self.Scale
	local tar = {}
	tinsert (self.Targets, tar)
	assert (x1)
	tar.TargetType = typ
	tar.TargetX1 = x1
	tar.TargetY1 = y1
	tar.TargetX2 = x2
	tar.TargetY2 = y2
	tar.TargetMX = (x1 + x2) * .5		
	tar.TargetMY = (y1 + y2) * .5
	tar.TargetTex = tex
	tar.TargetId = id
	tar.TargetName = name
	mapId = mapId or self.MapId
	tar.MapId = mapId
	local i = self.TargetNextUniqueId
	tar.UniqueId = i
	self.TargetNextUniqueId = i + 1
	local typ = keep and "Target" or "TargetS"
	local zx, zy = self:GetZonePos (mapId, tar.TargetMX, tar.TargetMY)
	Nx.Fav:Record (typ, name, mapId, zx, zy)
	return tar
end
function Nx.Map:ClearTargets (matchType)
	if matchType then
		local tar = self.Targets[1]
		if tar then
			if tar.TargetType ~= matchType then
				return
			end
		end
	end
	self.Targets = {}
	self.Tracking = {}
	if self.LOpts.NXAutoScaleOn and self.ScaleBeforeTarget then
		self:GotoPlayer()		
		self:Move (self.PlyrX, self.PlyrY, self.ScaleBeforeTarget, 60)
	end
	self.ScaleBeforeTarget = false
end
function Nx.Map:ClearTarget (uniqueId)
	self.Tracking = {}
	local tar, i = self:FindTarget (uniqueId)
	if tar then
		tremove (self.Targets, i)
	end
end
function Nx.Map:FindTarget (uniqueId)
	for n, tar in ipairs (self.Targets) do
		if tar.UniqueId == uniqueId then
			return tar, n
		end
	end
end
function Nx.Map:ChangeTargetOrder (srcI, dstI)
	srcI = srcI >= 0 and srcI or #self.Targets	
	local t = tremove (self.Targets, srcI)
	tinsert (self.Targets, dstI, t)
	self.Tracking = {}
end
function Nx.Map:ReverseTargets()
	local tar = self.Targets
	local n2 = #tar
	for n = 1, n2 / 2 do
		local a = tar[n]
		tar[n] = tar[n2]
		tar[n2] = a
		n2 = n2 - 1
	end
	self.Tracking = {}
end
function Nx.Map:SetTargetXY (mid, zx, zy, name, keep)
	Nx.Quest.Watch:ClearAutoTarget()
	local wx, wy = self:GetWorldPos (mid, zx, zy)
	return self:SetTarget ("Goto", wx, wy, wx, wy, nil, nil, name or "", keep, mid)
end
function Nx.Map:SetTargetAtClick()
	Nx.Quest.Watch:ClearAutoTarget()
	local wx, wy = self:FramePosToWorldPos (self.ClickFrmX, self.ClickFrmY)
	local zx, zy = self:GetZonePos (self.MapId, wx, wy)
	local str = format (L"Goto %.0f, %.0f", zx, zy)
	self:SetTarget ("Goto", wx, wy, wx, wy, nil, nil, str, IsShiftKeyDown())
end
function Nx.Map:SetTargetAtStr (str, keep)
	local mId, zx, zy = self:ParseTargetStr (str)
	if mId then
		local wx, wy = self:GetWorldPos (mId, zx, zy)
		local str = format ("%.0f, %.0f", zx, zy)
		self:SetTarget ("Goto", wx, wy, wx, wy, nil, nil, str, keep, mId)
	end
end
function Nx.Map:ParseTargetStr (str)
	local str = gsub (strlower (str), ",", " ")
	local zone
	local zx, zy
	for s in gmatch (str, "%S+") do
		local i = tonumber (s)
		if i then
			if zx then
				zy = zy or i
			else
				zx = i
			end
		else
			if zone then
				zone = zone .. " " .. s
			else
				zone = s
			end
		end
	end
	local mid = self.RMapId
	if zone then
		mid = nil
		for name, id in pairs (Nx.MapNameToId) do
			if strfind (strlower (name), zone, 1, true) then
				mid = id
				break
			end
		end
		if not mid then
			Nx.prt ("zone %s not found", zone)
			return
		end
	end
	if not zx or not zy then
		Nx.prt ("zone coordinate error")
		return
	end
	return mid, zx, zy
end
function Nx:TTAddWaypoint (zx, zy, name)
	local map = Nx.Map:GetMap (1)
	local mid = map:GetCurrentMapId()
	local tar = map:SetTargetXY (mid, zx, zy, name, true)
	map:ChangeTargetOrder (-1, 1)
	return tar.UniqueId
end
function Nx:TTAddZWaypoint (cont, zone, zx, zy, name, _persist, _minimap, _world, callbackT)
	local map = Nx.Map:GetMap (1)
	local mid = map:GetCurrentMapId()
	if cont and zone then
		mid = map:CZ2MapId (cont, zone)
	end
	return Nx:TTSetTarget (mid, zx, zy, name, callbackT)
end
function Nx:TTSetCustomWaypoint (cont, zone, zx, zy, callbackT)
	return Nx:TTAddZWaypoint (cont, zone, zx, zy, "", false, nil, nil, callbackT)
end
function Nx:TTSetCustomMFWaypoint (aid, _floor, zx, zy, opts)
	zx = zx * 100
	zy = zy * 100
	return Nx:TTSetTarget (Nx.AIdToId[aid], zx, zy, opts["title"], opts["callbacks"])
end
function Nx:TTSetTarget (mid, zx, zy, name, callbackT)
	local map = Nx.Map:GetMap (1)
	local tar = map:SetTargetXY (mid, zx, zy, name, true)
	map:ChangeTargetOrder (-1, 1)
	if callbackT and callbackT["distance"] then
		local d = 99999
		local f
		for dist, func in pairs (callbackT["distance"]) do
			if dist < d then
				d = dist
				f = func
			end
		end
		tar.Radius = d
		tar.RadiusFunc = f
	end
	return tar.UniqueId
end
function Nx:TTRemoveWaypoint (id)
	local map = Nx.Map:GetMap (1)
	map:ClearTarget (id)
end
function Nx:TTSetCrazyArrow (id, dist, str)
	local map = Nx.Map:GetMap (1)
	local tar = map:FindTarget (id)
	if tar then
		tar.Radius = dist
		tar.TargetName = str
	end
end
function Nx:CartGetDistanceToPoint (zx, zy, mapName)
	local map = Nx.Map:GetMap (1)
	local mapId = Nx.MapNameToId[mapName]
	if not mapId then
		return 1000
	end
	local wx, wy = map:GetWorldPos (mapId, zx * 100, zy * 100)
	local x = wx - map.PlyrX
	local y = wy - map.PlyrY
	local distYd = (x * x + y * y) ^ .5 * 4.575
	return distYd
end
function Nx:CartSetPointAsWaypoint (zx, zy)
	Nx:TTAddZWaypoint (nil, nil, zx * 100, zy * 100, "Waypoint")
end
function Nx:CartAddLHWaypoint (cont, zone, zx, zy, name)
	Nx:TTAddZWaypoint (cont, zone, zx, zy, name)
end
function Nx:CartAddRoutesWaypoint (mapName, yx, name)
	local map = Nx.Map:GetMap (1)
	local mapId = Nx.MapNameToId[mapName]
	local cont, zone
	if mapId then
		cont, zone = map:IdToContZone (mapId)
	end
	local zx = (yx % 10001) / 100
	local zy = floor (yx / 10001) / 100
	Nx:TTAddZWaypoint (cont, zone, zx, zy, name)
end
function Nx:CartAddWaypoint (note)
	local map = Nx.Map:GetMap (1)
	local mapId = Nx.MapNameToId[note["z"]]
	local cont, zone
	if mapId then
		cont, zone = map:IdToContZone (mapId)
	end
	local id = Nx:TTAddZWaypoint (cont, zone, note["x"] * 100, note["y"] * 100, note["n"])
	note["WaypointID"] = id
end
function Nx:CartCancelWaypoint (id)
	local map = Nx.Map:GetMap (1)
	map:ClearTargets()						
end
function Nx:CartSetWaypointHitDistance (dist)
	local map = Nx.Map:GetMap (1)
	if map.Targets[1] then
		map.Targets[1].Radius = dist
	end
end
function Nx:CartNotePointNew (zone, x, y, name)
	local note = {}
	if not y then
		y = floor (x / 10001) / 100
		x = (x % 10001) / 100
	end
	note["z"] = zone
	note["x"] = x
	note["y"] = y
	note["n"] = name or ""
	return note
end
function Nx.MapMinimapOwned()
	local map = Nx.Map:GetMap (1)
	return map.MMOwn
end
function Nx.MapInitIconType (iconType, drawMode)
	local map = Nx.Map:GetMap (1)
	map:InitIconType (iconType, drawMode)
end
function Nx.MapAddIconPoint (iconType, mapName, x, y, texture)
	local map = Nx.Map:GetMap (1)
	local mapId = Nx.MapNameToId[mapName]
	if mapId then
		local wx, wy = map:GetWorldPos (mapId, x, y)
		map:AddIconPt (iconType, wx, wy, nil, texture)
	end
end
function Nx.MapAddIconRect (iconType, mapName, x, y, x2, y2, color)
	local map = Nx.Map:GetMap (1)
	local mapId = Nx.MapNameToId[mapName]
	if mapId then
		map:AddIconRect (iconType, mapId, x, y, x2, y2, color)
	end
end
function Nx.MapSetIconTip (icon, tip)
	local map = Nx.Map:GetMap (1)
	map:SetIconTip (icon, tip)
end
function Nx.NXMapKeyTargetSkip()
	local self = Nx.Map:GetMap (1)
	local tar = self.Targets[1]
	if tar then
		tar.Radius = 999999999999
	end
end
function Nx.Map.Dock:Create(time)
	if Nx.Free then
		return
	end
	self.UpdateMod = 100		
	local gopts = Nx.GetGlobalOpts()
	self.GOpts = gopts
	if not gopts["MapMMButOwn"] then
		return
	end
    if MiniMapWorldMapButton.border then return end 
    MiniMapWorldMapButton.border = MiniMapWorldMapButton:CreateTexture(nil, "OVERLAY")
    MiniMapWorldMapButton.border:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
    MiniMapWorldMapButton.border:SetSize(54,54)
    MiniMapWorldMapButton.border:SetPoint("TOPLEFT")
	
	Nx.Window:SetCreateFade (1, 0)
	local win = Nx.Window:Create ("NxMapDock", nil, nil, nil, 1, 1, nil, true)
	self.Win = win
	win:SetBGAlpha (0, 1)
	win:CreateButtons()
	win:InitLayoutData (nil, 100045, -.08, 45, 50, 2)
	win.Frm:SetToplevel (true)
	self:UpdateOptions()
	self.InitPending = true
	Nx.Timer:Start ("DockMinimapScan", time or 3, self, self.MinimapOwnInit)
end
function Nx.Map.Dock:MinimapOwnInit()
	self.InitPending = nil
	local map = Nx.Map:GetMap (1)
	local mm = getglobal ("Minimap")
	local mmOwnerNames = {
		"NXMiniMapBut", "GameTimeFrame", "TimeManagerClockButton", "MiniMapWorldMapButton", "MiniMapMailFrame", "MiniMapTracking", "MiniMapVoiceChatFrame", 
		"QueueStatusMinimapButton","MiniMapInstanceDifficulty",
	}
	local f = getglobal ("MinimapBackdrop")	
	map.MMOwnedFrms[f] = 0
	self.MMFrms = {}
	for k, name in ipairs (mmOwnerNames) do
		local f = getglobal (name)
		if f then
			map.MMOwnedFrms[f] = 0
			tinsert (self.MMFrms, f)
			f:SetParent (self.Win.Frm)
			if name == "MiniMapTracking" then
				f:Show()
			end
		end
	end
	
	local texnames = { ["Interface\\AddOns\\CT_Core\\Images\\minimapIcon"] = 1, }
	local mapf = map.Frm
	local winf = self.Win.Frm
	local found = {}
	local f = EnumerateFrames()
	while f do
		if not f:IsObjectType ("Model") then
			local pt, relTo = f:GetPoint()
			if relTo == mm then
				local parent = f:GetParent()
				if (parent ~= mm and parent ~= mapf) or (f:GetName() and f:GetName():find("^LibDBIcon")) then
					found[f] = 1
				end
			end
			if not found[f] then
				local reg = { f:GetRegions() }
				for k, v in ipairs (reg) do
					if v:IsObjectType ("Texture") then
						local tname = v:GetTexture()
						if tname and texnames[tname] then
	
	
							found[f] = 1
							break
						end
					end
				end
			end
		end
		f = EnumerateFrames (f)
	end
	
	for f in pairs (found) do
		if not map.MMOwnedFrms[f] then
			map.MMOwnedFrms[f] = 0
			tinsert (self.MMFrms, f)
			f:SetParent (winf)
		end
	end
	map.Win:Show (map.StartupShown)
	Nx.Map:MinimapButtonShowUpdate()
	if NxData.DebugDock then
		Nx.prt ("DockScan %s", #self.MMFrms)
	end
end
function Nx.Map.Dock:UpdateOptions()
	local win = self.Win
	if win then
		local lock = win:IsLocked()
		win:SetBGAlpha (0, lock and 0 or 1)
		self.UpdateMod = 1
	end
end
function Nx.Map.Dock:MinimapDetachFrms(map)
	if map.Tick % self.UpdateMod ~= 0 then  
		return
	end
	if not self.Win then
		return
	end
	self.UpdateMod = 30
	if NxData.DebugDock then
		Nx.prt ("Dock %s", #self.MMFrms)
	end
	local mm = getglobal ("Minimap")
	local mmClock = getglobal ("TimeManagerClockButton")
	local win = self.Win
	local winf = win.Frm
	local butLvl = winf:GetFrameLevel() + 1
	local cLvl = butLvl + 1
	local setCLvls = Nx.Util_SetChildLevels
	local strata = winf:GetFrameStrata()
	local mini = self.GOpts["MMButWinMinimize"]
	local cx, cy = win:GetClientOffset()
	local cw, ch = win:GetSize()
	local columnCnt = mini and 1 or self.GOpts["MapMMButColumns"]		
	local columnStart = 0
	local columnEnd = columnCnt - 1
	local colAdd = 1
	local spacing = self.GOpts["MapMMButSpacing"]
	local yAdd = spacing
	local y = cy + 6
	local s = self.GOpts["MapMMButCorner"]
	if s == "TopRight" or s == "BottomRight" then
		columnEnd = -columnEnd
		colAdd = -1
	end
	if s == "BottomLeft" or s == "BottomRight" then
		yAdd = -yAdd
		y = cy - 6
	end
	local column = columnStart
	local borderSize = win:GetBorderSize()
	local baseX = borderSize + 17
	local baseY = y
	local incRow
	for n, f in ipairs (self.MMFrms) do
		if f:IsVisible() then
			local w = f:GetWidth()
			if w > 0 then
				local sc = 32 / max (w, 32)
				if incRow then
					incRow = false
					column = columnStart
					y = y + yAdd
				end
				if mini and n > 1 then
					column = 0
					y = baseY
					butLvl = 1
					cLvl = 1
					sc = .1
				end
				local x = baseX + column * spacing
				f:SetParent (winf)
				f:ClearAllPoints()
				if f == mmClock then
					sc = sc * 1.5
				end
				f:SetPoint ("CENTER", winf, "TOPLEFT", x / sc, -y / sc)
				f:SetScale (sc)
				f:SetFrameStrata (strata)
				f:SetFrameLevel (butLvl)
				setCLvls (f, cLvl)
				if column == columnEnd then
					incRow = true
				end
				column = column + colAdd
			end
		elseif f:IsShown() then		
			f:Show()
		end
	end
	if not win.MovSizing then
		local x = winf:GetLeft()
		win:SetSize (34, 11)
	end
	
end
function Nx.Map:RouteGathers()
	local points = {}
	local cnt = self:GetIconCnt ("!Ga")
	for n = 1, cnt do
		local wx, wy = self:GetIconPt ("!Ga", n)
		local x, y = self:GetZonePos (self.MapId, wx, wy)
		local pt = {}
		tinsert (points, pt)
		pt.X = x
		pt.Y = y
	end
	self:RouteMerge (points)
	local route = self:Route (points)
	if route then
		self:RouteToTargets (route, false)
	end
end
function Nx.Map:RouteTargets()
	local points = {}
	for n, tar in ipairs (self.Targets) do
		local wx = tar.TargetMX
		local wy = tar.TargetMY
		local x, y = self:GetZonePos (self.MapId, wx, wy)
		local pt = {}
		tinsert (points, pt)
		pt.Name = tar.TargetName
		pt.X = x
		pt.Y = y
	end
	local route = self:Route (points)
	if route then
		self:RouteToTargets (route)
	end
end
function Nx.Map:RouteQuests (points)
	local route = self:Route (points)
	if route then
		self:RouteToTargets (route, false)
	end
end
function Nx.Map:RouteMerge (points)
	local radius = self.GOpts["RouteMergeRadius"]
	if #points < 2 or radius < 1 then
		return
	end
	local tm = GetTime()
	sort (points, function (a, b) return a.X < b.X end)
	radius = radius / Nx.Map:GetWorldZoneScale (self.MapId) / 4.575
	local radiusSq = radius ^ 2	
	local startCnt = #points
	local merged = true
	while merged do
		merged = false
		local close = 999999999
		local closeI1
		local closeI2
		for n1, pt1 in ipairs (points) do
			for n2 = n1 + 1, #points do
				local pt2 = points[n2]
				if pt2.X - pt1.X > radius then
					break
				end
				local d = (pt1.X - pt2.X) ^ 2 + ((pt1.Y - pt2.Y) / 1.5) ^ 2
				if d < close then
					close = d
					closeI1 = n1
					closeI2 = n2
				end
			end
		end
		if close ^ .5 < radius then
			local pt1 = points[closeI1]
			local pt2 = points[closeI2]
			pt1.X = (pt1.X + pt2.X) * .5		
			pt1.Y = (pt1.Y + pt2.Y) * .5
			tremove (points, closeI2)
			merged = true
			sort (points, function (a, b) return a.X < b.X end)
		end
	end
	Nx.prt ("Merged %s in %.1f secs", startCnt - #points, GetTime() - tm)
end
function Nx.Map:Route (points)
	if #points == 0 then
		return
	end
	
	local tm = GetTime()
	
	local route = {}
	for n, pt in ipairs (points) do
		pt.Y = pt.Y / 1.5		
	end
	
	if #points > 1 then
		local x = points[1].X
		local y = points[1].Y
		if x == points[#points].X and y == points[#points].Y then	
			tremove (points)
		end
	end
	local x, y = self:GetZonePos (self.MapId, self.PlyrX, self.PlyrY)
	y = y / 1.5
	while #points > 0 do
		local closeDist = 999999999
		local closeI
		for n, pt in ipairs (points) do
			local dist = (x - pt.X) ^ 2 + (y - pt.Y) ^ 2
			if dist < closeDist then
				closeDist = dist
				closeI = n
			end
		end
		local pt = tremove (points, closeI)
		local r = {}
		tinsert (route, r)
		r.Name = pt.Name
		r.X = pt.X
		r.Y = pt.Y
		r.Weight = pt.Weight or 1
		x = pt.X
		y = pt.Y
	end
	
	local x = route[1].X
	local y = route[1].Y
	if x ~= route[#route].X or y ~= route[#route].Y then
		local r = {}
		r.X = x
		r.Y = y
		tinsert (route, r)
	end
	
	local len = self:RouteLen (route)
	
	for n = 1, 5 do
		local swap = self:RouteOptimize (route)
		if not swap then
			break
		end
	end
	
	local scale = self:GetWorldZoneScale (self.MapId)
	local len = self:RouteLen (route)
	Nx.prt ("Routed %s nodes, %d yards in %.1f secs", #route, len * scale * 4.575, GetTime() - tm)
	return route
end
function Nx.Map:RouteToTargets (route, targetIcon)
	Nx.Quest.Watch:ClearAutoTarget()
	local mapId = self.MapId
	for n, r in ipairs (route) do
		local wx, wy = self:GetWorldPos (mapId, r.X, r.Y * 1.5)
		local s = format (L"Route%s (%s) %s", n, #route - n + 1, r.Name or "")
		local tar = self:SetTarget ("Route", wx, wy, wx, wy, targetIcon, nil, s, n ~= 1)
		tar.Radius = self.GOpts["RouteGatherRadius"]
	end
end
function Nx.Map:RouteLen (route)
	local len = 0
	for n = 1, #route - 1 do
		local r1 = route[n]
		local r2 = route[n + 1]
		r1.Dist = ((r1.X - r2.X) ^ 2 + (r1.Y - r2.Y) ^ 2) ^ .5
		len = len + r1.Dist
	end
	return len
end
function Nx.Map:RouteOptimize (route)
	local swap
	for len = #route - 2, 2, -1 do
		for n = 1, #route - len - 1 do
			local r1 = route[n]
			local r2 = route[n + 1]
			local n2 = n + len
			local r3 = route[n2]
			local r4 = route[n2 + 1]
			if r1.Dist + r3.Dist >
				((r1.X - r3.X) ^ 2 + (r1.Y - r3.Y) ^ 2) ^ .5 + ((r2.X - r4.X) ^ 2 + (r2.Y - r4.Y) ^ 2) ^ .5 then
				self:RouteSwap (route, n + 1, len)
				swap = true
			end
		end
	end
	return swap
end
function Nx.Map:RouteSwap (route, first, len)
	
	
	local last = first + len - 1
	local stop = first + floor (len / 2) - 1
	local n2 = last
	for n = first, stop do
		route[n], route[n2] = route[n2], route[n]
		n2 = n2 - 1
	end
	for n = first - 1, last do
		local r1 = route[n]
		local r2 = route[n + 1]
		r1.Dist = ((r1.X - r2.X) ^ 2 + (r1.Y - r2.Y) ^ 2) ^ .5
	end
end
function Nx.Map:VehicleDumpPos()
	
	for n = 1, GetNumBattlefieldVehicles() do
		local x, y, unitName, possessed, typ, dir, player = GetBattlefieldVehicleInfo (n)
		if x and not player then
			local xo = self.PlyrRZX - x * 100
			local yo = (self.PlyrRZY - y * 100) / 1.5
			dir = dir / PI * -180
			xo, yo = xo * cos (dir) + yo * sin (dir), (xo * -sin (dir) + yo * cos (dir)) * 1.5
			Nx.prt ("#%s %s %f %f %.3f %s", n, unitName or L"nil", xo, yo, dir or -1, typ or L"no type")
		end
	end
end
function Nx.Map:OpenBlizzardWorldMap(but1)
   Nx:NXMapKeyTogOriginal()
end
function NxToggleWorldMap()
    Nx.Map:BlizzToggleWorldMap()
end
local function isWorldMapResizing()
    local stack = debugstack(0,0,1) 
    if stack:find(": in function <Interface\\FrameXML\\WorldMapFrame%.lua:") then return true end
    stack = debugstack()
    if stack:find(": in function `WorldMapFrame_ToggleWindowSize'")
        or stack:find(": in function `ToggleMapSize'") then 
            return true
    end
end
hooksecurefunc("ToggleFrame", function(fra)
    if(fra~=WorldMapFrame)then return end
    if(Nx.Map.BlizzToggling)then return end
    if(isWorldMapResizing()) then return end
    local opt=Nx:GetGlobalOpts()
    
    local should = (IsAltKeyDown() and opt["MapMaxOverride"]) or (not IsAltKeyDown() and not opt["MapMaxOverride"]);
    local instance, type = IsInInstance() instance = instance and type~="pvp"
    should = (instance and not IsAltKeyDown()) or (not instance and should)
    if(should)then 
        
        local map=Nx.Map:GetMap(1)
        if(WorldMapFrame:IsShown())then
            Nx.Map:GetMap(1):RestoreSize()
        end
    else
        local toshow = Nx._toshow
        if(fra:IsShown())then HideUIPanel(fra) end
        if not Nx.Map.Maps then return end
        local map=Nx.Map:GetMap(1)
        
        if toshow==2 then
            map.Win:Show()
            if(Nx.Map.GOpts["MapMaxCenter"])then map:MaxSize() end
        elseif toshow==1 then
            map:MaxSize()
        else
            map:RestoreSize()
        end
    end
end)
hooksecurefunc(WorldMapFrame, "GetAttribute", function(f, attr)
    
    
    if(attr~="UIPanelLayout-defined")then return end
    if(not Nx.Map.Maps)then return end
    if(Nx._toshowlast and GetTime()-Nx._toshowlast<0.005) then return end
    local map=Nx.Map:GetMap(1)
    if not map then return end
    if(isWorldMapResizing()) then return end
    
    local win = map.Win
    if not win:IsShown() then
        Nx._toshow = 2
    elseif not win:IsSizeMax() then
        Nx._toshow = 1
    else
        Nx._toshow = 0
    end
    Nx._toshowlast = GetTime()
    
end)
hooksecurefunc("SetMapToCurrentZone", function()
    if not Nx or not Nx.AIdToId then return end
    Nx.CurrAreaID = GetCurrentMapAreaID()
    Nx.CurrMapID = Nx.Map:GetCurrentMapId() 
    Nx.CurrIsMicroDungeon = select(4, GetMapInfo())
    Nx.CurrDungeonLevel = GetCurrentMapDungeonLevel()
    
end)
